Sun Jul 10 22:50:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (rmpd_power_by_big_decimal): fix
	  precision treatment errors.

	* test/bigdecimal/test_bigdecimal.rb: add tests for the above change.
	  fix precision treatment errors.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_power): precision argument
	  should be optional for its compatibility.

Sun Jul 10 22:38:09 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (var_ref): distinguish vcall from local variable
	  references.  based on a patch by Michael Edgar michael.j.edgar
	  AT dartmouth.edu.  Bug #5002

Sun Jul 10 21:51:29 2011  Koichi Sasada  <ko1@atdot.net>

	* internal.h: add comments (cautions).

Sun Jul 10 20:59:38 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb: Add new class variable `@@testfile_prefix`.
	  This is for changing test name prefix. (For testing)

	* test/testunit/tests_for_parallel/ptest_first.rb: Renamed from
	  test_first.rb

	* test/testunit/tests_for_parallel/ptest_second.rb: Renamed from
	  test_second.rb

	* test/testunit/tests_for_parallel/ptest_third.rb: Renamed from
	  test_third.rb

	* test/testunit/tests_for_parallel/ptest_forth.rb: Renamed from
	  test_forth.rb

	* test/testunit/tests_for_parallel/runner.rb: Remove misc.rb

	* test/testunit/tests_for_parallel/ptest_first.rb: ditto.

	* test/testunit/tests_for_parallel/ptest_second.rb: ditto.

	* test/testunit/tests_for_parallel/ptest_third.rb: ditto.

	* test/testunit/tests_for_parallel/ptest_forth.rb: ditto.

	* test/testunit/tests_for_parallel/misc.rb: Removed because no longer
	  needed.

	* test/testunit/test_parallel.rb: Fix assertions for above.

Sun Jul 10 16:57:08 2011  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_throw): check a class frame.
	  Fixes Bug #4648.
	  The patch is contributed by Kazuki Tsujimoto.

	* bootstraptest/test_proc.rb: add tests for above.

Sun Jul 10 17:28:01 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (mutex_debug): use exit(EXIT_FAILURE) instead of
	  exit(1).
	* thread_pthread.c (add_signal_thread_list): ditto.
	* thread.c (rb_thread_call_with_gvl): ditto.
	* util.c (Bug): ditto.

Sun Jul 10 15:58:12 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json: Merge json gem 1.5.4+ (f7f78896607b6f6226cd).
	  [Bug #4700]

Sun Jul 10 16:41:32 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm_core.h (typedef struct rb_vm_struct): create a new
	  'inhibit_thread_creation' field.
	* thread.c (rb_thread_terminate_all): set inhibit_thread_creation.
	* thread.c (thread_s_new): don't permit to create new thread
	  if the VM is under destruction. Otherwise evil finalizer code
	  can make SEGV. [Bug #4992][ruby-core:37858]

	* bootstraptest/test_objectspace.rb: new test for this fix.

Sun Jul 10 16:06:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c (sigsegv): use abort() instead of exit() when nested
	  SEGV was happen. Because unnested SEGV use abort().
	  [Bug #5013][ruby-dev:44078]

Sun Jul 10 15:30:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* load.c (rb_f_autoload): prevent to autoload for singleton
	  classes.  fixes [Bug #4886] [ruby-dev:43816]

	* bootstraptest/test_autoload.rb: add tests for the above change.

Sun Jul 10 15:09:17 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit/assertions.rb: Import documentation patch by Justin
	  Collins. [ruby-core:37225] [Feature #4903]

Sun Jul 10 14:57:36 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: canonicalizes nth and sf.

Sun Jul 10 14:13:50 2011  Koichi Sasada  <ko1@atdot.net>

	* internal.h (rb_thread_call_with_gvl, rb_thread_call_without_gvl):
	  make them visible as experimental C APIs.  fixes Feature #4328.

Sun Jul 10 12:18:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_power): support non-integral
	  exponent.  fixes [Bug #3271]

	* ext/bigdecimal/bigdecimal.c (rmpd_power_by_big_decimal): ditto.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_power_op): add a function to
	  only use for "**" operator.

	* test/bigdecimal/test_bigdecimal.rb: add a bunch of tests for the
	  above changes.

	* ext/bigdecimal/bigdecimal.c (is_integer): add an utility function.

	* ext/bigdecimal/bigdecimal.c (is_negative): ditto.

	* ext/bigdecimal/bigdecimal.c (is_positive): ditto.

	* ext/bigdecimal/bigdecimal.c (is_zero): ditto.

	* ext/bigdecimal/bigdecimal.c (is_one): ditto.

	* ext/bigdecimal/bigdecimal.c (is_even): ditto.

Sun Jul 10 12:08:39 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* compile.c (when_vals): when a string literal is written on when
	  clause, skip string creation to make it faster.  [ruby-dev:44068]
	  [Feature #5000]

Sun Jul 10 11:35:29 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* parse.y (reduce_nodes_gen): NODE_RETURN in rescue body must not be
	  reduced when there is an else clause.  This caused bizarre behavior
	  in [Bug #4473] [ruby-core:35629] [ruby-core:37884].

Sun Jul 10 09:46:14 2011  Masaya Tarui  <tarui@ruby-lnag.org>

	* range.c (range_max): fix behavior with excluded end value.
	  [Bug #4591]

Sun Jul 10 09:13:18 2011  Eric Hodel  <drbrain@segment7.net>

	* NEWS:  Fix RubyGems version.  [Ruby 1.9 - Bug #5004]

Sat Jul  9 20:01:59 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* internal.h: rb_rational_reciprocal is defined in rational.c.

Sat Jul  9 19:48:31 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* internal.h: added declarations.
	* complex.c: followed the above change.

Sat Jul  9 17:24:41 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* NEWS: bigdecimal is not a builtin.

Sat Jul  9 17:17:53 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: some improvements for performance.

Sat Jul  9 16:56:01 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* atomic.h (ATOMIC_OR): _InterlockedOr is unavailable in VC6.

	* numeric.c (ULLONG_MAX): fallback definition.

Sat Jul  9 15:59:19 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (rb_w32_{read,write}): should be signed.
	  Bug #5001

Sat Jul  9 14:02:20 2011  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/core.rb: fix multipart form parsing bug. [Bug #3866]

Sat Jul  9 11:41:03 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Add Vector#normalize [ruby-dev:43829]

Sat Jul  9 09:25:06 2011  Eric Hodel  <drbrain@segment7.net>

	* enumerator.c:  Remove "enumeration sequenced by".
	  [Ruby 1.9 - Bug #4757]

Sat Jul  9 09:14:56 2011  Eric Hodel  <drbrain@segment7.net>

	* io.c:  Note that methods other than IO#gets may increase IO#lineno.
	  [Ruby 1.9 - Bug #4902]

Sat Jul  9 08:39:39 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (RUN_OPT): disable gems.

Sat Jul  9 08:37:05 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_close): close(2) on a fd which is being read by
	  another thread causes deadlock on Mac OS X 10.5

Fri Jul  8 21:20:39 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* addr2line.c: use USE_ELF instead of __ELF__ because Solaris
	  doesn't define it. USE_ELF is already provided by configure.
	  patched by Naohisa Goto. [ruby-dev:44066] [Bug #4998]

	* addr2line.h: ditto.

	* vm_dump.c: ditto.

Fri Jul  8 16:40:38 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/json/parser/parser.rl (convert_encoding): should not modify
	  the argument.

	* ext/json/parser/parser.rl (convert_encoding): no needs to use
	  force_encoding.

Fri Jul  8 15:53:31 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (rb_bug): get rid of segfault after all threads
	  disposed.

Fri Jul  8 15:01:06 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/openssl/ossl.h: include openssl/e_os2.h before checking the
	  definition of OPENSSL_SYS_WIN32.

Fri Jul  8 14:40:39 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (wunlink): reverted a part of r32426. it was mistakenly
	  mixed.

Fri Jul  8 14:29:47 2011  Narihiro Nakamura  <authornari@gmail.com>

	* configure.in: can't subtract void *.

Fri Jul  8 14:33:26 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (config.h): define GC_MARK_STACKFRAME_WORD.
	  fixed build problem of r32438.  the value (30) is temporary value.
	  maybe it's enough by 20~24 according to my observation.

Fri Jul  8 13:47:39 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_mutex_unlock_all): folded into
	  rb_threadptr_unlock_all_locking_mutexes.
	* thread.c (rb_threadptr_unlock_all_locking_mutexes) ditto.

Fri Jul  8 13:36:02 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (thread_unlock_all_locking_mutexes): rename to
	  rb_threadptr_unlock_all_locking_mutexes and remove static.
	* vm_core.h: add rb_threadptr_unlock_all_locking_mutexes declaration.
	* thread.c (thread_start_func_2): adjust the above rename.

	* eval.c (ruby_cleanup): call rb_threadptr_unlock_all_locking_mutexes
	  again after finalizer. [Bug #4988] [ruby-dev:44049]

Fri Jul  8 13:06:09 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (FIBER_MACHINE_STACK_ALLOCATION_SIZE): Fiber stack size
	  don't need to keep multiple number of sizeof(VALUE).

Fri Jul  8 11:39:12 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (sudo-precheck): true command is not standard on
	  Windows.

Fri Jul  8 10:39:52 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (gvl_destroy): fix cond_t leak.

Fri Jul  8 09:17:59 2011  Eric Hodel  <drbrain@segment7.net>

	* gc.c:  Improve documentation

Thu Jul  7 23:35:31 2011  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c: change water_mark value that may call
	  gc_mark(lev <= GC_LEVEL_MAX) in gc_mark().
	  In ruby_stack_check(), water_mark is a value that may call some
	  C function. Fixes Bug #3781

	* configure.in: define GC_MARK_STACKFRAME_WORD that approximate
	  size of gc_mark() and gc_mark_children() stackframes.

Thu Jul  7 17:55:05 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/testunit/test_parallel.rb (TestParallelWorker#teardown): wait
	  the child process even if the communication pipe is broken.

Thu Jul  7 15:44:42 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (rb_enc_set_index, rb_enc_associate_index): should
	  check if frozen.

	* parse.y (rb_intern3), ruby.c (process_options, ruby_script):
	  defer freezing after associating encodings.

Thu Jul  7 15:16:51 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* numeric.c (rb_num2ull): use own switch sentence.
	  Current implementation can't convert 18446744073709551615.

Thu Jul  7 06:56:15 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* cont.c (FIBER_STACK_FLAGS): workaround fix for r32420 on FreeBSD.

Thu Jul  7 06:46:12 2011  Eric Hodel  <drbrain@segment7.net>

	* benchmark/driver.rb:  Add difference column to report that averages
	  across all runs of a benchmark.  [Ruby 1.9 - Feature #4982]

Thu Jul  7 06:19:38 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems.rb:  Reduce requires to improve `make benchmark`.
	  [#4962]
	* lib/rubygems/specification.rb:  Delay initialization of rubygems
	  until require is called.

Thu Jul  7 04:31:26 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (arg): rescue_mod is in inverse order from other
	  modifiers.  patched by michael.j.edgar AT dartmouth.edu at
	  [ruby-core:36248].  fixed #4716.

Thu Jul  7 00:40:16 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (kill): check that the process exited or not before
	  terminating it. [Bug #4943]

Wed Jul  6 23:13:19 2011  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (opt_call_args): allow trailing comma after assoc
	  argument e.g. 'foo(bar:1,)'.  fixed #3456

Wed Jul  6 22:11:12 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/cgi/test_cgi_header.rb(test_cgi_header_nph): Validate date in
	  "Date:" header

Wed Jul  6 21:29:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): cleanup pointer arithmetic.
	  "size/sizeof(VALUE)" is ugly and easy confusing.
	* cont.c (fiber_initialize_machine_stack_context): ditto.

Wed Jul  6 21:24:53 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): fix mprotect misuse. A stack
	  guard page should have PROT_NONE.
	* cont.c (fiber_initialize_machine_stack_context):
	  th->machine_stack_maxsize shouldn't be included guard pages size.
	  [Bug #4983][ruby-dev:44043]

Wed Jul  6 21:23:38 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): use MAP_STACK if it's provided.

Wed Jul  6 21:22:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): use MAP_FAILED instead of -1.

Wed Jul  6 21:21:05 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): remove unnecessary cast.

Wed Jul  6 18:10:13 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/cgi/test_cgi_header.rb(test_cgi_header_nph): Adding space after
	  comma.

	* test/cgi/test_cgi_header.rb(test_cgi_header_nph): Remove variable
	  `now`. Suppress warning.

Wed Jul  6 12:18:09 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/cgi/test_cgi_header.rb(test_cgi_header_nph): Fix bug depends to
	  time. The test fails if time past 1 second in line 136-145

Tue Jul  5 15:28:04 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): should dispatch heredoc_end
	  scanner event on an empty here document.  fixed Bug#4543.

Tue Jul  5 13:49:26 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* addr2line.c: fix r32407 to check HAVE_ALLOCA_H.

Tue Jul  5 14:05:43 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/webrick/httpauth/digestauth.rb (_authenticate):
	  Literal texts in HTTP ABNF is case-insensitive (RFC2616 2.1),
	  and a sample implementation in RFC2617 also ignores the case
	  of algorithms. So now this ignores those cases.
	  [ruby-dev:43965] [Feature #4936]

	* lib/webrick/httpauth/digestauth.rb (initialize):
	  Because of above, opera_hack is useless and removed.

Tue Jul  5 01:30:01 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread_pthread.c (native_sleep): cut the waiting time up to
	  100,000,000 because Solaris cond_timedwait() return EINVAL if an
	  argument is greater than current_time + 100,000,000.  This is
	  considered as a kind of spurious wakeup.  The caller to native_sleep
	  should care about spurious wakeup.

Tue Jul  5 01:24:26 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* cont.c: disable FIBER_USE_NATIVE on Solaris because resuming any
	  Fiber caused SEGV.  I haven't follow up the issue deeply, but it
	  works when disabling the feature.

Tue Jul  5 01:22:46 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* addr2line.c: include <alloca.h> to fix a build issue on Solaris.

Tue Jul  5 00:49:05 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* ext/coverage/coverage.c: resurrect r32071 + add GC guard for
	  rb_coverages. [ruby-core:37352] [Bug #4927]
	  [ruby-core:36539] [Feature #4796]

	* test/coverage/test_coverage.rb resurrect r32071.

Mon Jul  4 22:24:46 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (get_stack): For NetBSD/FreeBSD, use
	  pthread_attr_getstack() if possible. and, remove an assumption
	  of stack growing direction.

Mon Jul  4 20:42:31 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* ext/coverage/coverage.c: revert r32071.  The commit caused SEGV on
	  some minor nonfree OS.  I have no means of debugging the bug.  My
	  personal opinion is that such OS should be unsupported unless there
	  is an active maintainer.  [ruby-core:37352]

	* test/coverage/test_coverage.rb: ditto.

Mon Jul  4 07:14:12 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread_pthread.c (get_stack): the return address of get_stack
	  must be the highest address of the current thread's stack.

Mon Jul  4 06:37:22 2011  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/intern.h, thread_pthread.c (rb_reserved_fd_p,
	  RB_RESERVED_FD_P): added.  This C API is to limit to access
	  fds which are used by RubyVM internal.  In this version of
	  CRuby, return 1 if fd is communication pipe.
	  If your application needs to close all file descriptors to
	  present resource leak, skip internal fds using this C API.
	  We also define a macro RB_RESERVED_FD_P(fd).  So you can write
	    #ifndef RB_RESERVED_FD_P
	    #define RB_RESERVED_FD_P(fd) 0
	    #endif
	  for Ruby 1.9.2 or previous version to write compatible extensions.
	  See [ruby-core:37727]

	* thread_win32.c (rb_reserved_fd_p): added (return 0 for any fds).

	* io.c (rb_io_initialize): raise ArgumentError if given fd is reserved by Ruby.

Sun Jul  3 23:43:56 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/extmk.rb (extmake): suppresses outputs from extconf.rb.
	  (extmake) warns a failure in extconf.rb.

Sun Jul  3 13:44:51 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (ary_reject_bang): should not remove elements which are
	  not yielded.  [Bug #2545]

Sun Jul  3 06:10:26 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (get_stack): pthread_attr_getstack() doesn't
	  return stack start address, but stack base address. Thus,
	  we need to add stack size for getting stack start address.
	  And, we don't have to decrease guard size twice.
	* thread_pthread.c (thread_start_func_1): don't use inaccurate
	  stack start guess if native_thread_init_stack() can be used.
	  [Bug #1813] [ruby-core:24540]

Sun Jul  3 04:50:08 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (get_stack): add to a care of guard page on Mac
	  OS X. [Bug #1813] [ruby-core:24540]
	* signal.c (ruby_signal): SIGBUS use alternative stack too.
	* signal.c (sigbus): On Mac, thread stack overflow makes SIGBUS
	  instead of SIGSEGV. thus, added stackoverflow check.
	* signal.c (default_handler): get rid of compilation warning.
	* signal.c (Init_signal): ditto.

Sat Jul 02 08:59:20 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_ocsp.rb
	* test/openssl/test_x509_cert.rb: Perform SHA-256 tests only if
	  supported by the available OpenSSL version. Versions < 0.9.8 don't
	  support it. [ruby-core:37724]

Sat Jul  2 07:17:45 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_reject_bang, rb_ary_delete_if): rejected
	  elements should be removed.  fixed [Bug #2545]

Sat Jul  2 01:57:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* NEWS: remove a description of Kernel#respond_to? because it has
	  been reverted at revision 28564.

Sat Jul  2 00:58:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* NEWS: describe a change of multiplication of Bignum.

Fri Jul  1 18:52:31 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/bm_app_erb.rb: increase loop count. too short
	  measurement time makes less accuracy.
	* benchmark/bm_app_factorial.rb: ditto.
	* benchmark/bm_app_mandelbrot.rb: ditto.
	* benchmark/bm_app_strconcat.rb: ditto.

	* benchmark/bm_io_file_create.rb: ditto.
	* benchmark/bm_io_file_read.rb: ditto.
	* benchmark/bm_io_file_write.rb: ditto.

	* benchmark/bm_so_concatenate.rb: ditto.
	* benchmark/bm_so_lists.rb: ditto.
	* benchmark/bm_so_matrix.rb: ditto.
	* benchmark/bm_so_random.rb: ditto.
	* benchmark/bm_so_sieve.rb: ditto.

	* benchmark/bm_vm_thread_mutex1.rb: ditto.
	* benchmark/bm_vm_thread_mutex2.rb: ditto.
	* benchmark/bm_vm_thread_mutex3.rb: ditto.

	* benchmark/bm_vm1_block.rb: cleanup.
	* benchmark/bm_vm1_const.rb: cleanup.
	* benchmark/bm_vm1_ensure.rb: cleanup.
	* benchmark/bm_vm1_ivar.rb: cleanup.
	* benchmark/bm_vm1_length.rb: cleanup.
	* benchmark/bm_vm1_neq.rb: cleanup.
	* benchmark/bm_vm1_not.rb: cleanup.
	* benchmark/bm_vm1_rescue.rb: cleanup.
	* benchmark/bm_vm1_simplereturn.rb: cleanup.
	* benchmark/bm_vm1_swap.rb: cleanup.

	* benchmark/bm_vm2_array.rb: cleanup.
	* benchmark/bm_vm2_case.rb: cleanup.
	* benchmark/bm_vm2_defined_method.rb: cleanup.
	* benchmark/bm_vm2_eval.rb: cleanup.
	* benchmark/bm_vm2_method.rb: cleanup.
	* benchmark/bm_vm2_mutex.rb: cleanup.
	* benchmark/bm_vm2_poly_method.rb: cleanup.
	* benchmark/bm_vm2_poly_method_ov.rb: cleanup.
	* benchmark/bm_vm2_proc.rb: cleanup.
	* benchmark/bm_vm2_regexp.rb: cleanup.
	* benchmark/bm_vm2_send.rb: cleanup.
	* benchmark/bm_vm2_super.rb: cleanup.
	* benchmark/bm_vm2_unif1.rb: cleanup.
	* benchmark/bm_vm2_zsuper.rb: cleanup.

	* benchmark/bm_vm_thread_alive_check1.rb: cleanup.

Fri Jul  1 15:23:00 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix: Add LUP decomposition

Fri Jul  1 15:21:14 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Allow non integer exponents for Matrix#**

Fri Jul  1 15:13:25 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix: Add Eigenvalue Decomposition

Fri Jul  1 15:10:22 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix: Add Matrix#round

Fri Jul  1 11:41:12 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (tr_trans): free heap ptr when the str is not embedded.
	  patched by Eric Wong. [Bug #4956] [ruby-core:37708]

Fri Jul  1 11:07:43 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (do_select): fix memory leak.
	  Patch by Eric Wong. Thank you! [Bug #4953] [ruby-core:37702]

Fri Jul  1 08:21:28 2011  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_getivar): check vm state version
	  to invalidate inline cache (ivar index).
	  fixes Bug #4926.

	* vm_insnhelper.c (vm_setivar): ditto.

Fri Jul  1 08:03:15 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c, thread_pthread.c (WRITE_CONST): suppress warnings
	  `ignoring return value'.

Fri Jul  1 06:41:36 2011  Koichi Sasada  <ko1@atdot.net>

	* thread.c (rb_threadptr_check_signal): only wake up main thread.

	* thread.c (rb_threadptr_execute_interrupts_common): check signal
	  delivery if it is main thread.
	  fixes [ruby-dev:44005] [Ruby 1.9 - Bug #4950]

	* bootstraptest/test_fork.rb: add a test for above.

	* signal.c (rb_get_next_signal): skip if signal_buff is empty.
	  (check signal_buff.size first)

	* vm_core.h: remove unused variable rb_thread_t::exec_signal.

	* thread.c (rb_thread_check_trap_pending): check
	  rb_signal_buff_size() because rb_thread_t::exec_signal
	  is no longer available.

Fri Jul  1 03:28:25 2011  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (Init_class_hierarchy): should name BasicObject
	  explicitly.

	* variable.c (rb_const_defined_0): should not check for
	  superclasses as const_get.

Fri Jul  1 03:24:03 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: mathn is still alive (should die soon).

Thu Jun 30 23:50:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* misc/ruby-mode.el (ruby-indent-beg-re): Fix broken regular
	  expression.  Fixes #4546

Thu Jun 30 23:43:30 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl.c/.h: Added ossl_x509_name_sk2ary.
	* ext/openssl/ossl.c: Replaced ossl_x509_ary2k by generic macro to
	  simplify future conversions.
	* ext/openssl/ossl_ssl.c: Implement SSLSocket#client_ca.
	* test/openssl/test_ssl.rb: Add test for SSLSocket#client_ca.
	  Thanks to Ippei Obayashi for providing the patch!
	  [ Ruby 1.9 - Feature #4481 ] [ruby-core:35461]

Thu Jun 30 22:38:58 2011  Koichi Sasada  <ko1@atdot.net>

	* benchmark/bm_vm2_defined_method.rb: added to measure performance of
	  bmethod (method defined by define_method()).

Thu Jun 30 22:17:04 2011  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_call_bmethod): fix to hook call/return event
	  for methods defined by define_method().  fixes Bug #4613.

	* thread.c (call_trace_proc): Fix to skip if class is not given (0).
	  Note that ID and Class object are passed for call/return event
	  if the called method was defined by define_method().
	  If you are author of tracer/profiler/debugger, this may be an
	  important change.  You should check passed class as zero or
	  non-zero instead of checking the event type.

	* test/ruby/test_settracefunc.rb: add a test for above.

Thu Jun 30 21:18:35 2011  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* configure.in: Add warnflags for XL/C on AIX during configure
	  to avoid [Bug #3971]. See [ruby-core:32859]

Thu Jun 30 21:16:04 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (m_ajd): refers a constant.

Thu Jun 30 20:54:25 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	  * ext/io/console/io-console.gemspec: spin-off gem for 1.9.2.

Thu Jun 30 20:36:23 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: trivial changes.

Thu Jun 30 20:12:36 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_module.rb: tests for [Bug #3422] and [Bug #3423].

Thu Jun 30 20:03:39 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: modified doc.

Thu Jun 30 19:09:19 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (thread_timer): ignore unknown errno.
	  (we observed that select(2) was canceled by errno=514 on
	  boron == Linux/Xen environment)

Thu Jun 30 17:33:25 2011  Koichi Sasada  <ko1@atdot.net>

	* ext/objspace/objspace.c (ObjectSpace.count_tdata_objects):
	  Fix rdoc.  Fixes Bug #3892.

	* ext/objspace/objspace.c (ObjectSpace.count_tdata_objects):
	  Change key type if the klass of a object is zero (internal object).
	  Read rdoc for details.

	* internal.h: export rb_objspace_data_type_name().

Thu Jun 30 17:25:08 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (ping_signal_thread_list, thread_timer):
	  fix to keep polling state if there are any ping-tasks.

Thu Jun 30 12:25:34 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (rb_thread_create_timer_thread): allocate
	  machine stack for the timer thread at least 12KB.  FreeBSD 8.2
	  AMD64 causes machine stack overflow (SIGSEGV) only with
	  PTHREAD_STACK_MIN (maybe defined as 2KB).

Thu Jun 30 09:36:37 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/weakref.rb:  Attach documentation to WeakRef and add missing
	  documentation

Thu Jun 30 09:30:14 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/yaml.rb:  Document toplevel YAML and YAML::ENGINE to describe
	  Psych vs Syck engines.

Thu Jun 30 09:21:52 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/cmath.rb:  Hide handle_no_method_error from RDoc.
	* error.c:  Document or hide undocumented error classes.

Thu Jun 30 07:49:04 2011  Eric Hodel  <drbrain@segment7.net>

	* hash.c:  Document ENV

Thu Jun 30 06:37:43 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (ruby_init_loadpath_safe): ensure RUBYLIB_PREFIX stored
	  before RUBYLIB, even if MANGLED_PATH is enabled.  fixed #1679.
	  MANGLED_PATH is disabled by the default and will be removed
	  completely in the future.

Thu Jun 30 06:32:21 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/drb/drb.rb:  Hide deprecated toplevel DRb constants.

Thu Jun 30 06:17:02 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/cmath.rb (CMath.log): second argument: b can be nil.

Thu Jun 30 06:23:28 2011  Eric Hodel  <drbrain@segment7.net>

	* thread.c (ruby_thread_s_pass):  Fix typo.

Thu Jun 30 06:16:53 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc:  Update to RDoc 3.8 which contains fixes for documentation
	  in trunk.

Thu Jun 30 02:53:26 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_threadptr_execute_interrupts_common): remove
	  meaningless native_thread_yield(). It never close a race.

Thu Jun 30 02:41:47 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_schedule_limits): minor optimization.
	  eliminate machine context saving when running time is enough small.

Thu Jun 30 02:28:11 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_schedule_rec): move interrupt_flag check to
	  rb_thread_schedule().
	  And also rename to rb_thread_schedule_limits() and remove
	  sched_depth argument. It's no longer called recursive.
	* thread.c (rb_thread_schedule): add to check interrupt_flag as
	  above explained.

	* thread.c (rb_threadptr_execute_interrupts_rec): rename to
	  rb_threadptr_execute_interrupts_common() and remove sched_depth
	  argument. It's no longer called recursive.

	* thread.c (rb_thread_sleep): adapt the renaming.
	* thread.c (rb_threadptr_execute_interrupts): ditto.
	* thread.c (rb_thread_execute_interrupts): ditto.

Thu Jun 30 01:31:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (thread_s_pass): change RDoc description and remove
	  a sample code. The actual implementation never behave as explained by
	  an example. It's a documentation bug.

Thu Jun 30 00:54:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_stop): change RDoc sample code. The old
	  example is buggy and may cause deadlock. The patch is
	  suggested by Heesob Park <phasis@gmail.com>. Thank you!
	  [Bug #3606][ruby-core:31454]

Thu Jun 30 00:49:53 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_wakeup): change RDoc sample code. The old
	  example is buggy and may not display anything by a race.
	  The patch is suggested by Heesob Park <phasis@gmail.com>.
	  Thank you! [Bug #3606][ruby-core:31454]

Thu Jun 30 00:43:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_run): change RDoc. The old example is buggy
	  and may cause deadlock. The patch is suggested by Heesob Park
	  <phasis@gmail.com>. Thank you! [Bug #3606][ruby-core:31454]

Thu Jun 30 00:30:15 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/cmath.rb: make same exception for Math. fix [Bug #3137].

Thu Jun 30 00:03:20 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/completion.rb: complement correctly string literal. fix
	  [Bug #1145].

Wed Jun 29 23:42:51 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: avoided using timev.
	* ext/date/date_strftime.c: ditto.
	* ext/date/date_tmx.h: ditto.

Wed Jun 29 23:17:57 2011  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/openssl/ossl.h (OPENSSL_SYS_WIN32): support for mingw(msys).

Wed Jun 29 23:09:14 2011  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/tk/extconf.rb (intptr_t, uintptr_t): support for the latest ActiveTcl with mingw.

Wed Jun 29 22:49:10 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/cmd/help.rb: support RDoc 3.7. fix [Bug #3760].

Wed Jun 29 22:04:14 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* lib/tracer.rb: Tracer.on only if required by -r command-line option.
	  and consider --disable-gems option.
	* test/test_tracer.rb: add tests for it.

Wed Jun 29 13:55:36 2011  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_const_get_0): should not look for superclasses if
	  the second optional argument is given for #const_get().
	  fix [Bug #3422] [Bug #3423]

Wed Jun 29 12:07:27 2011  Eric Hodel  <drbrain@segment7.net>

	* math.c:  Attach documentation for Math.
	* object.c:  Document NIL, TRUE, FALSE.
	* io.c:  Improve grammar in ARGF comment.  Document STDIN/OUT/ERR.
	  Document ARGF global constant.
	* lib/rake:  Hide deprecated toplevel constants from RDoc (import from
	  rake trunk).
	* lib/thwait.rb:  Document ThWait.
	* lib/mathn.rb:  Hide Math redefinition from RDoc
	* lib/sync.rb:  Add a basic comment for Sync_m, Synchronizer_m, Sync,
	  Synchronizer.
	* parse.y:  Document SCRIPT_LINES__.
	* hash.c:  Document ENV class and global constant.
	* vm.c:  Document TOPLEVEL_BINDING.
	* version.c:  Document RUBY_* constants.
	* ruby.c:  Document DATA and ARGV.

Wed Jun 29 10:13:12 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Matrix.zero can build rectangular matrices.
	  Vector#r should be called #magnitude

Wed Jun 29 10:11:08 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Add Matrix#diagonal?, hermitian?, normal?,
	  orthogonal?
	  permutation?, symmetric?, {lower|upper}triangular?, unitary?, zero?

Wed Jun 29 10:09:35 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Specialize Matrix#find_index to return [row, col]
	  and accept the same optional argument as #each

Wed Jun 29 10:07:32 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Matrix#each{_with_index} can iterate over a subset
	  of the Matrix

Wed Jun 29 06:21:02 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (native_stop_timer_thread): skip to close
	  communication pipe to avoid timing bug (process termination timing).
	  The communication pipe will closed by OS.

Wed Jun 29 06:09:54 2011  Koichi Sasada  <ko1@atdot.net>

	* error.c (rb_async_bug_errno): async-safe bug report function.
	  In timer thread, signal handler should use it.
	  The patch is contributed by Eric Wong <normalperson@yhbt.net>.
	  Refs: [ruby-core:37644] and [ruby-core:37647]

	* thread_pthread.c: use rb_async_bug_errno().
	  And replace all fprintf() to write().

	* internal.h (rb_async_bug_errno): add decl. of above func.

Tue Jun 28 23:46:08 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/tracer.rb: count only non-internal libraries in stack trace,
	  ignoring custom_require.

Tue Jun 28 21:44:58 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/ruby-lex.rb: recognize '\char' in ruby statement.

Tue Jun 28 20:39:29 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* lib/debug.rb (var_list): Command 'var *' did not work on 1.9(!).
	  global_variables, local_variables, and instance_variables returns
	  Symbols from 1.9 and need to stringify before evaling it.
	  See #4931.

Tue Jun 28 19:23:01 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c: Now, USE_TRAP_SIGMASK depend on HAVE_PTHREAD_SIGMASK.
	  The code have already depended on pthread_sigmask since r27464.

Tue Jun 28 15:09:21 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/benchmark.rb: merge eregon/benchmark.
	  https://github.com/eregon/ruby/tree/benchmark
	  patched by Benoit Daloze. [ruby-core:37593] [Bug #4940]

	* lib/benchmark (Benchmark#bmbm): bmbm should be consistent with bm
	  for the return value.

	* test/benchmark: remove preemptive test instead of skipping
	  I removed the preemptive test I wrote for Feature #4197.
	  I'll add it back when the implementation will be able to satisfy it.

	* lib/benchmark (Benchmark#bmbm): remove useless explicit call,
	  #format is an alias of #to_s test/benchmark: add a test for
	  format of long time.

	* lib/benchmark: fix label width: always add 1 to ensure there is a
	  space delimiter even with times over 100s
	  When I asked for Feature #4197, I wanted to make delimiting spaces
	  consistent for #bm and #bmbm.
	  But with times over 100s, the output contains no space between the
	  label and the first time (user).
	  Now both ensure there is always a space, even if that means 3 spaces
	  with times under 10s (because it is formatted as %10.6f)

	* test/benchmark: let labels be a constant
	  lib/benchmark (Benchmark#realtime): avoid creating an unused Proc
	  lib/benchmark (Benchmark#benchmark): use ensure clause to restore
	  STDOUT.sync, as in #bmbm

Tue Jun 28 13:41:51 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* thread_win32.c (native_stop_timer_thread): fixed commit miss of
	  r32244.  grep sources before changing the signature of a function.

Tue Jun 28 11:49:14 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (consume_communication_pipe):
	  Make "buff" as static.  (Maybe) "buff" can be shared between
	  any caller (any threads) because no one use the read values.
	  "buff" (1024 byte) on stack may cause stack overflow on
	  several environment (we found a crash on FreeBSD).
	  And remove const value "buff_size", and define CCP_READ_BUFF_SIZE
	  macro.

Tue Jun 28 11:45:30 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rake:  Update rake to fix some bugs and hide deprecated features
	  from RDoc.
	* lib/rake/version.rb:  Bump version to 0.9.2.1 to distinguish it from
	  the released version.
	* NEWS:  ditto

Tue Jun 28 11:17:28 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc:  Update to RDoc 3.7 (final)
	* NEWS:  ditto

Tue Jun 28 10:18:42 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* process.c (rb_daemon): fix wrong #endif position.

Tue Jun 28 07:50:32 2011  Eric Hodel  <drbrain@segment7.net>

	* object.c (Init_Object):  Teach RDoc what Init_class_hierarchy does to
	  hook up ri for BasicObject, Object, Module and Class.

Tue Jun 28 05:03:32 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* thread.c (rb_thread_local_aref): RDoc fix. Thread#[] example
	  had a race. See #4480.

Tue Jun 28 01:22:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigMath_s_log): move BigMath.log from
	  bigdecimal/math.rb.

	* ext/bigdecimal/lib/bigdecimal/math.rb: ditto.

	* test/bigdecimal/test_bigdecimal.rb: move test for BigMath.log from
	  test/bigdecimal/test_bigmath.rb.

	* test/bigdecimal/test_bigmath.rb: ditto.

Tue Jun 28 01:19:52 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/ruby-lex.rb: fix [Bug #4232].

Tue Jun 28 00:14:13 2011  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb: fix [Bug #4409]. add DRbServer#here?.

	* test/drb/test_drb.rb: ditto.

	* test/drb/drbtest.rb: ditto.

	* test/drb/ut_eq.rb: ditto.

Tue Jun 28 00:08:43 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/workspace.rb: fix BUG#4793.

Mon Jun 27 22:06:12 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (consume_communication_pipe): don't use C99
	  style variable length array.

Mon Jun 27 22:04:27 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (consume_communication_pipe): change return
	  type to void. caller doesn't use it.

Mon Jun 27 21:29:50 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.h (rb_global_vm_lock_struct): add volatile to
	  gvl->waiting. now thread_timer() access it w/o lock.

Mon Jun 27 21:16:11 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c: s/__gvl_acquire/gvl_acquire_common/ and
	  s/__gvl_release/gvl_release_common/.

Mon Jun 27 11:41:47 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread_pthread.c (rb_thread_create_timer_thread):
	  the type of return value of write(2) is ssize_t.

Mon Jun 27 09:57:02 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (rb_thread_create_timer_thread):
	  Fixes missing initialization of oflags.

Mon Jun 27 09:07:42 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c: Stop polling in the timer thread when there are
	  no waiting thread.  If there are 2 or more runnable threads,
	  the timer thread does polling.  Avoid polling makes power save
	  for several computers (0.2W per a Ruby process, when I measured).
	  If outside-event such as signal or Thread#kill was occurred
	  when the timer thread does not do polling, then wake-up
	  the timer thread using communication-pipe (the timer thread
	  waits this communication-pipe with select(2)).
	  The discussion about this modification can be found from the post
	  [ruby-core:33456] and other related posts.
	  Note that Eric Wong and KOSAKI Motohiro give us the huge
	  contributions for this modification.  Thanks.

	* thread_pthread.c (rb_thread_wakeup_timer_thread): add a function.
	  This function wakes up the timer thread using communication-pipe.

	* thread.c (rb_thread_stop_timer_thread): add a parameter which
	  specify closing communication-pipe or not.

	* thread.c (rb_thread_terminate_all): do not stop timer thread here
	  (ruby_cleanup() terminate timer thread).

	* signal.c: wake up timer thread using
	  rb_thread_wakeup_timer_thread() from signal handler.

	* eval.c (ruby_cleanup): use rb_thread_stop_timer_thread(1).

	* process.c: use rb_thread_stop_timer_thread(0)
	  (reuse communication-pipe).

	* thread_win32.c (rb_thread_wakeup_timer_thread): add a dummy
	  function.

	* vm_core.h: add and fix decl. of functions.

Mon Jun 27 08:01:19 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_parse.c: should use ALLOCA_N.

Mon Jun 27 01:34:18 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/etc/test_etc.rb (TestEtc#test_get{pw,gr}nam): skip entries
	  start with + sign, which means NIS.  these are returned in the
	  case that passwd and group entries in /etc/nsswitch.conf are set
	  to use "nis" explicitly on Debian.  fixed #3683

Mon Jun 27 00:44:53 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* parse.y (rb_parser_end_seen_p): fix documentation about return
	  value. patched by Sho Hashimoto. [Bug #4511]

Mon Jun 27 00:40:47 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* hash.c (rb_hash_reject): add documentation that Hash#reject
	  without block returns enumerator.
	  patched by Michael Edgar [Bug #4847] [ruby-core:36800]

Sun Jun 26 23:49:21 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/test_switch_hitter.rb: added a test.

 Sun Jun 26 22:21:23 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: refactoring.

Sun Jun 26 18:03:30 2011  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* parse.y: comma at the end of line is no longer allowed.
	  A patch from Yukihiro Matsumoto  <matz AT ruby-lang.org>.
	  (fixed #3456).

Sun Jun 26 13:35:35 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm_dump.c (rb_vm_bugreport): change CrashReporter suggestion messages
	  on Mac. It should be placed after "-- C level backtrace" line.
	  Suggested by Endoh-san.

	  <before>
	  -- See Crash Report log file under ~/Library/Logs/CrashReporter or ---------
	  -- /Library/Logs/CrashReporter, for the more detail of ---------------------
	  -- C level backtrace information -------------------------------------------

	<after>
	  -- C level backtrace information -------------------------------------------

	     See Crash Report log file under ~/Library/Logs/CrashReporter or
	     /Library/Logs/CrashReporter, for the more detail of.

Sun Jun 26 10:08:28 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/extconf.rb
	* ext/openssl/ossl_missing.h/.c: add ASN1_put_eoc if missing.

	* ext/openssl/ossl_asn1.c: introduce ossl_asn1_object_size and
	  ossl_asn1_put_object to wrap functionality depending on OpenSSL
	  version in use.
	  Fixes	[ Ruby 1.9 - Bug #4916 ] reported by Hiroshi Nakamura.
	  [ruby-core:37286]

Sun Jun 26 01:00:15 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (date_strftime_internal): removed meaningless braces.
	* ext/date/date_core.c (gengo): the value should be int.

Sat Jun 25 23:45:30 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* vm_insnhelper.c (vm_search_superclass): avoid control frame
	  stack overrun. currently super() in Proc created in a method
	  defined by Module#define_method raise NoMethodError. [Bug #4881]
	* test/ruby/test_method.rb t_super_in_proc_from_define_method):
	  add test for it.

Sat Jun 25 23:23:14 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* thread.c (sleep_forever): now Kernel#sleep don't wakeup by
	  signal handler execution. [Bug #4072]

Sat Jun 25 23:14:47 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* thread.c (rb_threadptr_check_signal): remove unnecessary th->status
	  backup. fix race condition which may results unexpected main thread's
	  status transition. see #4072

Fri Jun 24 19:57:30 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* lib/webrick/httprequest.rb (setup_forwarded_info): Parsing request
	  header failed when the request is from 2 or more Apache reverse
	  proxies. It's said that all X-Forwarded-* headers will contain more
	  than one (comma-separated) value if the original request already
	  contained one of these headers.  Since we could use these values as
	  Host header, we choose the initial(first) value. See #4922.

	* test/webrick/test_httprequest.rb (test_forwarded): Test it.

Fri Jun 24 17:06:33 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (proc_daemon): should not start timer thread
	  twice.  fixed Bug#4920.

Fri Jun 24 15:54:14 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/ossl_ssl.c (ossl_ssl_shutdown): Try to shutdown SSL
	  connection more gracefully. Call SSL_shutdown() max 4 times until it
	  returns 1 (success). Bi-directional SSL close has several states but
	  SSL_shutdown() kicks only 1 transition per call. Max 4 is from
	  mod_ssl.c of Apache httpd that says 'max 2x pending + 2x data = 4'.
	  See #4237.

Fri Jun 24 07:24:37 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rake/version.rb:  Fixed VERSION to work with tool/rbinstall.rb
	* bin/rake:  Import bin/rake from 0.9.2
	* tool/rbinstall.rb (install):  Rake::VERSION is now in
	  lib/rake/version.rb.  Fixes `make install`

Fri Jun 24 07:11:37 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rake: Import Rake 0.9.2

Fri Jun 24 00:44:15 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (c_valid_{julian,gregorian}_p): fixed the range of month.

Fri Jun 24 00:14:23 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: trivial changes on text.

Thu Jun 23 22:46:57 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/ossl_x509name.c: Add X509::Name#hash_old as a wrapper
	  for X509_NAME_hash_old in OpenSSL 1.0.0. See #4805

	* test/openssl/test_x509name.rb (test_hash): Make test pass with
	  OpenSSL 1.0.0.

	* NEWS: Add it.

Thu Jun 23 19:30:53 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/ossl_ssl_session.c (ossl_ssl_session_set_time): Check
	  argument type with NUM2LONG if the arg is not a Time object.
	  See #4919.

	* ext/openssl/ossl_ssl_session.c (ossl_ssl_session_set_timeout): Check
	  type with NUM2LONG. Time as an arg is not allowed. See #4919.

	* test/openssl/test_ssl_session.rb (test_session_time,
	  test_session_timeout): Test it.

Wed Jun 23 13:30:30 2011  Shota Fukumori  <sorah@tubusu.net>

	* signal.c(ruby_atomic_exchange): Fix definition style.

Wed Jun 22 22:34:05 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/ossl_ssl.c (ossl_sslctx_session_new_cb): Return 0 to
	  OpenSSL from the callback for SSL_CTX_sess_set_get_cb().
	  Returning 0 means to OpenSSL that the session is still valid
	  (since we created Ruby Session object) and was not freed by us with
	  SSL_SESSION_free(). Call SSLContext#remove_session(sess) in
	  session_get_cb block if you don't want OpenSSL to cache the session
	  internally.
	  This potential issue was pointed by Ippei Obayashi. See #4416.

	* test/openssl/test_ssl_session.rb (test_ctx_server_session_cb): Test
	  it.

Wed Jun 22 22:21:17 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_ssl_session.c: Respect T_BIGNUM time values. Patch by
	  Tomoyuki Chikanaga.
	  [ Ruby 1.9 - Bug #4919 ] [ruby-dev:43869]

Wed Jun 22 21:29:25 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/socket/depend (SOCK_HEADERS): use $(top_srcdir) instead of
	  $(topdir). sorry!

Wed Jun 22 19:47:03 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* cont.c (cont_capture): add volatile.
	  On clang -O, it is needed to avoid the optimization.
	  With this and llvm/clang's recent fix, clang 3.0 can
	  build ruby-trunk with -O option.

	* cont.c (cont_capture): use for-loop.

	* array.c (rb_ary_each): add volatile and use it.

	* vm_insnhelper.c (vm_call_cfunc): ditto.

Wed Jun 22 18:20:46 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/ossl_ssl.c (ossl_sslctx_session_remove_cb):
	  OpenSSL::SSL::SSLContext#session_remove_cb was broken. It wrongly
	  tried to call the session_*new*_cb callback.

	* test/openssl/test_ssl_session.rb (class OpenSSL): Test it.

Wed Jun 22 17:37:49 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl.h: Introduced OSSL_BIO_reset macro for PEM/DER
	  fallback scenarios.

	* ext/openssl/ossl_pkey_dsa.c
	* ext/openssl/ossl_x509req.c
	* ext/openssl/ossl_pkey_rsa.c
	* ext/openssl/ossl_pkey_ec.c
	* ext/openssl/ossl_ssl_session.c
	* ext/openssl/ossl_x509crl.c
	* ext/openssl/ossl_pkey.c
	* ext/openssl/ossl_pkey_dh.c
	* ext/openssl/ossl_x509cert.c
	* ext/openssl/ossl_pkcs7.c: Use OSSL_BIO_reset.

	* ext/openssl/ossl_ssl.c
	* ext/openssl/ossl_cipher.c
	* ext/openssl/ossl_pkey_ec.c
	* ext/openssl/ossl_pkcs12.c
	* ext/openssl/ossl_ssl_session.c: Replace rb_raise occurrences by
	  ossl_raise. This automatically flushes OpenSSL's error queue.

	* ext/openssl/ossl_pkcs7.c: Raise error if DER fallback for parsing
	  fails.

	* test/openssl/test_pkey_ec.rb
	* test/openssl/test_pkey_dsa.rb
	* test/openssl/test_pkey_rsa.rb: Add assertions that OpenSSL.errors is
	  empty.

	* test/openssl/test_pkey_rsa.rb: Remove initial OpenSSL.errors call in
	  test_new.
	  [ Ruby 1.9 - Bug #4885 ] [ruby-core:37134]

Wed Jun 22 15:01:24 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_ssl.c: Use SSL_MODE_RELEASE_BUFFERS if available.
	  Thanks, Eric Wong, for providing the patch.
	  [ Ruby 1.9 - Feature #4672 ] [ruby-core:36127]

Wed Jun 22 14:47:53 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_buffering.rb
	* test/openssl/test_pkcs12.rb: Inherit from Test::Unit::TestCase
	  instead of MiniTest::Unit::TestCase. [ruby-core:37275]

Wed Jun 22 12:41:03 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/ossl_ssl_session.c (ossl_ssl_session_to_der):
	  OpenSSL::SSL::Session#to_der was broken. Fix buffer handling.

	* test/openssl/test_ssl_session.rb (test_session): Test it.

Wed Jun 22 12:38:52 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* test/openssl/test_ssl_session.rb: Split out SSL::Session related
	  tests from test_ssl.rb

Wed Jun 22 03:20:52 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: Fix cyclic references of
	  objects.  Thanks to CvX for reporting the bug and a test case.
	* test/psych/test_object.rb: test for cyclic object references.

Wed Jun 22 02:39:54 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* lib/net/http.rb (Net::HTTP.post_form): Do not ignore query part of
	  the given URI to post. See #655.

	* test/net/http/test_http.rb, test/net/http/utils.rb: Test it.

Wed Jun 22 01:28:13 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* test/openssl/test_x509store.rb (test_set_errors): Redhat is
	  distributing a patched version of OpenSSL that allows multiple CRL
	  for a key (multi-crl.patch.) Make test pass on such env. See #4122,
	  #4554.

Tue Jun 21 21:50:37 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* lib/webrick/httpresponse.rb (HTTPResponse#setup_header): Close
	  HTTP/1.1 connection when returning an IO object as response body
	  without setting HTTPResponse#chunked to true. See #855 no.1.

	* test/webrick/test_httpserver.rb: Test it.

Tue Jun 21 21:27:34 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* internal.h: move rb_thread_io_blocking_region() declaration
	  from intern.h to internal.h. It's still experimental API and
	  need more discussion. [ruby-dev:43698]
	* include/ruby/intern.h: ditto.

	* ext/socket/rubysocket.h: include internal.h.
	* ext/socket/depend: add internal.h dependency.
	* ext/socket/extconf.rb: add $INCFLAGS to topdir.

Tue Jun 21 20:38:47 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (datetime_s_*): canonicalize 24 o'clock.

Tue Jun 21 19:46:23 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_thread.rb (TestThread#test_priority): enable
	  this test again. Current GVL respect thread priority rather
	  than past.

Tue Jun 21 13:25:35 2011  TAKAO Kouji  <kouji@takao7.net>

	* ext/readline/readline.c (readline_getc): applied a patch in
	  #3827 by by Akio Tajima <artonx AT yahoo.co.jp>. (see #3827)

Tue Jun 21 13:16:31 2011  TAKAO Kouji  <kouji@takao7.net>

	* ext/readline/extconf.rb: fixed bug, specify --disable-libedit
	  then disable libedit, does not specify then check readline and
	  libedit if failed checking readline. (fixes #3375)

Mon Jun 20 22:52:07 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (before_exec): use sig_do_nothing instead of SIG_DFL
	  for avoiding a race.
	* process.c (sig_do_nothing): new function.

Mon Jun 20 21:31:03 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (thread_timer): rename timeout_10ms to
	  time_quantum. it's no longer 10ms.

Mon Jun 20 18:46:02 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/ossl_cipher.c, ext/openssl/lib/openssl/cipher.rb:
	  Documentation fix by Ippei Obayashi. See #4419.

Mon Jun 20 15:41:33 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* lib/webrick/cookie.rb (WEBrick::Cookie.parse): Revert r31228.
	  r31228 was for allowing the 'Cookie:' header which did not have no
	  SP after ';' for separating cookie-pairs but RFC6265 requires single
	  SP after ';' there.  We allow multiple SPs here for compatibility
	  with older WEBrick version.

	* test/webrick/test_cookie.rb: Test it.

Sun Jun 19 13:31:26 2011  Shota Fukumori  <sorah@tubusu.net>

	* NEWS: Introduce --hide-skip on test/unit.

Sun Jun 19 10:05:16 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit/parallel.rb: Override Test::Unit::TestCase#on_parallel_worker?
	  only when $0 == __FILE__.

	* lib/test/unit/parallel.rb: Run Test::Unit::Worker.run only when
	  $0 == __FILE__.

Sat Jun 18 23:59:24 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (fill_cbuf): finish reading at EOF, and the readconv has
	  been cleared by another thread while io_fillbuf() is waiting at
	  select().  a patch in [ruby-core:37197] by Hiroshi Shirosaki
	  <h.shirosaki AT gmail.com>.  fixed #3840

Sat Jun 18 21:36:29 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c: remove GVL_DEBUG

Sat Jun 18 21:32:02 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm.c, vm_core.h (rb_vm_stack_to_heap): remove const.
	  It makes compilations warnings.

Sat Jun 18 18:54:15 2011  Koichi Sasada  <ko1@atdot.net>

	* vm.c, vm_core.h (rb_vm_stack_to_heap): fix "const" place.

Sat Jun 18 17:23:38 2011  Tanaka Akira  <akr@fsij.org>

	* eval.c, hash.c, load.c, proc.c, range.c, thread.c, time.c: don't
	  declare internal functions.

	* internal.h, vm_core.h: declare internal functions.

	* array.c: include internal.h.

	* common.mk: update dependency for array.o.

Sat Jun 18 13:39:33 2011  Tanaka Akira  <akr@fsij.org>

	* internal.h: declarations declared in include/ruby/*.h removed.

Sat Jun 18 12:42:17 2011  Tanaka Akira  <akr@fsij.org>

	* method.h, internal.h iseq.h: declare internal functions.

	* compile.c, eval.c, iseq.c, object.c, parse.y, proc.c, process.c,
	  thread.c, vm.c, vm_eval.c, vm_insnhelper.c, vm_method.c: don't
	  declare internal functions.

	  Note that rb_method_entry_eq() is defined in vm_method.c but
	  there was a declaration in proc.c with different const-ness.
	  Now it is declared in method.h with same const-ness to the
	  definition.

	* object.c (rb_mod_module_exec): don't declare functions declared in
	  include/ruby/intern.h.

Sat Jun 18 12:05:08 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/backward/classext.h: for evil gems.  fixed #4803

Sat Jun 18 11:12:13 2011  Tanaka Akira  <akr@fsij.org>

	* common.mk: update dependencies.

Sat Jun 18 11:09:03 2011  Tanaka Akira  <akr@fsij.org>

	* io.c: suppress warnings.

Sat Jun 18 10:22:39 2011  Tanaka Akira  <akr@fsij.org>

	* internal.h: declare more internal functions.

	* iseq.h (rb_method_get_iseq): declared.

	* compile.c, eval.c, eval_error.c, iseq.c, parse.y, proc.c, range.c,
	  ruby.c, time.c, util.c, vm.c: don't declare internal functions.

	* eval.c, parse.y, thread_pthread.c: non-existing function declarations
	  removed.

Sat Jun 18 08:12:54 2011  Tanaka Akira  <akr@fsij.org>

	* common.mk: dependencies updated.

	* tool/update-deps: new file to assist update dependencies in
	  common.mk.

Sat Jun 18 07:27:27 2011  Tanaka Akira  <akr@fsij.org>

	* internal.h: declare internal functions here.

	* node.h: declare NODE dependent internal functions here.

	* iseq.h: declare rb_iseq_t dependent internal functions here.

	* vm_core.h: declare rb_thread_t dependent internal functions here.

	* bignum.c, class.c, compile.c, complex.c, cont.c, dir.c, encoding.c,
	  enumerator.c, error.c, eval.c, file.c, gc.c, hash.c, inits.c, io.c,
	  iseq.c, load.c, marshal.c, math.c, numeric.c, object.c, parse.y,
	  proc.c, process.c, range.c, rational.c, re.c, ruby.c, string.c,
	  thread.c, time.c, transcode.c, variable.c, vm.c,
	  tool/compile_prelude.rb: don't declare internal functions declared
	  in above headers.  include above headers if required.

	  Note that rb_thread_mark() was declared as
	  void rb_thread_mark(rb_thread_t *th) in cont.c but defined as
	  void rb_thread_mark(void *ptr) in vm.c.  Now it is declared as
	  the later in internal.h.

Sat Jun 18 02:36:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (VpNewRbClass): fix type of the 2nd
	  argument.

	* ext/bigdecimal/bigdecimal.h: ditto.

Sat Jun 18 02:30:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigMath_s_exp): move BigMath.exp from
	  bigdecimal/math.rb.

	* ext/bigdecimal/lib/bigdecimal/math.rb: ditto.

	* test/bigdecimal/test_bigdecimal.rb: move test for BigMath.exp from
	  test/bigdecimal/test_bigmath.rb.

	* test/bigdecimal/test_bigmath.rb: ditto.

Sat Jun 18 00:20:54 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: do not define wnum[01].

Fri Jun 17 18:57:36 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* compile.c (iseq_compile_each): fix return value of obj[a,*b]=c.

Fri Jun 17 13:09:45 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/curses/curses.c:  Clean up documentation.

Fri Jun 17 09:25:14 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/curses/curses.c:  Document curses constants.  Patch by Vincent
	  Batts.  [Ruby 1.9 - Bug #4880]

Fri Jun 17 09:11:05 2011  Eric Hodel  <drbrain@segment7.net>

	* object.c:  Document Module#method_added and #method_removed.
	  Patch by Bryce Kerley.  [Ruby 1.9 - Feature #4867]

Fri Jun 17 08:50:16 2011  Eric Hodel  <drbrain@segment7.net>

	* io.c:  Improve documentation of IO and File open and new.
	  Patch by Roger Pack.  [Ruby 1.9 - Bug #4790]

Fri Jun 17 07:53:50 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/csv.rb:  Document #raw_encoding.  Patch by David Czarnecki.
	  [Ruby 1.9 - Bug #4874]

Fri Jun 17 07:46:50 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/benchmark.rb:  Document Benchmark::Tms#memberwise.  Patch by
	  David Czarnecki.  [Ruby 1.9 - Bug #4873]

Fri Jun 17 07:38:31 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/prettyprint.rb:  Improve documentation.  Patch by Ysiad
	  Ferreiras.  [#4834]

Fri Jun 17 07:23:03 2011  Eric Hodel  <drbrain@segment7.net>

	* array.c (rb_ary_drop):  Improve documentation.  Patch by Caley Woods.
	  [Ruby 1.9 - Bug #4858]

Fri Jun 17 06:11:31 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/webrick/log.rb:  Improve documentation of BasicLog and Log.
	  Patch by Olivier Brisse.  [Ruby 1.9 - Bug #4833]
	* lib/webrick/httpstatus.rb:  Improve documentation of
	  WEBrick::HTTPStatus.  Patch by Olivier Brisse.
	  [Ruby 1.9 - Bug #4833]

Fri Jun 17 04:48:22 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c, thread_pthread.h: remove unused variables.
	  (native_thread_data_t::gvl_cond, native_thread_data_t::gvl_next)

Thu Jun 16 14:32:31 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* time.c (rb_time_new): prevent overflow by "* 1000".

Fri Jun 17 03:07:36 2011  Koichi Sasada  <ko1@atdot.net>

	* benchmark/bm_vm4_thread_create_join.rb,
	  benchmark/bm_vm4_thread_mutex[1-3].rb: renamed to
	  bm_thread_* (fix last rename).

Fri Jun 17 02:26:47 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (native_thread_create): fix debug message.
	  (add last newline)

Thu Jun 16 23:40:49 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_schedule_rec): fix {UN,}LIKELY macro misuse.
	* gc.c (rb_newobj): ditto.
	* vm_insnhelper.c (vm_method_search): ditto.

Thu Jun 16 20:06:15 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/testunit/test_parallel.rb: Fix Regexp for test.

	* test/testunit/tests_for_parallel/test_third.rb: Use
	  Test::Unit::TestCase#on_parallel_worker? for detecting worker.

	* lib/test/unit/testcase.rb(Test::Unit::TestCase#on_parallel_worker?):
	  New Method Test::Unit::TestCase#on_parallel_worker? returns true
	  when a testcase is running on parallel worker.
	* lib/test/unit/parallel.rb(Test::Unit::TestCase#on_parallel_worker?):
	  ditto.

Thu Jun 16 19:27:12 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* test/test_securerandom.rb: Add testcase.  This testcase does NOT aim
	  to test cryptographically strongness and randomness.  It includes
	  the test for PID recycle issue of OpenSSL described in #4579 but
	  it's disabled by default.

Thu Jun 16 17:55:07 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_io.rb (TestIO#test_copy_stream_socket): fix
	  test hanging up issue. Patch by CHIKANAGA Tomoyuki.

Thu Jun 16 15:17:39 2011  Eric Hodel  <drbrain@segment7.net>

	* variable.c (const_missing):  Add simple example of const_missing.
	  Patch by Anuj Dutta.  [Ruby 1.9 - Bug #4794]

Thu Jun 16 15:09:29 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/monitor.rb:  Improve documentation.  Patch by Sandor Szucs.
	  [Ruby 1.9 - Bug #4823]

Thu Jun 16 14:54:09 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/webrick/utils.rb: Document WEBrick::Utils.  Patch by Olivier
	  Brisse.  [Ruby 1.9 - Bug #4819]

Thu Jun 16 14:26:46 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/webrick/httpservlet/erbhandler.rb:  Allow the ERB document to
	  alter the content-type of the response.  [Ruby 1.9 - Bug #4685]

Thu Jun 16 14:15:47 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/timeout.rb: Clarify timeout duration types.  Patch by Alf Mikula.
	  [Ruby 1.9 - Bug #4791]
	* lib/net/http.rb: ditto

Thu Jun 16 13:25:25 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc*:  Import RDoc 3.7 release candidate

Thu Jun 16 11:35:09 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (search_response): parses SEARCH responses from
	  the Yahoo IMAP server correctly.  patched by Mark Nadig.  [Bug #4509]

Thu Jun 16 09:12:38 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* fix for build on solaris 10.

Thu Jun 16 09:08:39 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/io/console/test_io_console.rb (TestIO_Console#test_sync):
	  fix for daemon process.

Thu Jun 16 07:58:01 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/testunit/test_parallel.rb(test_ignore_tzero): Test for r32109.

	* test/testunit/tests_for_parallel/test_third.rb: Use another way to
	  detect that test is running on worker. This fixes sometimes
	  TestParallel failing.

Thu Jun 16 07:20:06 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb(Test::Unit::Runner#_run_parallel): Ignore -j0
	  because it makes blocking forever by IO.select.

Thu Jun 16 03:08:11 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/testunit/test_parallel.rb (TestParallel::TestParallelWorker#
	  setup): now can run on Windows, probably.

	* test/testunit/test_parallel.rb (TestParallel::TestParallel#setup):
	  ditto.

Thu Jun 16 03:00:26 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* thread.c (do_select): Windows: no need to poll if select(2) is
	  cancelable.

	* thread_win32.c (native_fd_select): new function to make select(2)
	  cancelable.

	* thread_win32.c (rb_w32_check_interrupt): new function for checking
	  interrupt.

	* win32/win32.c (rb_w32_select_with_thread): new function. cancelable
	  select(2).

	* win32/win32.c (rb_w32_select): use above function internally.

Wed Jun 15 23:30:45 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* gc.c: fix a regression by r31690 on AIX because AIX malloc
	  return NULL if it's passed 0. But some caller don't expect it.
	  patch by Yutaka Kanemoto. [ruby-dev:43779]
	(vm_malloc_prepare): return calculated size.
	(vm_xmalloc): use above result.
	(vm_xcalloc): ditto.

Wed Jun 15 23:11:35 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c: remove BLOCKING_REGION_CORE() macro. It's no longer used
	  since r32022.

Wed Jun 15 21:00:47 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_config.rb: execute based on the existence of the
	  OpenSSL module.

Wed Jun 15 12:35:11 2011  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_io.rb (test_copy_stream_socket): wait a child process
	  before SIGUSR1 handler is removed.

	* test/pathname/test_pathname.rb (define_assertion): use line number
	  for test method names.

Wed Jun 15 10:37:43 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* file.c (rb_stat_rdev): use DEVT2NUM.

	* file.c (rb_stat_rdev_major): ditto.

	* file.c (rb_stat_rdev_minor): ditto.

Wed Jun 15 05:12:59 2011  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/tcltklib.c (lib_eventloop_core): revert the last change (it's
	  the part for ruby_1_8), and use rb_thread_check_ints() when RUBY_VM
	  is defined.

Wed Jun 15 04:42:47 2011  Koichi Sasada  <ko1@atdot.net>

	* benchmark/bm_vm3_thread_*.rb: renamed bm_vm3_thread_*.rb to
	  benchmark/bm_vm_thread_*.rb.

Wed Jun 15 04:28:39 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/bm_vm4_thread_pass.rb: rename bm_vm4* to
	  bm_vm_thread_*. suggested by ko1.
	* benchmark/bm_vm4_pipe.rb: ditto.
	* benchmark/bm_vm4_alive_check1.rb: ditto.
	* benchmark/bm_vm4_pass_flood.rb: ditto.

Wed Jun 15 03:52:50 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/bm_vm4_pass_flood.rb: new benchmark for GVL fairness.
	* benchmark/bm_vm4_alive_check1.rb: ditto.

Wed Jun 15 01:27:53 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (gvl_yield): fix live lock issue on 1-2 cpus
	  system. It's additional fix for r32021.
	* thread_pthread.c (gvl_init): add switch_wait_cond.
	* thread_pthread.h (typedef struct rb_global_vm_lock_struct): ditto.

Tue Jun 14 23:16:22 2011  Tanaka Akira  <akr@fsij.org>

	* bootstraptest/runner.rb (show_progress): refine verbose mode.
	  (exec_test): ditto.

Tue Jun 14 23:02:36 2011  Tanaka Akira  <akr@fsij.org>

	* bootstraptest/runner.rb (show_progress): extracted from assert_check.
	  (assert_check): use show_progress.
	  (assert_normal_exit): ditto.
	  (assert_finish): ditto.
	  (flunk): ditto.

Tue Jun 14 22:51:42 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/test_*.rb: added tests.

Tue Jun 14 22:09:58 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: renamed some functions.
	* ext/date/date_core.c: modified doc.

Tue Jun 14 21:26:01 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* cont.c (cont_save_thread): add new utility function.
	  rb_context_t::saved_thread.machine_stack_start and
	  machine_stack_end should be cleared immediately after a snapshot of
	  current thread is stored to saved_thread. [ruby-dev:43680] [Bug #4855]
	  this change aims to get rid of unnecessary GC mark at machine stack.

Tue Jun 14 19:50:49 2011  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_autoload.rb: remove temporary directory.

Tue Jun 14 11:05:03 2011  Narihiro Nakamura  <narihiro@netlab.jp>

	* gc.c (rb_gc_set_params): call initial_expand_heap if
	  initial_heap_min_slots is set.

Tue Jun 14 11:02:08 2011  Narihiro Nakamura  <narihiro@netlab.jp>

	* gc.c: use size_t.

Tue Jun 14 01:10:38 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* test/coverage/test_coverage.rb: add a test for restart.  a patch
	  from Xavier Shay.  [ruby-core:36745]

Tue Jun 14 01:05:10 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* ext/coverage/coverage.c: make it restartable.  [ruby-core:36539]

Mon Jun 13 23:55:40 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_schedule_rec): call gvl_yield() unconditionally.
	* thread_pthread.c: remove HAVE_GVL_YIELD macro.
	* thread_win32.c (gvl_yield): new. this fallback logic was moved from
	  rb_thread_schedule_rec().

Mon Jun 13 23:50:25 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/io/console/console.c (console_dev): typo.

Mon Jun 13 23:38:23 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_parse_string): flush delayed token.  based on a
	  patch by Masaya Tarui in [ruby-dev:43762].  Bug #4544

	* parse.y (yylex): revert r24557.  delayed token at the end of
	  string should be flushed already by the above change.

Mon Jun 13 23:33:31 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (console_dev): console should be
	  unbuffered.

	* ext/io/console/console.c (console_dev): take care of no-ctty
	  case.

Mon Jun 13 23:06:12 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c: rewrite GVL completely. This fix improve some
	  benchmark dramatically (e.g. vm3_thread_mutex result changed
	  form 120.601sec to 3.426sec).
	* thread_win32.c: ditto.
	* thread_pthread.h: ditto.
	* vm_core.h: ditto.
	* thread.c: ditto.

Mon Jun 13 23:11:52 2011  Tanaka Akira  <akr@fsij.org>

	* test/socket/test_unix.rb: don't use Thread.abort_on_exception.

Mon Jun 13 23:05:01 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/unixsocket.c (unix_send_io): race condition fixed.
	  (unix_recv_io): ditto.
	  fixed by Eric Wong.  [ruby-core:35574]

	* test/socket/test_unix.rb: test added for above problem.

Mon Jun 13 21:41:05 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_win32.c (native_cond_signal): remove unnecessary rb_bug().
	  It's additional fix for r32021. [Bug #4696]

Mon Jun 13 20:50:49 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_ec.rb
	  test/openssl/test_pkey_ec.rb: merge both files into test_pkey_ec.rb.
	  Removed redundant group instantiation from PKey tests.
	* test/openssl/utils.rb: only create TEST_PKEY_EC_P256V1 if EC is
	  defined.

Mon Jun 13 20:28:24 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/digest.rb: remove MDC2 from test, it is not available
	  by default in an OpenSSL installation.

Mon Jun 13 20:18:55 2011  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h, vm_insnhelper.h: move decl. of
	  ruby_vm_global_state_version and related macros
	  from vm_core.h to vm_insnhelper.h.

	* vm.c (vm_clear_all_cache): added.  This function is called
	  when ruby_vm_global_state_version overflows.
	  TODO: vm_clear_all_inline_method_cache() is only place holder.
	        We need to implement it ASAP.

	* vm_method.c (vm_clear_global_method_cache): added.

Mon Jun 13 19:46:21 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/cmath.rb: add new method Object#real?. fix #3137

Mon Jun 13 18:52:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (is_kind_of_BigDecimal): new function to
	  examine the whether the object is kind of BigDecimal.

Mon Jun 13 18:49:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimalCmp): use GetVpValueWithPrec
	  for Float and Rational arguments.

	* test/bigdecimal/test_bigdecimal.rb (test_new, test_cmp, test_power):
	  add and modify tests for the above change.

	* ext/bigdecimal/bigdecimal.c (BigDecimalCmp): modify coding style to
	  match ruby's standard.

Mon Jun 13 18:33:04 2011  Tanaka Akira  <akr@fsij.org>

	* lib/securerandom.rb (SecureRandom.random_bytes): modify PRNG state
	  to prevent random number sequence repetition at forked child
	  process which has same pid.
	  reported by Eric Wong.  [ruby-core:35765]

Mon Jun 13 17:02:34 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http.rb (Net::HTTP#use_ssl?): require 'openssl' only when
	  https is needed. fixes r31933.

Mon Jun 13 14:35:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* lib/cmath.rb (CMath.cbrt): returns the principal value of the cube
	  root of the argument.  fix #3676

	* test/test_cmath.rb (test_cbrt_returns_principal_value_of_cube_root):
	  test for the above change.

Mon Jun 13 14:17:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* lib/test/unit.rb (Test::Unit::GlobOption#non_options): fix typo.

Mon Jun 13 13:04:20 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_digest.c: fix error for digests that have no oid
	(e.g. DSS1).
	* test/openssl/test_digest.c: add tests for this.

Mon Jun 13 12:51:51 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/yaml.rb: load psych only when syck is not loaded.

Mon Jun 13 12:23:39 2011  NARUSE, Yui  <naruse@ruby-lang.org>

Mon Jun 13 12:23:39 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/psych/lib/psych/deprecated.rb (Object#to_yaml_properties):
	  undef to_yaml_properties before redefine it.

	* ext/syck/lib/syck/rubytypes.rb: ditto.

Mon Jun 13 11:30:10 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_digest.c: allow Digests to be created by sn, ln or
	  oid.
	* test/openssl/test_digest.rb: add tests for this.
	  [Ruby 1.9 - Feature #4412] [ruby-core:35319]

Mon Jun 13 10:54:03 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/pkey_dh.c: corrected documentation.
	* test/openssl/utils.rb: add test key for DH.
	* test/openssl/test_pkey_dh.rb: add tests.

Mon Jun 13 10:13:08 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/pkey_dh.c: clarify difference between DH#public_key and
	DH#pub_key in documentation.

Mon Jun 13 05:50:43 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* NEWS: introduce PKey.read.

Mon Jun 13 05:17:29 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_pkey.c: added PKey.read module function that allows
	  reading arbitrary public/private keys from DER-/PEM-encoded File or
	  string instances.
	* ext/openssl/ossl_pkey_dh.c: improved documentation.
	* test/openssl/utils.rb: added EC test key.
	* test/openssl/test_pkey_rsa.rb
	  test/openssl/test_pkey_dsa.rb: Test PKey.read. Reuse keys from
	  OpenSSL::TestUtils.
	* test/openssl/test_pkey_ec.rb: Created test file for EC tests.
	  Test PKey.read.
	  [Ruby 1.9 - Feature #4424] [ruby-core:35330]

Mon Jun 13 04:42:24 2011  Koichi Sasada  <ko1@atdot.net>

	* ext/objspace/objspace.c (total_i): fix to skip no ruby objects.

Mon Jun 13 03:07:38 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/benchmark/test_benchmark.rb (capture_output):
	  replace '-' as space. On NetBSD, subtract between two Process.times
	  after and before the short process may return negative value like:
	  t0=Process.times; yield; t1=Process.times; p t1.utime-t0.utime

Mon Jun 13 02:40:23 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_pkey_dsa.rb: Test for DSA#syssign/sysverify.

Mon Jun 13 01:59:19 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_pkey_dh.c: completed documentation.
	* ext/openssl/ossl_pkey_dsa.c: corrected examples. Improved parameter
	  sections.

Mon Jun 13 00:25:10 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_pkey_dsa.c: completed documentation.

Sun Jun 12 23:36:46 2011  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* lib/drb/drb.rb (kill_sub_thread): remove the method. [ruby-core:34185]

Sun Jun 12 21:01:56 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (d_lite_marshal_load): should give converted value.

Sun Jun 12 20:36:30 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: edited doc.

Sun Jun 12 18:12:07 2011  Koichi Sasada  <ko1@atdot.net>

	* benchmark/bm_vm3_clearmethodcache.rb: added.

Sun Jun 12 17:40:29 2011  Koichi Sasada  <ko1@atdot.net>

	* vm_method.c (rb_clear_cache*): update only vm state version.

	* vm_method.c (rb_method_entry_get_without_cache, rb_method_entry):
	  Fill method cache entry with vm state version, and
	  check current vm state version for method (cache) look up.
	  This modification speed-up invalidating of global method cache table.
	  [Ruby 1.9 - Feature #3905] [ruby-core:36908]

Sun Jun 12 16:19:48 2011  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/extconf.rb: fail on Mac OS X. [Bug #4853][ruby-dev:43655]

Sun Jun 12 15:56:08 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c: remove th->transition_for_lock. It's thread unsafe.
	  [Bug #4723][ruby-dev:43563]

Sun Jun 12 15:47:35 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c: introduce spurious wakeup safe deadlock check.
	  [Bug #4696][ruby-dev:43554]

Sun Jun 12 13:33:52 2011  Koichi Sasada  <ko1@atdot.net>

	* benchmark/bm_vm3_thread_mutex.rb: remove it.

	* benchmark/bm_vm3_thread_mutex[1-3].rb: added 3 benchmarks.
	    1: one thread with one mutex (no contention).
	    2: two threads with one mutex (contention).
	    3: 1000 threads with one mutex (huge number of contention)
	  Above removed benchmark was type 3.
	  Therefore, this commit adds type 1 and 2 benchmark.

Sun Jun 12 11:16:59 2011  Tanaka Akira  <akr@fsij.org>

	* io.c: use select() appropriately for sendfile().
	  Fixed by Eric Wong.  [ruby-core:36150]
	  (maygvl_copy_stream_wait_readwrite): removed.
	  (nogvl_copy_stream_sendfile): use nogvl_copy_stream_wait_write and
	  maygvl_copy_stream_wait_read instead of
	  maygvl_copy_stream_wait_readwrite.

Sun Jun 12 09:32:13 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* atomic.h (ATOMIC_OR): _InterlockedOr is not available on mingw.h
	* gc.c (rb_gc_set_params): VM_OBJSPACE is disabled on mingw.

Sun Jun 12 01:07:09 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: edited doc.

Sat Jun 11 23:18:00 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm_core.h (RUBY_VM_SET_TIMER_INTERRUPT, RUBY_VM_SET_INTERRUPT,
	  RUBY_VM_SET_FINALIZER_INTERRUPT): use atomic ops for preventing
	  interrupt_flag bit lost. [Bug #4770][ruby-dev:43467]
	* thread.c (rb_threadptr_execute_interrupts_rec): ditto.
	* vm_core.h (typedef struct rb_thread_struct): change type of
	  interrupt_flag to rb_atomic_t.
	* atomic.h: move atomic ops definition from signal.c.
	* signal.c: remove atomic ops definition.
	* common.mk (gc, signal, thread, cont): add to dependency to atomic.h.

Sat Jun 11 23:23:52 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: edited doc.

Sat Jun 11 23:02:36 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/lib/openssl/buffering.rb (module OpenSSL):
	  Buffering#each_byte should return String in accordance with IO in
	  1.9.

	* test/openssl/test_buffering.rb (class OpenSSL): add tests for getc
	  and each_byte.

Sat Jun 11 22:41:37 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* time.c: a correction of doc for strftime (%v).

Sat Jun 11 22:30:53 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: replaced doc for strftime based on Time's one.

Sat Jun 11 22:07:56 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (datetime_s_{iso8601,rfc3339,xmlschema,rfc2822,httpdate}):
	  do not take argument comp.

Sat Jun 11 21:58:31 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: added examples.

Sat Jun 11 19:40:45 2011  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c: expand heap if initial_heap_min_slots is bigger than
	  HEAP_MIN_SLOTS.

Sat Jun 11 19:42:50 2011  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ChangeLog (vim): set shiftwidth to 2.

Sat Jun 11 19:27:06 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/ossl_x509req.c: raise RequestError instead of
	  CertificateError when Request#to_der gets an error from OpenSSL.
	  Patch from Ippei Obayashi, see #4420. I cannot write a test for
	  this... Request does not allow to create broken bytes...

Sat Jun 11 19:34:51 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (Date::(ABBR_)?(MONTH|DAY)NAMES): should be usascii.

Sat Jun 11 19:24:33 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: rewrote doc.

Sat Jun 11 19:04:15 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit.rb (Test::Unit::GlobOption#non_options): should run
	  with 1.8.

Sat Jun 11 18:05:57 2011  WATANABE Hirofumi  <eban@ruby-lang.org>

	* bootstraptest/runner.rb: should initialize $stress to avoid warnings.

Sat Jun 11 18:02:09 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_getc): should be 7bit if ascii.  fixes #4557

Sat Jun 11 16:52:16 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* numeric.c (rb_enc_uint_chr): fix message format. Bug#4869

Sat Jun 11 16:28:25 2011  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/formatters/pretty.rb
	  (REXML::Formatters::Pretty#write_text),
	  test/rexml/test_core.rb
	  (Tester#test_pretty_format_long_text_finite): don't ignore
	  'width' parameter in pretty formatter. fixes #4498
	  Reported by Michael Frasca. Thanks!!!

Sat Jun 11 16:11:36 2011  Kouhei Sutou  <kou@cozmixng.org>

	* test/rexml/test_core.rb
	  (Tester#test_pretty_format_long_text_finite): remove needless
	  assert_nothing_raised.

Sat Jun 11 16:04:03 2011  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/parsers/xpathparser.rb
	  (REXML::Parsers::XPathParser#parse),
	  test/rexml/test_elements.rb
	  (ElementsTester#test_each_with_frozen_condition):
	  don't modify original XPath. fixes #4161
	  Reported by Pavel Shved. Thanks!!!

Sat Jun 11 15:53:27 2011  Kouhei Sutou  <kou@cozmixng.org>

	* test/rexml/test_elements.rb (ElementsTester): remove needless
	  prefix from test name.

Sat Jun 11 15:36:36 2011  Martin Duerst  <duerst@it.aoyama.ac.jp>
	* common.mk: fixed a grammatical error

Sat Jun 11 14:20:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm.c (thread_memsize): don't ignore size of th->local_storage.

Sat Jun 11 10:32:46 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb: should quote arch_hdrdir and libpath for the case
	  installed prefix contains spaces.

Sat Jun 11 10:20:52 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (native_cond_timeout): wrap conditionally used
	  label.

	* thread_pthread.c (native_sleep): remove unused variable.

Sat Jun 11 10:15:50 2011  Tanaka Akira  <akr@fsij.org>

	* thread.c (rb_thread_execute_interrupts): use GetThreadPtr to extract
	  rb_thread_t from VALUE.
	  reported by Motohiro KOSAKI.  [ruby-dev:43700]

Sat Jun 11 10:00:49 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (ruby_process_options): add missing return type.

Fri Jun 10 23:18:09 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/tk/tcltklib.c (lib_eventloop_core): replace CHECK_INTS with
	  rb_thread_check_ints(). Because current code can't be compiled.

Fri Jun 10 16:38:13 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* encoding.c (rb_locale_charmap): When ruby process is run as Windows
	  Service the console codepage is not set, GetConsoleCP returns 0.
	  So on such environment, use GetACP().
	  http://blogs.msdn.com/b/michkap/archive/2005/02/08/369197.aspx
	  patched by Rafal Bigaj [ruby-core:36832] [Bug #4854]

Fri Jun 10 14:34:24 2011  Koichi Sasada  <ko1@atdot.net>

	* common.mk: restore TESTRUN_SCRIPT to "$(srcdir)/test.rb".
	  TESTRUN_SCRIPT is used by "make run", "make gdb" and so on.

Fri Jun 10 13:01:24 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_module.rb (TestModule#remove_rake_mixins): remove all
	  module related to Rake.

Fri Jun 10 09:52:38 2011  Eric Hodel  <drbrain@segment7.net>

	* encoding.c:  Mention that Encoding.compatible? can work with more
	  than just Strings.

Fri Jun 10 02:25:53 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: updating version to match released gem.

Fri Jun 10 01:06:29 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/bigdecimal (BigDecimal_to_i): Integer#** may return flonum.

Fri Jun 10 00:35:12 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c (string_to_c_internal): uses rb_reg_nth_match;
	* rational.c (string_to_r_internal): ditto.

Fri Jun 10 00:25:03 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* gc.c: remove an unused declaration.

Fri Jun 10 00:24:04 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* rational.c (string_to_r): Rational#** may return flonum.

Thu Jun  9 23:57:53 2011  Tanaka Akira  <akr@fsij.org>

	* io.c: fix IO.copy_stream interrupt handling.
	  based on the patch by Eric Wong.  [ruby-core:36156]

	* vm_core.h (rb_thread_call_with_gvl): don't declare here.

	* thread.c: include internal.h.
	  (rb_thread_execute_interrupts): new function.

	* internal.h (rb_thread_execute_interrupts): declared.
	  (rb_thread_call_with_gvl): declared.

Thu Jun  9 23:34:01 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* gc.c (rb_objspace_call_finalizer): use rb_typeddata_is_kind_of() for
	  type check to get rid of a double free when main Thread has singleton
	  class. [ruby-core:36741] [Bug #4828]
	* thread.c (rb_obj_is_mutex): add a new utility function.
	* vm.c (rb_obj_is_thread): ditto.

Thu Jun  9 22:53:49 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/ruby/test_thread.rb (TestThread#test_kill_thread_subclass):
	  add test for Thread.kill with Thread subclass instance.

Thu Jun  9 22:31:47 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/ruby/test_thread.rb (TestThread#test_kill_wrong_argument):
	  test for [ruby-core:35086].
	  partially forward porting r31402 from ruby_1_9_2 branch.

Thu Jun  9 18:36:00 2011  Kenta Murata <mrkn@mrkn.jp>

	* string.c: Fix the ambiguous description of the behavior of
	  rb_str_aref_m with a range.  It returns nil when the beginning of
	  the range is greater than the end of the string rather than the range.

Thu Jun  9 10:57:03 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: Hash subclasses can be read
	  from YAML files.
	* ext/psych/lib/psych/visitors/yaml_tree.rb: Hash subclasses can be
	  dumped to YAML files.
	* test/psych/test_hash.rb: corresponding test.

Thu Jun  9 09:18:51 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: Ruby modules can be loaded
	  from YAML files.
	* ext/psych/lib/psych/visitors/yaml_tree.rb: Ruby modules can be
	  dumped to YAML files.
	* test/psych/test_class.rb: corresponding test.

Thu Jun  9 09:05:04 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: Ruby classes can be loaded
	  from YAML files.
	* ext/psych/lib/psych/visitors/yaml_tree.rb: Ruby classes can be
	  dumped to YAML files.
	* test/psych/test_class.rb: corresponding test.

Wed Jun  8 21:38:57 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* cont.c (root_fiber_alloc): set root fiber's status RUNNING.
	  in cont_mark() only RUNNING fiber's machine stack is marked.
	  root fiber's status should be RUNNING at the beginning regardless of
	  FIBER_USE_NATIVE. [ruby-core:36735] fixes #4827

Tue Jun  7 20:50:11 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* doc/irb/irb.rd: fix typo. patch by Nobuhiro IMAI.
	  [Bug #4843] [ruby-dev:43639]
	* doc/irb/irb.rd.ja: ditto.
	* doc/ChangeLog-YARV: ditto.

Tue Jun  7 18:52:55 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/rubygems/user_interaction.rb (Gem::StreamUI#tty?): IO#tty? of
	  Windows has been fixed at r29969.

	* test/rubygems/test_gem_stream_ui.rb: now can run tests.

Tue Jun  7 18:36:41 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/rubygems/test_gem.rb (TestGem#{test_self_user_home_userprofile,
	  test_self_user_home_user_drive_and_path}): should simply ignore
	  meaningless tests instead of skipping them.

Tue Jun  7 18:15:00 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_rubyoptions.rb (TestRubyOptions#test_set_program_name):
	  should show some messages when skipping tests.

Tue Jun  7 13:59:47 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_core.c (date_s_today, datetime_s_now): check the
	  result of localtime_r().

Tue Jun  7 13:36:51 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/tk/extconf.rb: use $defs not $CPPFLAGS to get rid of
	  command line escape issues on Windows.  fixed #4835.

Tue Jun  7 03:18:45 2011  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/ruby/test_io.rb (TestIO#test_s_{,bin}write): do not create a
	  file under /tmp. [Bug #4846]

Mon Jun  6 22:51:43 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* cont.c: use #if FIBER_USE_NATIVE instead of #ifdef.
	  you can suppress use of setcontext for Fiber with compile option
	  -DFIBER_USE_NATIVE=0

Mon Jun  6 21:59:23 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/test_switch_hitter.rb: added a test.

Mon Jun  6 21:37:45 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: added notes.

Mon Jun  6 21:02:12 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: flattened format to strftimev.
	* ext/date/date_core.c (date_strftime_internal): taints run.

Mon Jun  6 15:10:17 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/{defines,missing}.h (rb_infinity, rb_nan): move from
	  defines.h to missing.h.  (couldn't use RUBY_EXTERN there.)

Mon Jun  6 14:35:48 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/rdoc/test_rdoc_markup_pre_process.rb (TestRDocMarkupPreProcess#
	  {test_include_file,test_include_file_encoding_incompatible}): no
	  need to write such workaround.  don't hide the bug of ruby. (and the
	  bug is already fixed.)

Mon Jun  6 14:11:11 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/date/date_core.c (valid_jd_sub): need to convert from VALUE to
	  double.

	* ext/date/date_core.c (offset_to_sec): get rid of a compiler warning.

Mon Jun  6 14:09:08 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/defines.h (rb_infinity, rb_nan): export for Windows.

Mon Jun  6 10:54:45 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb(Test::Unit::Runner#puke):
	  Add overriding from MiniTest::Unit#puke. This reverts minitest's fix
	  that skip messages are hidden when not verbose mode (-v option).
	  To hide skip messages, use --hide-skip option instead.

Mon Jun  6 10:52:13 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http.rb: don't use autoload.

Mon Jun  6 09:39:43 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/parser.c (parse): release event objects to plug memory
	leak.  Thanks Mark J. Titorenko!

Sun Jun  5 23:26:15 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* eval.c: remove rb_thread_stop_timer_thread function declaration.
	  Instead, include vm_core.h.
	* process.c: ditto.

Sun Jun  5 21:38:51 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (thread_timer): add to care a spurious wakeup.
	  When native_cond_timedwait() return 0 by spurious wakeup, we
	  don't have to neither 1) call timer_thread_function and 2)
	  exit the timer thread.

Sun Jun  5 17:50:01 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (m_real_cwyear): new.  derived from m_cwyear.
	* ext/date/date_strftime.c: trivial changes.

Sun Jun  5 17:22:01 2011  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/config_list.in: add new options for tcltklib.

Sun Jun  5 10:06:50 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_tmx.h: now does not place decoded data.  allows to
	  access indirectly via functions on demand.
	* ext/date/date_strftime.c: ditto.
	* ext/date/date_core.c: ditto.
	* ext/date/date_core.c ({d|dt}_lite_to_s): use strftime.

Sun Jun  5 06:22:02 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* NEWS: wrote about changes of date.

Sat Jun  4 16:59:26 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (d_lite_inspect): changed the format.
	* ext/date/date_core.c: refactoring and fixing some bugs.

Sat Jun  4 11:30:57 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (check_mix_method_i, do_mix_method_i): not mix methods
	  renamed as nil.

Sat Jun  4 04:04:41 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/rubygems/test_gem_commands_which_command.rb:
	  "missing" exists on ruby's top source directory. [Bug #4815]

Fri Jun  3 21:48:12 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/rubygems/test_case.rb: Refix for test-all in separate directory.
	  r31147 + r31151.

Fri Jun  3 20:58:47 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/date/date_core.c (d_lite_plus): get rid of compiler warnings.

Fri Jun  3 20:56:40 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/missing.h, numeric.c (round): moved prototype of round()
	  from numeric.c to missing.h.  (note: round() is C99 feature, so ruby
	  provides it if not exist in C runtime.)

Fri Jun  3 20:42:04 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit/parallel.rb: Keep $stdin, $stdout before run testcase
	  and restore after run. Because some test break $stdin, $stdout.
	  Fixes [Bug #4433] [ruby-core:35353]

Fri Jun  3 19:58:14 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (io_fflush): windows -- call fsync() only when the FD is tied to
	  file, because if the FD is pipe, it blocks.

Fri Jun  3 09:27:31 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http.rb (URI::HTTP#request_uri): return nil when the uri
	  is path-rootless form. Bug #4759

Thu Jun  2 23:51:03 2011  James Edward Gray II  <jeg2@ruby-lang.org>

	* lib/csv.rb: Improve the line ending detection algorithm
	  patch by Alexey).

Thu Jun  2 20:05:57 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (rb_io_s_write, rb_io_s_binwrite): return!!!

Thu Jun  2 16:29:34 2011  Shota Fukumori  <sorah@tubusu.net>

	* io.c: Add File.write, File.binwrite. [Feature #1081] [ruby-core:21701]

	* test/ruby/test_io.rb: Test for File.write, File.binwrite.

	* NEWS: News for above.

Thu Jun  2 12:33:09 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (io_fflush, rb_io_flush): need to fsync() when ruby calls
	  internal flush. [ruby-core:36670] [Bug #4813]

Thu Jun  2 07:56:24 2011  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/tcltklib.c: reduce CPU power required by an eventloop.

Tue May 31 21:28:33 2011  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_signal.rb (TestSignal#test_signal_requiring):
	  redirect stderr to null device.

Thu Jun  2 00:45:26 2011  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/extconf.rb: fix for uninitialized global variables.
	  [Ruby 1.9 - Bug #4811]

Wed Jun  1 21:57:08 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (native_sleep): fix 1000times calculation error.
	  this is a regression since r31457. [Bug #4808] [ruby-dev:43606]

Wed Jun  1 17:19:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c: remove unused macro.

Wed Jun  1 15:42:18 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (peek_n): new macro to see next nth char.

Wed Jun  1 15:40:46 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/rbinstall.rb (gem): fix for rubygems change.

Wed Jun  1 14:07:57 2011  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/minitest/*: Imported minitest 2.2.2 (r6281)
	* test/minitest/*: ditto

Wed Jun  1 12:35:50 2011  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/rubygems*: Import rubygems 1.8.5 (released @ 137c80f)
	* test/rubygems: Ditto

Wed Jun  1 12:34:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* NEWS: add new features of bigdecimal.

Wed Jun  1 09:41:14 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/cgi/util.rb:  Improve documentation.  Patch by Kuba Fietkiewicz.
	  [Ruby 1.9 - Bug #4775]
	* lib/cgi/core.rb:  ditto

Wed Jun  1 09:26:05 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/mathn.rb:  Improve documentation and attach it to Numeric.
	  Modified from patch by Anil V.  [Ruby 1.9 - Bug #4762]

Wed Jun  1 09:21:30 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/prime.rb:  Indent examples enough to appear as code sections.
	  Note that Prime is Enumerable.  [#4762]

Wed Jun  1 07:34:57 2011  Eric Hodel  <drbrain@segment7.net>

	* hash.c (key_i):  Change rdoc from "the first occurrence" to "an
	  occurrence" since first occurrence is not a specification of
	  Hash#key.  [Ruby 1.9 - Bug #4760]

Wed Jun  1 07:26:19 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/pty/pty.c (pty_check):  Restore "not reached" comment.
	  [Ruby 1.9 - Bug #4756]

Wed Jun  1 07:21:40 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/zlib/zlib.c:  Fix document-method declarations for set_sync and
	  set_comment.  [Ruby 1.9 - Bug #4695]

Wed Jun  1 06:43:13 2011  Masaya Tarui  <tarui@ruby-lang.org>

	* load.c (loaded_feature_path): cut nonsense loop execution to fix
	  performance bug.

Wed Jun  1 01:16:02 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_mix_module): implement Module#mix.

Wed Jun  1 01:15:12 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_encoding_set): should honor already set ecflags since it
	  might be set by mode option.  fixed #4804

Wed Jun  1 00:34:04 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* ext/bigdecimal/bigdecimal.c (GetVpValueWithPrec): remove unused
	  variable.

Wed Jun  1 00:32:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (GetVpValueWithPrec): support instantiation from
	  a Float through Rational.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_new): ditto.

	* test/bigdecimal/test_bigdecimal.rb (test_global_new_float): add a test for
	  the above changes.

	* test/bigdecimal/test_bigdecimal.rb (test_new_with_float): ditto.

Wed Jun  1 00:07:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_coerce): support coerce with a
	  Rational.  The precision used for instantiate a BigDecimal from the
	  given Rational is obtained from the receiver BigDecimal.

	* test/bigdecimal/test_bigdecimal.rb (test_coerce): add a test for the
	  above change.

Tue May 31 23:49:08 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (offset_to_sec): fixed invalid validation.

Tue May 31 23:43:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (GetVpValueWithPrec): replace the algorithm for
	  coercing from a Rational to stop requiring "bigdecimal/util.rb".
	  [ruby-core:34318]

	* ext/bigdecimal/bigdecimal.c (GetVpValue): refactoring.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_new): support instantiation from a
	  Rational.

	* test/bigdecimal/test_bigdecimal.rb (test_global_new_with_rational): add a
	  test for the above change.

	* test/bigdecimal/test_bigdecimal.rb (test_new_with_rational): ditto.

Tue May 31 22:44:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_new): support instantiation a
	  BigDecimal object from an Integer.

	* test/bigdecimal/test_bigdecimal.rb (test_new_with_integer):
	  add for testing the above change.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_global_new): replace its body
	  with a BigDecimal_new call.

	* test/bigdecimal/test_bigdecimal.rb (test_global_new_with_integer):
	  add for testing the above change.

Tue May 31 22:24:39 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: use simple/complex mode instead of light/right mode.
	* test/date/*.rb: followed the above changes.

Tue May 31 21:28:33 2011  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_signal.rb (TestSignal#test_signal_requiring):
	  initialize SIGINT handler.

Tue May 31 17:03:24 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* lib/net/http.rb, lib/net/protocol.rb: Allow to configure to wait
	  server returning '100 continue' response before sending HTTP request
	  body. See NEWS for more detail. See #3622.
	  Original patch is made by Eric Hodel <drbrain@segment7.net>.

	* test/net/http/test_http.rb: test it.

	* NEWS: Add new feature.

Tue May 31 14:17:49 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (rb_io_s_pipe): potential bug. the mode of read IO is set as
	  DEFAULT_TEXTMODE in call of io_set_encoding(), and of write IO is
	  also set as it in call of io_new_instance() via rb_protect().
	  so, if DEFAULT_TEXTMODE is not 0, we should check the result of
	  extract_binmode() and avoid crush of default IO mode and the result.

Tue May 31 13:00:17 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* strftime.c (rb_strftime_with_timespec): improved style consistency.
	  constified some variables.

	* test/test_time.rb (TestTime#test_huge_precision): test for #4456.

Tue May 31 12:53:10 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/io/wait/test_io_wait.rb (TestIOWait#{test_nread,test_ready?,
	  test_wait}: give system some time to process the written data.

Tue May 31 12:40:49 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_io.rb (TestIO#test_open_mode): MUST release resources
	  explicitly. fix problem of r31671

Tue May 31 10:49:55 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* vm_exec.c: remove conditions for clang
	  because clang version 3.0 (trunk 132165) doesn't need them.

Mon May 30 22:19:33 2011  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_signal.rb (TestSignal#test_signal_requiring): don't
	  close stderr.

Mon May 30 20:22:00 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_signal.rb (TestSignal#test_signal_requiring): small
	  but critical typo of r31642.  sorry...
	  [Bug #4798] [ruby-core:36550]

Mon May 30 15:44:16 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* insns.def (opt_mult): as r31805, volatile it.
	  Without this, clang -O fails calculation.

	* numeric.c (fix_mul): ditto.

	* rational.c (f_imul): ditto.

Mon May 30 10:26:51 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* numeric.c (int_pow): make sure to assign the result of x * z.
	  If xz is optimized out, the value won't overflow.

Sun May 29 23:17:29 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* re.c (rb_reg_match): fix rdoc of Regexp#=~.
	  patched by Tsuyoshi Sawada. [Bug #4781]

Sun May 29 23:10:42 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/webrick/https.rb (WEBrick::HTTPRequest#parse_uri):
	  keep parse_uri as private. patched by okkez. [Bug #4773]

Sun May 29 17:53:03 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* numeric.c: add #include "internal.h" for rb_big_uminus() prototype.

Sun May 29 15:09:05 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* numeric.c (flo_round): fix for negative value.

Sun May 29 02:16:53 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/net/http/utils.rb (TestNetHTTPUtils#teardown): add nil check.

Sun May 29 00:22:40 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (before_exec, after_exec): change from macro to function.

Sat May 28 19:30:17 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (before_exec, after_exec): change SIGPIPE handler to SIG_DFL
	  before calling execve(). Because r31760 reintroduced an issue that
	  system() may hang up (i.e. [ruby-dev:12261]).
	* process.c (save_sigpipe, restore_sigpipe): new.

Sat May 28 16:08:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c (Init_signal, default_handler): change default SIGPIPE handler
	  from empty function to SIG_IGN. [ruby-dev:43215]
	* signal.c (sigpipe): removed.

Sat May 28 03:04:27 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* io.c (fill_cbuf): return MORE_CHAR_SUSPENDED when cbuf is not empty.

Sat May 28 02:22:48 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* string.c (rb_str_bytesize): rb_str_bytesize() should use LONG2NUM().
	  Patch by Nikolai Weibull. [Bug #4789] [ruby-core:36511]

Sat May 28 02:06:26 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (fill_cbuf): Fix test-all crash.

Sat May 28 00:58:40 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/ostruct.rb (method_missing): Handle [] and []= correctly.
	  Based on a patch by Caius Durling, bug #4179 [ruby-core:33792]

Fri May 27 23:56:54 2011  Kouhei Sutou  <kou@cozmixng.org>

	* test/rexml/test_core.rb (Tester::test_text_frozen): split frozen
	  string test. refs #4783

Fri May 27 22:46:23 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/rbinstall.rb (gem): install gemspec of json.  fixed #4784

Fri May 27 22:45:10 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (validate_enc_binmode): do not clear textmode flag if
	  default.  fixed #4732

	* io.c (fill_cbuf): finish reading at EOF.

Fri May 27 11:31:51 2011  misfo <tedwardo2@gmail.com>

	* lib/rexml/text.rb (REXML::Text#initialize): prevent an error
	  when passing a frozen string to REXML::Text.new

	  dup the string passed in instead of cloning so that it's frozen
	  state is ignored

Fri May 27 08:47:26 2011  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* thread.c (ppoll): typo bug fix.

Fri May 27 08:35:04 2011  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: hang-up at exit before calling Tk.mainloop.

	* ext/tk/lib/tk/extconf.rb: cannot make on MinGW [Ruby 1.9 - Bug #4141].

Thu May 27 00:34:07 2011  James Edward Gray II  <jeg2@ruby-lang.org>

    * lib/csv.rb: Enhance each() to support Enumerator.

Thu May 26 10:32:11 2011  James Edward Gray II  <jeg2@ruby-lang.org>

    * lib/csv.rb: Documentation improvements from Ysiad Ferreiras.
      [Ruby 1.9 - Bug #4785]

Thu May 26 15:42:02 2011  Cezary Baginski <cezary.baginski@gmail.com>

	* lib/xmlrpc/parser.rb (FaultException): fix to_s and inspect

	* test/xmlrpc/parser.rb: test for the above

Wed May 25 11:54:31 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/curses/curses.c:  Remove color constants block.
	  [Ruby 1.9 - Bug #4748]

Wed May 25 09:56:45 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/curses/curses.c:  Add missing documentation for button state, MIN
	  and MAX comments.  Add Curses. to TABSIZE= and ESCDELAY= methods.
	  [Ruby 1.9 - Bug #4747]

Wed May 25 09:35:31 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/benchmark.rb:  Restore nodoc for Benchmark::Job and
	  Benchmark::Report.  [Ruby 1.9 - Bug #4726]

Wed May 25 09:29:38 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/net/pop.rb:  Hide implementation details from RDoc.
	  [Ruby 1.9 - Bug #4711]

Wed May 25 09:26:29 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/net/ftp.rb:  Add :nodoc: for private methods.
	  [Ruby 1.9 - Bug #4710]

Wed May 25 09:19:17 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/zlib/zlib.c:  Fix Document-method declarations.  Improve
	  Zlib::GzipFile's method catalog.  [Ruby 1.9 - Bug #4695]

Wed May 25 08:22:12 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/erb.rb:  Hide documentation for implementation details of ERB.
	  [Ruby 1.9 - Bug #4694]

Wed May 25 07:58:14 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/tempfile.rb (Tempfile.{mkdir,rmdir}): revert for backward
	  compatibility.

Wed May 25 07:13:12 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* spec/README: update the description.

Wed May 25 07:12:16 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/tempfile.rb (Tempfile.{lock,unlock}_tempfile): refactor.

Tue May 24 17:30:36 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* spec/README: fix typo.
	  patched by bowsersenior. https://github.com/ruby/ruby/pull/24

Tue May 24 07:06:34 2011  Hidetoshi NAGAI  <nagai@ai.kyutech.ac.jp>

	* ext/tk/lib/tk.rb: fail to start Tk.mainloop (exit immediately) on
	  some environment (reported on [ruby-talk:381444]).

	* ext/tk/lib/tk/canvas.rb: support creating a canvas item object from
	  an item ID number.

	* ext/tk/lib/tk/image.rb: import documents which are pull-requested.
	  [Ruby 1.9 - Feature #4595]

	* ext/tk/lib/tk/extconf.rb: search directories for 64bit library (e.g.
	  /usr/lib64), add some new configure options (see README.tcltklib),
	  and bug fix.

	* ext/tk/lib/tk/README.tcltklib: modify docs for some new configure
	  options.

Tue May 24 04:01:46 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* lib/yaml.rb: switch default YAML engine to Psych, old syck engine
	  may be enabled via YAML::ENGINE.yamler = "syck". [ruby-core:36374]

Mon May 23 09:45:26 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* include/ruby/defines.h (CASEFOLD_FILESYSTEM): Revert r30508. Forgot to
	  include this file in the commit r31692. __APPLE__ is not
	  CASEFOLD_FILESYSTEM again, from this time.

Mon May 23 10:01:02 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: Do not parse zero-tagged values as EOC. Do
	  not let current length become negative for infinite length constructed
	  values. Support constructed values of length zero. Added tests.

Mon May 23 09:19:53 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/net/smtp.rb:  Document Net::SMTP::Response.  Patch by J.R. Garcia.
	  [Ruby 1.9 - Bug #4768]

Mon May 23 09:03:52 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit/parallel.rb: Never Ignore SIGINT. When received
	Interrupt, immediately puts result and exit. [ruby-dev:43571]

	* lib/test/unit.rb: When received Interrupt, wait results from workers
	and collect them. [ruby-dev:43571]

Mon May 23 09:08:07 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/mathn.rb:  Improve documentation.  Patch by Sandor Szucs.
	  [Ruby 1.9 - Bug #4767]

Mon May 23 08:45:55 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/ostruct.rb:  Improve documentation.  Patch by Franklin Webber.
	  [Ruby 1.9 - Bug #4761]

Mon May 23 08:35:24 2011  Eric Hodel  <drbrain@segment7.net>

	* hash.c:  Improve documentation of Hash#key.  Patch by Utkarsh
	  Kukreti.  [Ruby 1.9 - Bug #4760]

Mon May 23 08:32:59 2011  Eric Hodel  <drbrain@segment7.net>

	* enumerator.c:  Improve documentation.  Patch by Dave Copeland.
	  [Ruby 1.9 - Bug #4757]

Mon May 23 07:19:45 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* NEWS (openssl): Infinite length support. Different behavior of
	  Constructive and Primitive constructors.

Mon May 23 06:58:33 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: Forbid Constructives whose value is not an
	  Array to prevent segfault. Added test.

Mon May 23 06:33:17 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: Forbid Constructive without infinite
	  length. This also prevents a segfault. Added test and improved
	  documentation.

Mon May 23 05:58:14 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: Fix decoding of infinite length values.
	  Simplified ossl_asn1_decode0 by splitting it into three separate
	  functions. Add tests.
	  [Ruby 1.9 - Bug #4374][ruby-core:35123]

Mon May 23 04:03:46 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c (ossl_asn1_initialize): Allow creation of
	  Constructives with an explicit tag_class parameter without
	  automatically setting tagging to :EXPLICIT. Fixes a bug when encoding
	  infinite length primitive values.

Mon May 23 04:03:46 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c (ossl_asn1_cons_to_der): Add an additional
	  EOC for infinite length Constructives that are supposed to be encoded
	  with explicit tagging. Also tabify method correctly.

Mon May 23 03:44:39 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c (ossl_asn1data_to_der): Remove redundant
	  flag tmp_cons.

Mon May 23 00:35:00 2001  Kenta Murata  <mrkn@mrkn.jp>

	* bignum.c (dump_bignum, bigmul1_balance, big_split, biglsh_bang),
	  (bigrsh_bang, big_split3, bigmul1_toom3, bigmul0): implement Toom3 (Toom-Cook)
	  multiplication.

	* include/ruby/defines.h: add format prefixes for BDIGIT and BDIGIT_DBL.

Sun May 22 23:24:02 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: Instead of rb_intern use static symbols to
	  improve performance.

Sun May 22 21:56:51 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: Use OpenSSL constants V_ASN1_xxx instead of
	  hardcoded numbers for initializing class_tag_map.

Sun May 22 21:29:29 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* include/ruby/defines.h (CASEFOLD_FILESYSTEM): Revert r30508. See #4255.
	  Now __APPLE__ is not CASEFOLD_FILESYSTEM again.

	* load.c (loaded_feature_path, rb_feature_p, load_lock): Revert r30508.
	  See #4255. Make $LOADED_FEATURES scanning case-sensitive again.

Sun May 22 18:59:27 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/ossl_asn1.c(ossl_asn1_default_tag): avoid using RCLASS_SUPER
	  to make it compilable. Plus, tabify and change variable definition style.

Sun May 22 18:26:43 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (vm_xcalloc): use calloc provided by platforms.
	  fixes #4754

Sun May 22 11:44:53 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/pty/pty.c:  Improve documentation.  Patch by David Copeland.
	  [Ruby 1.9 - Bug #4756]

Sun May 22 11:26:39 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/timeout.rb:  Improve documentation.  Patch by David Copeland.
	  [Ruby 1.9 - Bug #4755]

Sun May 22 11:21:41 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/ipaddr.rb:  Improve documentation.  Patch by Sandor Szucs.
	  [Ruby 1.9 - Bug #4753]

Sun May 22 11:14:40 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/forwardable.rb:  Document def_delegator.  Patch by Sandor Szucs.
	  [Ruby 1.9 - Bug #4752]

Sun May 22 11:11:41 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/fileutils.rb:  Document block behavior of FileUtils.cd.  Patch by
	  Bil Kleb.  [Ruby 1.9 - Bug #4751]

Sun May 22 11:07:47 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/curses/curses.c:  Complete documentation.  Patch by Vincent
	  Batts.  [Ruby 1.9 - Bug #4748]

Sun May 22 09:29:43 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_rubyoptions.rb (TestRubyOptions#test_set_program_name):
	  use spawn. it prevent that other tests inherit renamed $0.

Sun May 22 08:57:13 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: Default tag lookup in constant time via hash
	  instead of previous linear algorithm.
	  [Ruby 1.9 - Feature #4309][ruby-core:34813]

Sun May 22 07:54:16 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_digest.c: Explain DSS and DSS1 in documentation.

Sun May 22 07:10:25 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_pkey_dsa.rb: Add tests for sign/verify.

Sun May 22 06:07:17 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_x509cert.rb: Merge DSA-related tests from ruby_1_8
	  branch.

Sun May 22 04:11:12 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (Init_Thread): add a code comment why the meaningless
	  line is necessary.

Sun May 22 01:35:12 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: modified documentation.

Sat May 21 22:46:26 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_strftime(date_strftime_with_tmx): "%v" means "%e-%b-%Y".

Sat May 21 22:14:35 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_io_extract_modeenc): accept combination hash and
	  File::Constants. (eg. File.open('yo', :mode => File::WRONLY))
	  [Feature #4742][ruby-core:36338]
	* test/ruby/test_io.rb (TestIO#test_open_mode): new test.

Sat May 21 21:44:14 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/test_switch_hitter.rb: new.

Sat May 21 21:18:29 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_{core,parse}.c: moved nearly all core code from ext/date/lib.
	* ext/date/lib/{date,date/format}.rb: removed nearly all code.

Sat May 21 02:58:46 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/.document:  Add curses to documented extensions.
	* ext/curses/curses.c:  Improve documentation.  Patch by Vincent Batts.
	  [Ruby 1.9 - Bug #4747]

Sat May 21 02:51:01 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/bigdecimal/lib/bigdecimal/util.rb:  Improve documentation.  Patch
	  by Pete Higgins.  [Ruby 1.9 - Bug #4746]

Sat May 21 02:44:10 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/bigdecimal/lib/bigdecimal/jacobian.rb:  Document isEqual.  Patch
	  by Kuba Fietkiewicz.  [Ruby 1.9 - Bug #4744]

Sat May 21 02:22:34 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/date/lib/date/format.rb:  Document date formats.  Patch by
	  Clinton Nixon.  [Ruby 1.9 - Bug #4743]

Fri May 20 05:15:19 2011  Nobuhiro Iwamatsu  <iwamatsu@nigauri.org>

	* gc.c: Fix build on m68k by 'error: too few arguments to
	  function 'mark_locations_array''.

Fri May 20 04:23:42 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/scanf.rb:  Improve documentation.  Patch by Gabe McArthur.
	  [Ruby 1.9 - Bug #4735]

Fri May 20 00:58:01 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/trans/ibm737-tbl.rb: greek code page.  fixes #4738

Thu May 19 14:44:05 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_signal.rb (test_signal_requiring): skip on Windows.
	  we can send SIGINT only to pid 0 and the process itself.

Thu May 19 09:07:08 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib: revert r31635-r31638 and untabify with expand(1).

Thu May 19 07:47:26 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_pkey_rsa.rb: Add tests for sign/verify.

Thu May 19 07:19:16 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_pkey.c: Add documentation.

Thu May 19 07:06:56 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/benchmark.rb:  Fix indentation.
	* lib/net/imap.rb:  Fix indentation of regular expressions.

Thu May 19 06:36:11 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/net/imap.rb:  Fix indentation of EOF for heredoc.
	* lib/debug.rb (Commands):  Fix indentation of EOHELP for heredoc.

Thu May 19 06:30:38 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/mkmf.rb:  Fix indentation of EOM for heredoc.

Thu May 19 06:16:41 2011  Eric Hodel  <drbrain@segment7.net>

	* lib:  Convert tabs to spaces for ruby files per
	  http://bugs.ruby-lang.org/projects/ruby/wiki/DeveloperHowto#coding-style
	  Patch by Steve Klabnik [Ruby 1.9 - Bug #4730]
	  Patch by Jason Dew [Ruby 1.9 - Feature #4718]

Thu May 19 06:06:07 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/cgi/util.rb:  Improve documentation.  Patch by Clinton Nixon.
	  [Ruby 1.9 - Bug #4733]
	* lib/cgi/core.rb:  ditto
	* lib/cgi/cookie.rb:  ditto

Thu May 19 06:02:21 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/tempfile.rb:  Document Dir.mkdir and Dir.rmdir.  Patch by Clinton
	  Nixon.  [Ruby 1.9 - Bug #4728]

Thu May 19 05:57:52 2011  Eric Hodel  <drbrain@segment7.net>

	* encoding.c:  Improve documentation for Encoding#default_external and
	  Encoding#default_internal.

Wed May 18 22:45:26 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/lib/console/size.rb (IO#console_size): new
	  method.  (EXPERIMENTAL)

Wed May 18 22:41:51 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* internal.h: add for internal use only.

Wed May 18 22:36:43 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (setup_exception): internal exception should be hidden

Wed May 18 20:25:04 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* lib/timeout.rb (Timeout#timeout): don't leak "execution expired"
	  exception. [Bug #4283] [ruby-core:34534].

Wed May 18 06:09:24 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/cmath.rb:  Add some examples and improve documentation.  Patch by
	  Sandor Szucs.  [Ruby 1.9 - Bug #4727]

Wed May 18 05:40:31 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/benchmark.rb:  Remove nodoc from Benchmark::Job and
	  Benchmark::Report.  Patch by Sandor Szucs.  [Ruby 1.9 - Bug #4726]

Wed May 18 05:29:26 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/webrick/compat.rb:  Improve documentation.  Patch by Sandor
	  Szucs.  [Ruby 1.9 - Bug #4725]

Wed May 18 05:10:35 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/tracer.rb:  Improve documentation.  Patch by Richard Ramsden.
	  [Ruby 1.9 - Feature #4720]

Wed May 18 04:53:41 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/cmath.rb:  Improve documentation.  Patch by Jason Dew.
	  [Ruby 1.9 - Feature #4717]

Wed May 18 04:50:24 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/net/ftp.rb:  Improve documentation.  Patch by Vincent Batts.
	  [Ruby 1.9 - Bug #4710]

Wed May 18 03:14:49 2011  Eric Hodel  <drbrain@segment7.net>

	* test/test_singleton.rb:  Add tests from lib/singleton.rb.  Patch by
	  Pete Higgins.  [Ruby 1.9 - Bug #4715]

Wed May 18 03:03:07 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/singleton.rb:  Improve documentation.  Patch by Pete Higgins.
	  [Ruby 1.9 - Bug #4709]

Tue May 17 21:24:04 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_mutex_lock): remove remove_signal_thread_list() call.
	  It's meaningless because lock_interrupt doesn't call
	  add_signal_thread_list().

Tue May 17 20:20:49 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm_core.h (rb_thread_struct): add volatile to
	  transition_for_lock because it is not protected by lock.

Tue May 17 20:08:53 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* LEGAL (missing/{elf,tgamma,lgamma_r}.c): they've been replaced by
	  public domain implementations.

	* LEGAL (vsnprintf.c): it has moved to srcdir from missing/.

	* LEGAL (missing/crypt.c): list its original license.

Tue May 17 19:54:26 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* LEGAL (configure): add missing/setproctitle.c

Tue May 17 19:35:01 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>
	Fix FreeBSD test failure.

	* test/ruby/test_rubyoptions.rb (TestRubyOptions#test_set_program_name):
	  use ps -o command instead of ps -o cmd. FreeBSD doesn't support
	  -o cmd option.

Tue May 17 08:04:26 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_digest.c: Add documentation.

Tue May 17 07:14:58 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/net/http.rb:  Improve documentation of proxy configuration
	  methods.  Patch by Alf Mikula.  [Ruby 1.9 - Bug #4714]

Tue May 17 07:09:01 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/net/pop.rb:  Improve documentation.  Patch by Vincent Batts.
	  [Ruby 1.9 - Bug #4711]
	* lib/net/telnet.rb:  ditto

Tue May 17 07:00:41 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/net/http.rb:  Fix nodoc for Net::HTTP::version_1_1?.  Patch by
	  Alf Mikula.  [Ruby 1.9 - Bug #4713]

Tue May 17 06:56:26 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/optparse.rb:  Add link to make_switch to improve documentation.
	  Patch by David Copeland.  [Ruby 1.9 - Bug #4708]

Tue May 17 06:50:40 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/observer.rb:  Improve documentation.  Patch by David Copeland.
	  [Ruby 1.9 - Bug #4707]

Tue May 17 06:42:53 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/logger.rb:  Improve documentation.  Patch by David Copeland.
	  [Ruby 1.9 - Bug #4706]

Tue May 17 06:28:14 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/gserver.rb:  Improve documentation.  Patch by David Copeland.
	  [Ruby 1.9 - Bug #4705]

Tue May 17 06:21:15 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/cgi.rb: Add toplevel documentation to class CGI
	* lib/cgi/session.rb: Add overview documentation to CGI::Cookie
	* lib/cgi/html.rb:  Don't add CGI::TagMaker documentation to CGI.
	  Patch by David Copeland.  [Ruby 1.9 - Bug #4704]
	* lib/cgi/core.rb:  Clean up CGI documentation.  Patch by David
	  Copeland.  [Ruby 1.9 - Bug #4704]
	* lib/cgi/cookie.rb:  Clean up CGI::Cookie documentation.  Patch by
	  David Copeland.  [Ruby 1.9 - Bug #4704]

Tue May 17 05:52:30 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/digest: Improve documentation of Digest, Digest::HMAC and
	  Digest::SHA2.  Patch by Pete Higgins.  [Ruby 1.9 - Bug #4702]

Tue May 17 03:51:42 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/abbrev.rb:  Hide copyright and revision information from RDoc.
	  Inspired by patch from David Copeland, bug #4703.

Tue May 17 03:33:21 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/timeout.rb (module Timeout):  Hide internal constants.  Patch by
	  Pete Higgins.  [Ruby 1.9 - Bug #4701]

Mon May 16 11:21:09 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* configure.in, win32/Makefile.sub (RUBY_SO_NAME): add CPU as prefix
	  of RUBY_SO_NAME on x64/ia64 mswin/mingw.
	  [Feature #4602]

Mon May 16 08:00:05 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc.rb:  Update to RDoc 3.6.1, allows OpenSSL::Digest to be
	  found.

Mon May 16 05:49:54 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/drb/acl.rb:  Add documentation.

Mon May 16 05:13:20 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: Add documentation.

Mon May 16 00:32:05 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_signal.rb (TestSignal#test_signal_process_group):
	  skip if the platform doesn't have :pgroup capability. (i.e. skip
	  if mswin32)

Sun May 15 23:53:31 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/intern.h: resurrect old rb_fd_copy().
	* thread.c (rb_fd_copy): ditto.

Sun May 15 23:45:11 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/intern.h: remove rb_fd_copy() to rb_fd_dup() and
	  rb_w32_fdcopy() to rb_w32_fd_dup().
	* win32/win32.c: ditto.
	* thread.c: ditto.

Sun May 15 22:26:39 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* signal.c (rb_f_kill): accept '-SIGXXX' style signal with Symbol or
	  implicit convertion with #to_str. [ruby-dev:43169] fixes #4362
	* test/ruby/test_signal.rb (test_signal_process_group): add a test
	  for send signal to process group.

Sun May 15 21:22:35 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* cont.c (cont_init): clear macihne_stack_start/end of saved thread to
	  prevent mark machine stack of GC'ed Thread. root Fiber is not
	  initialized by fiber_init().
	  based on a patch by Serge Balyuk [ruby-core:35891] fixes #4612
	* test/ruby/test_fiber.rb (test_gc_root_fiber): add test for it.

Sun May 15 21:04:29 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (econv_init): revert r31353.  [ruby-dev:43512]

Sun May 15 03:39:35 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/zlib/zlib.c:  Improve documentation.  Patch by Vincent Batts.
	  [Ruby 1.9 - Bug #4695]

Sun May 15 03:23:46 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/erb.rb:  Document ERB::Compiler.  Patch by Simon Chiang.
	  [Ruby 1.9 - Bug #4694]

Sun May 15 00:58:47 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>
	fix mswin32 build error.

	* missing/setproctitle.c: add #ifdef HAVE_UNISTD_H.
	* win32/Makefile.sub (MISSING): add setproctitle.obj

Sat May 14 22:45:28 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* missing/setproctitle.c: add to include "ruby/util.h".

Sat May 14 19:52:22 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_rubyoptions.rb (TestRubyOptions#test_set_program_name):
	  add for $0 test.

Sat May 14 19:50:46 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* missing/setproctitle.c (compat_init_setproctitle): use
	  ruby_strdup() instead of strdup().

Sat May 14 19:37:31 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/missing.h: add setproctitle() declaration.
	* missing/setproctitle.c: added.
	* configure.in: add check for missing/setproctitle.c.

	* ruby.c (ruby_process_options): add to call compat_init_setproctitle().
	* ruby.c (set_arg0): remove all platform specific code. it's
	  moved to missing/setproctitle.c.
	* ruby.c (origarg): remove len field. It's no longer used.
	* ruby.c (get_arglen): removed.

	This patch makes a lot of cleanup set_arg0 related code and fixes
	[Feature #4689].

Sat May 14 17:42:21 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* process.c (rb_proc_times): improve documentation.
	  [ruby-core:35785] fixes #4581, reported by Andrew Grimm.

Sat May 14 12:12:54 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_pkey_dsa.rb: Add basic tests and tests that
	  ensure new public key PEM encoding behavior and ensure backward
	  compatibility.
	  [Ruby 1.9 - Bug #4422] [ruby-core:35328]
	* test/openssl/test_pkey_rsa.rb: Remove line with 'puts'.

Sat May 14 12:06:49 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/context.rb (class RDoc):  Fix infinite loop caused by
	  re-encountering BasicObject.

Sat May 14 10:32:36 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_pkey_rsa.rb: Add tests that ensure new public key
	  encoding behavior and also ensure backward compatibility.
	  [Ruby 1.9 - Bug #4421] [ruby-core:35327]

Sat May 14 09:50:10 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/yaml/dbm.rb:  Add documentation.  Patch by Justin Collins.
	  [Ruby 1.9 - Bug #4693]
	* lib/yaml/store.rb:  ditto

Sat May 14 09:31:43 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc.rb: Updated to RDoc 3.6

Sat May 14 07:30:29 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: released a new gem, so increasing version.

Sat May 14 05:08:32 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_digest.c
	* ext/openssl/ossl_pkey.c
	* ext/openssl/ossl_pkey.h
	* test/openssl/pkey/test_pkey_rsa.rb
	  Reverted premature commit. Sorry for the noise!

Sat May 14 05:02:58 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/uri.rb:  Add toplevel documentation.  Patch by Vincent Batts.
	  [Ruby 1.9 - Bug #4690]

Sat May 14 04:19:06 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* NEWS: Describe altered behaviour for RSA and DSA public key
	  encoding. [Ruby 1.9 - Bug #4421, Bug #4422]
	  [ruby-core:35327,35328]

Sat May 14 02:57:52 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/ipaddr.rb (unless Socket):  Document valid*? methods.  Patch by
	  Sebastian Martinez.  [Ruby 1.9 - Feature #4687]

Sat May 14 02:54:04 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rexml/functions.rb:  Add some documentation for REXML::Functions.
	  Patch by Sebastian Martinez.  [Ruby 1.9 - Feature #4688]

Sat May 14 02:51:42 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/resolv.rb:  Hide private method and state-tracking constants from
	  RDoc.  Patch by Mark Turner.  [Ruby 1.9 - Feature #4691]

Fri May 13 19:23:21 2011  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* numeric.c (flo_coerce): Add #flo_coerce documentation.
	  Patch by Sebastian Martinez.
	  https://github.com/ruby/ruby/pull/21

Fri May 13 18:42:22 2011  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* README.EXT: fix typo.  Patch by William Blackerby.
	  https://github.com/ruby/ruby/pull/19

	* README.EXT.ja: ditto.

Fri May 13 15:22:34 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_select): check invalid handle before doing
	  select operations.  see [ruby-dev:43513], [ruby-dev:43535]

Fri May 13 08:34:00 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/rdoc.rb:  Output summary after documentation report.
	* lib/rdoc/stats/normal.rb:  Don't output information for users when
	  we're not on a TTY

Fri May 13 07:49:02 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/fileutils.rb:  Hide internal methods from RDoc.  Patch by Darragh
	  Curran.  [Ruby 1.9 - Bug #4684]

Fri May 13 07:36:23 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/webrick/httpservlet/erbhandler.rb:  Add documentation.

Fri May 13 07:04:33 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/mathn.rb:  Fix indentation.  Patch by Jason Dew.
	  [Ruby 1.9 - Feature #4682]

Fri May 13 06:50:43 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/mathn.rb:  Add documentation.  Patch by Jason Dew.  [Ruby 1.9 -
	  Feature #4667]

Fri May 13 05:44:19 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/logger.rb (class Logger):  Document Logger#datetime_format.
	  Patch by Sergio Gil Perez de la Manga.  [Ruby 1.9 - Bug #4678]

Fri May 13 05:39:11 2011  Eric Hodel <drbrain@segment7.net>

	* re.c (Init_Regexp): Document option constants.  Patch by Vincent
	  Batts.  [Ruby 1.9 - Bug #4677]
	* lib/uri/common.rb (module URI):  Documentation for URI.  Patch by
	  Vincent Batts.  [Ruby 1.9- Bug #4677]
	* lib/uri/ftp.rb (module URI):  ditto
	* lib/uri/generic.rb (module URI):  ditto
	* lib/uri/http.rb (module URI):  ditto
	* lib/uri/https.rb (module URI):  ditto
	* lib/uri/ldap.rb (module URI):  ditto
	* lib/uri/ldaps.rb (module URI):  ditto
	* lib/uri/mailto.rb (module URI):  ditto
	* process.c (Init_process):  Document Process constants.  Patch by
	  Vincent Batts.  [Ruby 1.9- Bug #4677]

Fri May 13 05:16:38 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rss/atom.rb (module RSS):  Document URIs.  Patch by Mark Turner.
	  [Ruby 1.9 - #4671]
	* lib/rss/rss.rb (module RSS):  Document exception classes.  Patch by
	  Mark Turner.  [Ruby 1.9 - #4671]

Fri May 13 02:15:18 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (select_internal): remove unused variable (interrupt_flag).

Thu May 12 18:24:34 2011  Kouhei Sutou  <kou@clear-code.com>

	* configure.in: limit to "T" type for prefix of external symbols
	  because x86_64-w64-mingw32-gcc on Debian GNU/Linux generates the
	  following symbol:
	    0000000068483390 D _GLOBAL__F__conftest_external

	  Approved by nobu.

Thu May 12 14:50:52 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/dl/test_base.rb (Fiddle::LIBC_SO): its always msvc*.dll on
	  mswin/mingw.

Thu May 12 14:47:53 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/mkmf.rb (Logging.postpone): copy only when temporary logfile
	  exists.

Thu May 12 12:24:22 2011  Nobuhiro Iwamatsu  <iwamatsu@nigauri.org>

	* ext/openssl/ossl_ssl.c: By trunk@31346, function check of SSLv2 is
	  executed.
	  However, the problem is not revised in this.
	  This adds the control of using function of SSLv2 in made macro by
	  function check.

Thu May 12 08:10:46 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/set.rb (class Set):  Add nodoc to internal-use methods.  Patch
	  by Pete Higgins.  [Ruby 1.9 - Bug #4665]

Thu May 12 08:01:14 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_pkey_ec.c: Allow encryption when PEM-encoding
	  Elliptic Curve private keys.
	  [ruby-core:35329] [Bug #4423]

Thu May 12 07:54:59 2011  Eric Hodel  <drbrain@segment7.net>

	* object.c (rb_obj_equal):  Add documentation.  Patch by Vincent Batts.
	  [Ruby 1.9 - Bug #4664]
	* lib/rexml:  ditto
	* lib/mkmf.rb:  ditto
	* ext/socket/lib/socket.rb:  ditto

Thu May 12 07:30:08 2011  Eric Hodel  <drbrain@segment7.net>

	* Various .document files: Update .document files to match files which
	  have documentation.

Thu May 12 07:18:45 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_pkey_dsa.c: Use generic X.509 SubjectPublicKeyInfo
	  format for PEM-encoding DSA public keys.
	  [ruby-core:35328] [Bug #4422]

Thu May 12 06:27:31 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_pkey_rsa.c: Use generic X.509 SubjectPublicKeyInfo
	  format for encoding RSA public keys.
	  [ruby-core:35327] [Bug #4421]

Wed May 11 19:45:27 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/forwardable.rb: support 'delegate :foo => :bar' for to meet
	  by specification of RDOC.

Wed May 11 08:36:38 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/webrick: Add documentation for WEBrick::HTTPAuth

Wed May 11 03:06:35 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rss.rb: Add documentation for RSS.  Patch by Steve Klabnik.
	  [Ruby 1.9 - Bug #4663]

Tue May 10 14:50:32 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb: Add option for hiding skip messages when test
	  ends. #4657

	* test/testunit/test_hideskip.rb, test/testunit/test4test_hideskip.rb:
	  test for above.

Tue May 10 10:53:04 2011  Eric Hodel  <drbrain@segment7.net>

	* common.mk (rdoc): Add rdoc-coverage rule

Tue May 10 09:13:21 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/webrick: Add Documentation

Tue May 10 04:22:09  Eric Hodel  <drbrain@segment7.net>

	* lib/webrick/log.rb: Hide copyright info from ri
	* lib/webrick/httpstatus.rb: ditto
	* lib/webrick/htmlutils.rb: ditto
	* lib/webrick/httpversion.rb: ditto
	* lib/webrick/version.rb: ditto
	* lib/webrick/httpauth/userdb.rb: ditto
	* lib/webrick/httpauth/authenticator.rb: ditto
	* lib/webrick/accesslog.rb: ditto

Mon May  9 20:57:13 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/ruby/test_{complex,rational}.rb: added tests.

Mon May  9 20:29:44 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c (string_to_c_internal): a refactoring.

Mon May  9 18:33:05 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c: Improve documentation for String#start_with? and
	  String#end_with?. fixes #4652
	  patched by Andrew Grimm <andrew.j.grimm at gmail.com>

Mon May  9 13:49:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* complex.c (string_to_c_internal): support scientific notation.
	  patched by Tinco Andringa. https://github.com/ruby/ruby/pull/16
	  [ruby-core:36046][Bug #4655]

Mon May  9 11:52:48 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* numeric.c (int_ord): remove K&R style.
	  patched by Daehyub Kim. https://github.com/ruby/ruby/pull/17

Sun May  8 22:17:24 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/ruby/test_{complex2,complexrational}.rb: use skip.
	* test/date/*.rb: ditto.

Sun May  8 21:02:31 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/ruby/test_{complex2,complexrational}.rb: NEVER SKIP.

Sun May  8 21:01:21 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/test_date_base.rb: fixed.

Sun May  8 20:54:11 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/*.rb: NEVER SKIP.

Sun May  8 20:37:33 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/*.rb: reverted 31432.

Sun May  8 20:32:43 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/*.rb: reverted 31483.

Sun May  8 19:39:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (native_cond_timedwait): add to care EINTR.
	* thread_pthread.c (thread_timer): remove EINTR check.

Sun May  8 19:04:15 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/time.rb (xmlschema): avoid passing any negative numbers.

Sun May  8 18:40:03 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_{parse,strptime}.c: introduced some macros.

Sun May  8 17:17:13 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/*.rb: use skip /w messages.

Sun May  8 17:04:55 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/lib/date/format.rb (_httpdate): omitted to call zone_to_diff.

Sun May  8 16:56:19 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (date_s_test_*): use macros.

Sun May  8 10:24:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c: cleanup signal_thread_list related ifdef.
	  1) we don't have to use #ifdef FOO-PLATFORM directly 2) About
	  half #ifdef didn't care symbian properly.

Sun May  8 05:19:37 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/io/wait/test_io_wait.rb: Linux socketpair(2) only support
	  AF_UNIX, but windows socketpair doesn't support it. we can't
	  avoid platform check. sigh!

Sun May  8 00:13:05 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/io/wait/test_io_wait.rb: use Socket.pair instead of pipe.
	  Windows can only treat a socket.

Sat May  7 22:43:48 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_fd_zero): remove redundant zero fill.

Sat May  7 22:38:04 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_fd_init): remove volatile qualifier.

Sat May  7 22:34:29 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_fd_init_copy): new internal api. It provide efficient
	  copy constructor semantics.
	* thread.c (do_select): use rb_fd_init_copy().

Sat May  7 15:18:06 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>
	fix incorrect native_cond_signal call when deadlock was detected.

	* thread.c (lock_func): decrement cond_waiting if timeout was happen.

Sat May  7 18:28:37 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (USE_MONOTONIC_COND): check the availability
	  more strictly.

	* thread_pthread.h (rb_thread_cond_t): ditto.

Sat May  7 15:15:10 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	fix win32 native_cond_timedwait() makes SIGSEGV.

	* thread_win32.h (rb_thread_cond_struct): add prev field instead of
	  last. (ie cond_event_entry is now using double linked list instead of
	  single)
	* thread_win32.c (cond_event_entry): add prev field.

	* thread_win32.c (__cond_timedwait): remove entry properly if timeout
	  was happen.

	* thread_win32.c (native_cond_signal): change for double linked list.
	* thread_win32.c (native_cond_broadcast): ditto.
	* thread_win32.c (native_cond_initialize): ditto.

Sat May  7 12:41:04 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>
	fix mutex deadlock test hang-up.

	* thread_win32.c (abs_timespec_to_timeout_ms): fix 1000x calculation
	  mistake. (ie fix hang-up native_cond_timedwait())

Sat May  7 03:14:13 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	sleep_cond use monotonic time if possible.

	* thread_pthread.c (native_thread_init): change sleep_cond
	  attribute to monotonic.
	* thread_pthread.c (native_sleep): use native_cond_timeout().

	* thread_pthread.c (native_cond_timeout): add overflow care.
	* thread_win32.c (native_cond_timeout): ditto.

Sat May  7 02:49:12 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>
	  fix win32 compile error.

	* thread_win32.c (RB_CONDATTR_CLOCK_MONOTONIC): define
	  RB_CONDATTR_CLOCK_MONOTONIC always.
	* thread_pthread.c (RB_CONDATTR_CLOCK_MONOTONIC): ditto.

Sat May  7 02:29:41 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	  mutex: deadlock check timeout use monotonic time.

	* thread_pthread.c (native_cond_timeout): new internal api.
	  it calculate a proper time for argument of native_cond_timedwait().
	* thread_win32.c (native_cond_timeout): ditto.

	* thread_pthread.c (thread_timer): use native_cond_timeout()
	  instead of get_ts.
	* thread.c (lock_func): ditto.

	* thread_pthread.c (get_ts): removed. use native_cond_timeout().
	* thread.c (init_lock_timeout): ditto.

Sat May  7 01:54:21 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (get_ts): add monotonic clock capability.
	* thread_pthread.c (rb_thread_create_timer_thread): use monotonic
	  clock if possible.

Sat May  7 01:43:37 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.h (rb_thread_cond_t): add clockid field. it's
	  no longer an alias of pthread_cond_t.
	* thread_pthread.c: adapt new rb_thread_cond_t type.
	* thread.c (mutex_alloc): ditto.
	* thread_win32.c (native_cond_initialize): ditto.
	* configure.in: add check for pthread_cond_attr_setclock() and
	  clockid_t type.

Fri May  6 23:29:47 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_wait_for_single_fd): use ppoll() instead of poll()
	  if possible. based on a patch from Eric Wong. [ruby-core:36003].

Fri May  6 23:13:43 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: remove nanosleep check. we no longer use it.
	  r20124 removed last usage.

Fri May  6 22:35:56 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/syck/rubyext.c (mktime_do): extra digits are not used.

Fri May  6 17:43:07 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/syck/rubyext.c (mktime_do): remove unused variable offset.

	* ext/syck/syck.h: use #ifdef instead of #if DEBUG.

Fri May  6 16:27:33 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/date/date_core.c (DAY_IN_NANOSECONDS): refix: 31438.
	  check with LONG_MAX and cast as long; without this the calculation
	  will be done as int and overflow.

Fri May  6 15:01:11 2011  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* ext/syck/rubyext.c (mktime_do): avoid buffer overrun, by
	  silently ignoring lesser significant digits.  Required buffer
	  length can be computable so you might at first think of
	  allocating enough memory space on the fly using alloca().  That
	  is a wrong idea because when using alloca there is always risk
	  of integer overflow.  A function that accepts outer-process
	  resources like this should not blindly trust its inputs.  In
	  this particular case we just want to generate milliseconds
	  resolution by strtod() so the string in question needs no more
	  length than what we originally have.  Ignoring lesser
	  significant digits should suffice I believe.

Fri May  6 14:25:53 2011  Tinco Andringa <mail@tinco.nl>

	* ext/syck/rubyext.c (mktime_do): YAML.load time correctly parse
	  usecs smaller than 1 fixes #4571

Thu May  5 22:23:34 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (native_mutex_reinitialize_atfork): removed
	  unused macro.
	* thread_win32.c (native_mutex_reinitialize_atfork): ditto.

Thu May  5 22:09:39 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_core.c (DAY_IN_NANOSECONDS): long long int is not
	  available on all platforms.

Thu May  5 17:36:31 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* eval.c (frame_func_id): store result of method_entry_of_iseq() to
	  cfp->me because method_entry_of_iseq() might become expensive.

Thu May  5 15:03:51 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* eval.c (frame_func_id): __method__ return different name from
	  methods defined by Module#define_method with a same block.
	  [ruby-core:35386] fixes #4606
	* eval.c (method_entry_of_iseq): new helper function. search control
	  frame stack for a method entry which has given iseq.
	* test/ruby/test_method.rb: add tests for #4606

Wed May  4 22:13:09 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/bm_vm4_pipe.rb: Reduced iterations. Too slow benchmark
	  is bad.
	* benchmark/bm_vm4_thread_pass.rb: ditto.

Wed May  4 22:08:22 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/date/test_date_base.rb: don't use no message skip().

Wed May  4 21:11:28 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/bm_io_select2.rb: reduce number of using file
	  descriptors. because gdb need some fds.

Wed May  4 19:00:59 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_wait_for_single_fd): Fix wrong return value.
	* test/-ext-/wait_for_single_fd/test_wait_for_single_fd.rb
	  (TestWaitForSingleFD#test_wait_for_closed_pipe): test for it.

Wed May  4 18:46:39 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/-test-/wait_for_single_fd: New. for testing
	  rb_wait_for_single_fd() internal function.
	  The patch was written by Eric Wong. [ruby-core:35991]

	* test/-ext-/wait_for_single_fd/test_wait_for_single_fd.rb: ditto.

Wed May  4 12:46:25 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_wait_for_single_fd): Added POLLNVAL check.
	  based on a patch from Eric Wong at [ruby-core:35991].

Wed May  4 11:51:01 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_f_select): remove useless ifdef.

Wed May  4 11:42:47 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/socket/init.c (wait_connectable): fix error handling code.
	  RB_WAITFD_OUT is turned on even though an error occur.

Wed May  4 10:12:39 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/readline/readline.c (readline_event): use rb_wait_for_single_fd().
	The patch was written by Eric Wong. [Ruby 1.9 - Feature #4531]

Wed May  4 10:10:28 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/socket/init.c (wait_connectable): use rb_wait_for_single_fd().
	  The patch was written by Eric Wong. [Ruby 1.9 - Feature #4531]

	* ext/socket/init.c (try_wait_connectable, wait_connectable_ensure):
	  removed.

Wed May  4 10:07:48 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/io/wait/wait.c (io_wait): use rb_wait_for_single_fd().
	  The patch was written by Eric Wong. [Ruby 1.9 - Feature #4531]

Wed May  4 10:01:27 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_wait_for_single_fd): new. poll(2) based backend for
	  rb_wait_for_single_fd().
	  Now only Linux uses it.

	The patch was written by Eric Wong. [Ruby 1.9 - Feature #4531]

Wed May  4 09:56:57 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_wait_for_single_fd): new.
	* thread.c (select_single): select(2) based backend for
	  rb_wait_for_single_fd().

	* io.c (make_writeconv): use rb_wait_for_single_fd() instead of
	  rb_thread_fd_select().
	* io.c (rb_io_wait_readable): ditto.
	* thread.c (rb_thread_wait_fd_rw): ditto.

	* io.c (wait_readable): removed.
	* thread.c (init_set_fd): new helper function.
	* include/ruby/io.h (RB_WAITFD_IN, RB_WAITFD_PRI, RB_WAITFD_OUT):
	  new constant for rb_single_wait_fd().

	The patch was written by Eric Wong. [Ruby 1.9 - Feature #4531]

Wed May  4 08:04:59 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: fix time dumping so that
	  Syck can load UTC times that Psych dumps.

Wed May  4 07:33:00 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_fd_copy): fix wrong argument.This issue was pointed
	  out by Eric Wong. [ruby-core:35982]

Tue May  3 20:29:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/fileutils/test_fileutils.rb (TestFileUtils#test_chmod_symbol_mode):
	  Skip sticky bit test if the platform is FreeBSD. It doesn't allow to
	  change sticky bit if a target is regular file.

Tue May  3 18:23:57 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* test/date/test_date.rb (TestDate#test_coerce):
	  test for [ruby-core:35127].

Tue May  3 04:27:53 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_thread_select): preserve errno if no error
	  occurred.

Tue May  3 03:57:04 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/intern.h (rb_w32_fdcopy): add prototype.  fixes
	  #4640

Mon May  2 01:02:04 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* lib/fileutils.rb (FileUtils#chmod): accept symbolic mode argument.
	  The patch was written by takkanm. [ruby-core:26029][Feature #2190]

	* lib/fileutils.rb (FileUtils#fu_mode): new helper function.
	* lib/fileutils.rb (FileUtils#symbolic_modes_to_i): ditto.
	* lib/fileutils.rb (FileUtils#mode_mask): ditto.
	* lib/fileutils.rb (FileUtils#user_mask): ditto.

	* test/fileutils/test_fileutils.rb (TestFileUtils#test_chmod_symbol_mode):
	  new test for the above symbolic mode.
	* test/fileutils/test_fileutils.rb (TestFileUtils#test_chmod_R): ditto.

Mon May  2 00:36:12 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/socket/init.c (rsock_connect): add to care EINTR. based
	  on a patch from Eric Wong at [ruby-core:35621][Bug #4555]

Sun May  1 01:06:24 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_select): release GVL while waiting select().

Sat Apr 30 23:10:15 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* win32/win32.c (rb_w32_fdcopy): New. This can copy even though
	  fdset size exceed FD_SETSIZE.
	* include/ruby/intern.h (rb_fd_copy): use rb_w32_fdcopy()

Sat Apr 30 20:18:43 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (do_select): Change argument type to rb_fdset_t.
	  Now do_select() is free from unexpected hangup if
	  HAVE_RB_FD_INIT=1 [Bug #4636]

	* thread.c (rb_thread_fd_select, rb_thread_wait_fd_rw):
	  adapt new argument type.

	* thread.c (rb_thread_select): make dummy implementation.

Sat Apr 30 20:16:53 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_fd_copy): Change function argument. Now
	  rb_fd_copy() has fully copy semantics.
	* include/ruby/intern.h: ditto.

Sat Apr 30 20:11:47 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/intern.h (rb_thread_select): mark as deprecated.

	* ext/io/wait/wait.c (wait_readable): use rb_thread_fd_select
	  instead of rb_thread_select.
	* ext/socket/init.c (wait_connectable0): ditto.
	* ext/readline/readline.c (readline_event): ditto.
	* io.c (rb_io_wait_readable, wait_readable, rb_io_wait_writable,
	  wait_writable): ditto.

Sat Apr 30 20:06:36 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (do_select): remove useless ifdef. time calculation
	  is not heavy weight.

Sat Apr 30 16:48:36 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/bm_io_select3.rb: New.

Sat Apr 30 16:27:09 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (copy_stream_body, rb_io_s_copy_stream): move rb_fd_init()
	  from copy_stream_body to rb_io_s_copy_stream. fds of passing
	  rb_fd_term() have to be guaranteed initialized.

Sat Apr 30 16:13:17 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/bm_io_select.rb, benchmark/bm_io_select2.rb: New.
	  based on a patch from Eric Wong at [Feature #4531]

Sat Apr 30 03:25:53 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/io/wait/test_io_wait.rb: New. for testing ext/io/wait.
	  the patch was written by Eric Wong. [Feature #4531]

Sat Apr 30 00:34:56 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/win32.h: remove redundant declaration of
	  rb_w32_time_subtract().

Sat Apr 30 00:16:40 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (gvl_init): fix hangup if GVL_SIMPLE_LOCK=1.
	  We don't have to call mutex_unlock() before initialize it!

Fri Apr 29 13:15:15 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_win32.c (native_cond_timedwait): New. r31373 caused
	  win32 build failure.

	* thread_win32.c (__cond_timedwait, abs_timespec_to_timeout_ms):
	  New helper functions.

	* win32/win32.c (rb_w32_time_subtract): rename from subtract and
	  remove static.

Fri Apr 29 10:43:09 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/bm_vm4_pipe.rb: Add two new benchmark for GVL
	  performance. They was written by Koichi Sasada.
	* benchmark/bm_vm4_thread_pass.rb: ditto.

Fri Apr 29 10:25:31 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm_method.c (rb_clear_cache_by_class): Revert r29673. It made
	  a segmentation fault regression. [Bug #4289][ruby-core:34554].

Fri Apr 29 10:24:51 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (make_writeconv): do not add textmode newline decorator if any
	  newline decorator is set already.  fixes #4618, fixes #4619

Fri Apr 29 10:17:42 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (lock_func): small cleanup.

Fri Apr 29 10:07:13 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_mutex_lock, lock_func): Avoid busy loop and
	  performance regression. bm_vm3_thread_mutex.rb performance
	  change from 109.064sec to 16.331sec. [Feature #4607]

	* thread.c (init_lock_timeout): New helper function.

Thu Apr 28 16:15:49 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/{win32.c,dir.h} (rb_w32_uopendir): new API to pass UTF-8 path.

	* win32/win32.c (opendir_internal, rb_w32_opendir): extract and merge
	  common part of rb_w32_opendir() and rb_w32_uopendir().

	* dir.c (do_opendir, glob_helper): encoding.

	* dir.c (dir_initialize, do_opendir): convert path to UTF-8 and call
	  rb_w32_uopendir() instead of rb_w32_opendir() on Windows.
	  fixes #4491, reported by Joey Zhou.

Thu Apr 28 15:32:53 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/dl/test_base.rb (DL::LIBC_SO): its always msvc*.dll on
	  mswin/mingw.

Thu Apr 28 06:07:06 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/csv.rb (CSV::open): suppress universal newline decorator.
	  fixes #4603

	* lib/csv.rb (CSV.read): no mode is needed.

Thu Apr 28 06:06:56 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_extract_modeenc, rb_f_backquote): set default text
	  mode.  fixes #4619

	* io.c (pipe_open): set universal newline decorator if needed.

Wed Apr 27 11:33:08 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* enc/trans/emoji_iso2022_kddi.trans: ISO-2022-JP-KDDI doesn't have
	  CP932 UDA. Another reason is emacs-mule: the implementation of
	  stateless-iso-2022-jp doesn't support beyond 94x94 (0x7fxx);
	  but CP932 UDA is in 7Fxx-92xx.

Wed Apr 27 07:42:44 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (STRIP): use proper toolchain.  based on a patch
	  from Jon Forums at [ruby-core:35909].  fixes #4617

Wed Apr 27 01:20:59 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (date_zone_to_diff): renamed.
	* ext/date/date_parse.c: ditto.
	* ext/date/date_strptime.c: ditto.

Wed Apr 27 01:16:59 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (enc_find): accept Encoding objects.

Wed Apr 27 00:55:56 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (econv_opts): add newline option.

	* io.c (validate_enc_binmode, rb_io_extract_modeenc): set newline
	  decorator according to open mode.

	* transcode.c (rb_econv_prepare_options): new function, to prepare
	  econv options with newline flags.

	* include/ruby/encoding.h (ECONV_NEWLINE_DECORATOR_MASK): add.

Wed Apr 27 00:51:01 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_file_truncate): fix function.

	* include/ruby/win32.h (ftruncate, truncate, ftello, fseeko): non-64
	  versions on mingw are useless because they use int32_t.  fixes #4564

Wed Apr 27 00:50:33 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: modified validation methods.
	* ext/date/lib/date.rb: ditto.

Wed Apr 27 00:00:37 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (dt_lite_set_tmx): should get df value.

Tue Apr 26 22:34:04 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/lib/date/format.rb (_iso8601): allowed day only civil
	  date.  disallowed separatorless day only ordinal date.

Mon Apr 25 21:31:36 2011  Nobuhiro Iwamatsu  <iwamatsu@nigauri.org>

	* ext/openssl/extconf.rb: Should check SSLv2_*method.
	  openssl compiled with "no-ssl2" the extconf don't fail
	  when running `make' having this compilation errors.
	  Patched by Laurent Arnoud. fixes #4562, #4556

Mon Apr 25 20:53:32 2011  Tajima, Akio <artonx@yahoo.co.jp>

	* win32/win32.c (kill): accept 0 only sig is SIGINT #4596

Mon Apr 25 19:59:47 2011  Tajima, Akio <artonx@yahoo.co.jp>

	* win32/win32.c (kill): accept 0 as pid, fixes #4596

Mon Apr 25 16:43:45 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* random.c (random_rand): remove unused variables.

	* struct.c (rb_struct_define_without_accessor): ditto.

	* strftime.c (rb_strftime_with_timespec): ditto.

	* sprintf.c: ditto.

	* time.c (time_asctime): remove useless GetTimeval().

	* thread_pthread.c: cast to (void *) for %p.

Mon Apr 25 11:02:11 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/ripper/lib/ripper/sexp.rb: fix rdoc around sexp.
	  patched by Sho Hashimoto. fixes #4599

Mon Apr 25 08:24:04 2011  Shota Fukumori  <sorah@tubusu.net>

	* random.c (rb_f_rand, random_s_rand): RDocs for them.

Mon Apr 25 07:18:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* random.c (random_s_rand, Init_Random): Random.rand should behave as
	  Random::DEFAULT.rand rather than Kernel#rand.

	* random.c (rand_range, random_rand): rand_range function extracted
	  from random_rand function.

	* random.c (rb_f_rand): accept a Range argument as Random#rand
	  [ruby-dev:43427] #4605

Mon Apr 25 03:31:06 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/time.rb: require 'date'.
	* ext/date/lib/date/format.rb: removed require line.

Mon Apr 25 03:08:39 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/lib/date/format.rb: require 'date'.

Mon Apr 25 03:04:16 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/lib/date/format.rb (_iso8601): added a pattern.

Mon Apr 25 02:51:22 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/date/lib/date/format.rb: require 'date_core.so'.
	  date/format needs methods which are now in date_core.so.
	  This breaks make rdoc which uses Date._parse from time.rb.

Mon Apr 25 02:47:46 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/lib/date/format.rb (_iso8601): fixed a bug of regex.

Mon Apr 25 02:12:26 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/lib/date/format.rb: an adjustment of regex.

Mon Apr 25 01:58:50 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/lib/date/format.rb: omitted to call _parse.

Mon Apr 25 01:03:03 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* string.c (rb_to_id): remove unused variable.

Sun Apr 24 22:19:05 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c, rational.c: omitted some method calls.

Sun Apr 24 02:57:27 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_parse.c (n2i): takes long.

Sun Apr 24 02:51:06 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_parse.c: reverted.

Sun Apr 24 02:25:23 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* include/ruby/intern.h: pcc can't use __builtin_constant_p.

	* vm_exec.c: change condition.

Sun Apr 24 01:58:01 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/date/date_core.c (leap_p): suppress warning: parentheses.

	* ext/date/date_core.c (date_s__parse_internal): remove unused
	  variable "str".

	* ext/date/date_parse.c (parse_ddd_cb): use RSTRING_LENINT.

	* ext/date/date_strftime.c (date_strftime_with_tmx): remove unused
	  variable.

Sun Apr 24 00:34:23 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_parse.c: removed some unused macros.  use strchr()
	  instead of index().

Sat Apr 23 21:29:42 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: replacement of implementation of
	  _parse.  [experimental]
	* ext/date/date_parse.c: new.
	* ext/date/lib/date/format.rb: removed ruby version of _parse.

Fri Apr 22 12:04:15 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* array.c (rb_ary_sort_bang): fix rdoc.
	  patched by burningTyger. https://github.com/ruby/ruby/pull/11

Fri Apr 22 11:49:49 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/xmlrpc/create.rb (XMLRPC::Create#conv2value):
	  XML-RPC's int is 32bit int, and Fixnum also may be beyond 32bit.

	* lib/xmlrpc/create.rb (XMLRPC::Create#conv2value):
	  XML-RPC doesn't allow Infinity and NaN.
	  http://www.xmlrpc.com/spec

Fri Apr 22 04:16:14 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/parser.c (parse): strings from psych have proper taint
	  markings.

	* test/psych/test_tainted.rb: test for string taint

Thu Apr 21 01:30:02 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* random.c (rb_f_srand): fix rdoc: srand(0)'s 0 is a seed.
	  [ruby-core:35833] fixes #4590

Thu Apr 21 01:01:28 2011  Masaya Tarui  <tarui@ruby-lang.org>

	* win32/win32.c (CreateChild): maximum length of lpCommandLine is
	  32,768 characters, including the Unicode terminating null character.

Wed Apr 20 21:32:11 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_strptime.c (date__strptime_internal): do not
	  overwrite local variables.

Wed Apr 20 14:41:28 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_str_each_line): check string's length when compare
	  separator and string. [ruby-core:35815] fixes #4586

Wed Apr 20 00:02:13 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-parse-partial): use position of open paren.

Tue Apr 19 01:00:21 2011  Tajima Akio <artonx@yahoo.co.jp>

	* test/ruby/test_io.rb (TestIO#test_cross_thread_close_fd):
	  skip cross thread pipe close if windows

Mon Apr 18 12:15:46 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_range.rb (TestRange#test_step_ruby_core_35753):
	  avoid float error. [ruby-core:35804]

Sun Apr 17 00:20:14 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_{core,strftime}.c: use struct tmx instead of vtm.
	* ext/date/date_tmx.h: new.

Sat Apr 16 22:23:52 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_strftime.c (date_strftime_wo_timespec): changed
	  the way of validation of locale modifiers.

Sat Apr 16 21:55:12 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: replacement of implementation of
	  _strptime.  [experimental]
	* ext/date/date_strptime.c: new.
	* ext/date/lib/date/format.rb: removed ruby version of _strptime.

Sat Apr 16 10:18:30 2011  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* vm.c (Init_VM): suppress warning: "OPT_BASIC_OPERATIONS" is not
	  defined.

Fri Apr 15 23:41:18 2011  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* ruby.c (proc_options): suppress warning:
	  "ALLOW_DEFAULT_SOURCE_ENCODING" is not defined.

Fri Apr 15 15:10:29 2011  Akinori MUSHA  <knu@iDaemons.org>

	* lib/uri/generic.rb (#route_from_path): Fix a bug where
	  URI('http://h/b/').route_to('http://h/b') wrongly returned './'
	  (should be '../b'). [Bug #4476]

Fri Apr 15 14:58:06 2011  Akinori MUSHA  <knu@iDaemons.org>

	* lib/fileutils.rb (FileUtils#touch): Fix corrupted output when
	  mtime is specified in addition to nocreate (and verbose).
	  ref [ruby-dev:43401]

Thu Apr 14 23:43:43 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* numeric.c (ruby_float_step): wrong loop condition.
	  fixes [ruby-core:35753], reported by Joey Zhou.

	* test/ruby/test_range.rb (TestRange#test_step_ruby_core_35753):
	  test above change.

Thu Apr 14 22:48:12 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit.rb (Test::Unit::Options#setup_options): set possible
	  values for completion. no conversion is needed.

	* lib/test/unit.rb (Test::Unit::Runner::Worker#initialize): use
	  positional arguments instead of keyword arguments.

	* lib/test/unit.rb (Test::Unit::Runner#jobs_status): io/console may
	  not be available. use 80 as the last resort if IO#winsize and
	  COLUMNS are unavailable.

	* lib/test/unit.rb (Test::Unit::Runner::Worker#died): rename using a
	  verb.

	* lib/test/unit.rb (Test::Unit::Runner#_run_parallel): check if worker
	  is signaled and use its exit status.

	* lib/test/unit.rb (Test::Unit::Runner::Worker#dead): no longer @in
	  and @out are separated.

Thu Apr 14 21:23:29 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* variable.c (rb_autoload_p): search superclasses as same as actual
	  loading.  fixes [ruby-core:35679]

Thu Apr 14 21:21:06 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/win32.h (frexp, modf): wrongly declared as pure in
	  mingw math.h.

	* include/ruby/win32.h (ftruncate, truncate): mingw64 misses
	  prototypes.

	* win32/win32.c (rb_w32_read): suppress warning.

Thu Apr 14 19:55:54 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* lib/fileutils.rb (FileUtils#touch): fix corrupted output when
	  FileUtils.touch(:nocreate => true, :verbose => true) case.
	  The patch was written by Hiroyuki Iwatsuki. [ruby-dev:43401]

Thu Apr 14 16:01:45 2011  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* io.c (rb_f_syscall): suppress warning: "HAVE___SYSCALL" is not
	  defined.

Thu Apr 14 00:41:09 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* thread.c (thread_fd_close_i): IOError exception should be assigned
	  to rb_thread_t::thrown_errinfo.

Wed Apr 13 20:12:26 2011  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* io.c (rb_io_fdatasync): remove unused variable.

Tue Apr 12 20:54:12 2011  Tanaka Akira  <akr@fsij.org>

	* include/ruby/st.h: parenthesize macro arguments.

Tue Apr 12 19:19:50 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/common.rb: avoid race condition. fixes #4572

Tue Apr 12 18:07:13 2011  TAKAO Kouji  <kouji@takao7.net>

	* ext/readline/extconf.rb: --disable-libedit to disable
	  libedit. fixes #4550

Tue Apr 12 10:37:39 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/win32.h: VC doesn't have ftruncate() and others, but
	  ruby needs HAVE_ macros to use our emulation functions.
	  (fix the problem of 31262)

Tue Apr 12 01:33:00 2011  Luis Lavena  <luislavena@gmail.com>

	* configure.in: properly evaluate existence of truncate, ftruncate
	  and ftello for MinGW. [ruby-core:35678]
	* win32/win32.c: rename truncate, ftruncate and ftello to avoid
	  redefinitions.
	* win32/win32.h: ditto.

Mon Apr 11 21:51:52 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c: revert r31230. Because it made a regression.
	  [ruby-core:35631]

Mon Apr 11 21:49:18 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_io.rb: Added TestIO#test_cross_thread_close_stdio
	  and TestIO#test_cross_thread_close_fd.
	  The patch was written by Eric Wong. [ruby-core:35669]

Mon Apr 11 21:15:54 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* file.c (rb_group_member): kill 256K of stack usage.
	  the patch was written by Eric Wong. [ruby-core:35699]

Mon Apr 11 07:24:13 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/openssl/ossl.c:  Fix typo, document version constants.

Sun Apr 10 22:23:45 2011  Tanaka Akira  <akr@fsij.org>

	* include/ruby/ruby.h: parenthesize macro arguments.

Sat Apr  9 23:31:47 2011  Shota Fukumori  <sorah@tubusu.net>

	* ext/stringio/stringio.c (strio_each, strio_readlines):
	  Use `NUM2LONG` instead of `FIX2INT`. Fixes [ruby-dev:43395].

Sat Apr  9 23:22:27 2011  Shota Fukumori  <sorah@tubusu.net>

	* ext/stringio/stringio.c (strio_each):
	  Fix exception message and don't raise immediately if block is not
	  given.
	  Fixes [ruby-dev:43394].

	* test/stringio/test_stringio.rb (test_each_line_limit_0):
	  Fix test for above.

Sat Apr  9 21:54:15 2011  Shota Fukumori  <sorah@tubusu.net>

	* ext/stringio/stringio.c (strio_each, strio_readlines):
	  limit must not be zero. Fixes [ruby-dev:43392].

	* test/stringio/test_stringio.rb: Add tests for above.

Sat Apr  9 18:01:36 2011  Tanaka Akira  <akr@fsij.org>

	* include/ruby/util.h: parenthesize macro arguments.

Fri Apr  8 16:01:56 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/stringio/stringio.c (strio_getline): check whether str is
	  a string when str and lim are given.
	  https://twitter.com/watson1978/status/56225052152168449

Thu Apr  7 20:03:52 2011  Tanaka Akira  <akr@fsij.org>

	* include/ruby/io.h: parenthesize macro arguments.

Wed Apr  6 21:08:31 2011  Tanaka Akira  <akr@fsij.org>

	* include/ruby/intern.h: parenthesize macro arguments.

Wed Apr  6 15:12:40 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_pkey_dh.c (ossl_dh_initialize):
	  pop pushed error after each try of reading. fixes #4550

	* ext/openssl/ossl_pkey_dsa.c (ossl_dsa_initialize): ditto.

	* ext/openssl/ossl_pkey_ec.c (ossl_ec_initialize): ditto.

Wed Apr  6 11:36:44 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_pkey_rsa.c (ossl_rsa_initialize):
	  pop pushed error after each try of reading. fixes #4550

Tue Apr  5 20:33:43 2011  Tanaka Akira  <akr@fsij.org>

	* include/ruby/encoding.h: parenthesize macro arguments.

Mon Apr  4 22:02:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/io/nonblock/nonblock.c (io_nonblock_set): Avoid F_SETFL if
	  we're not changing the O_NONBLOCK bit. F_SETFL is an expensive
	  operation since it needs to affect all processes with the same
	  file object.
	  The patch is written by Eric Wong. [ruby-core:35556]

Mon Apr  4 21:41:26 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_io_syswrite): While local FS writes are usually
	  buffered, the buffers can be full or the file opened with
	  O_SYNC. IO#syswrite can also be used on blocking IOs
	  (pipe/socket) just like IO#write.
	  The patch is written by Eric Wong. [ruby-core:35554]

Mon Apr  4 11:50:40 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/test_tempfile.rb: simply ignore platform dependent testcases
	  instead of skipping.

Sun Apr  3 22:52:22 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* ext/syslog/syslog.c: improve rdoc.
	  a patch by Jonas Pfenniger. [ruby-core:35592] fixes #4545

Sun Apr  3 22:10:09 2011  Tanaka Akira  <akr@fsij.org>

	* ext/zlib/zlib.c: parenthesize macro arguments.

Sun Apr  3 21:33:58 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: disable fdatasync again on Mac OS X.
	  [ruby-core:35493][Bug #4500]

Sun Apr  3 21:16:20 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (io_reopen): IO#close releases GVL if possible.
	  close() may block for certain file types (NFS, SO_LINGER
	  sockets, inotify), so let other threads run. The patch was
	  created by Eric Wong [ruby-core:35555][Bug #4527]

	* io.c (fptr_finalize): ditto.

	* io.c (maygvl_fclose): new.
	* io.c (nogvl_fclose): ditto.
	* io.c (maygvl_close): ditto.
	* io.c (nogvl_close): ditto.

Fri Apr  1 22:25:50 2011  Tanaka Akira  <akr@fsij.org>

	* ext/syslog/syslog.c: parenthesize macro arguments.

Fri Apr 1 18:53:06 2011  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* lib/webrick/cookie.rb (WEBrick::Cookie.parse): 'white space is
	  permitted between tokens' according to RFC2965. Though 'Netscape
	  spec' does not define the syntax clearly, make it tolerant as a
	  server. As a real-world example, rest-client gem sends
	  'Cookie: foo=1;bar=2'

	* test/webrick/test_cookie.rb (test_parse_non_whitespace): test it.

Fri Apr  1 13:19:20 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_core.h (RUBY_VM_CHECK_INTS_TH): merge a patch by ko1
	  in [ruby-dev:43373].

Thu Mar 31 23:15:46 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-brace-to-do-end, ruby-do-end-to-brace):
	  adjust space between block beginning and block arguments

Thu Mar 31 20:42:05 2011  Tanaka Akira  <akr@fsij.org>

	* ext/strscan/strscan.c:  parenthesize macro arguments.

Thu Mar 31 18:06:12 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_insnhelper.c (vm_get_ev_const): should ignore crefs with
	  the NODE_FL_CREF_PUSHED_BY_EVAL flag.

Thu Mar 31 16:49:56 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_insnhelper.c (vm_get_ev_const): search root cref properly.
	  [ruby-dev:43365]

Thu Mar 31 14:50:25 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* eval.c (rb_mod_s_constants): should ignore crefs with
	  the NODE_FL_CREF_PUSHED_BY_EVAL flag.

Wed Mar 30 22:55:47 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-toggle-block): toggle do/end and {}.

	* misc/ruby-mode.el (ruby-move-to-block): move to opening of
	  block.

Wed Mar 30 14:35:15 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_insnhelper.h (COPY_CREF): should copy
	  the NODE_FL_CREF_PUSHED_BY_EVAL flag to hide constants from
	  methods defined by class_eval.  [ruby-dev:43365]

Wed Mar 30 00:24:53 2011  Tanaka Akira  <akr@fsij.org>

	* ext/stringio/stringio.c: parenthesize macro arguments.

Tue Mar 29 21:51:31 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* object.c (rb_String): Kernel#String should call to_str before to_s.

Tue Mar 29 10:28:08 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/webrick/test_filehandler.rb
	  (WEBrick::TestFileHandler#test_short_filename): the cgi doesn't exist
	  on current directory.

Tue Mar 29 05:19:57 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/raddrinfo.c: parenthesize macro arguments.

Tue Mar 29 00:03:51 2011 Tajima Akio <artonx@yahoo.co.jp>

	* test/webrick/test_filehandler.rb (test_short_filename):
	  read real short filename by cmd because smb mounted files
	  have different naming convention.

Mon Mar 28 11:38:08 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/date/date_core.c (date_s_today): use int for year.

	* ext/date/date_core.c (datetime_s_now): ditto.

Mon Mar 28 11:07:41 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/extmk.rb: set MFLAGS from MAKEFLAGS when using nmake.

Mon Mar 28 11:07:00 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* common.mk (love): all you need is love.

Sun Mar 27 23:16:31 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/ipsocket.c: parenthesize macro arguments.

Sun Mar 27 16:55:34 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-mode-map): remove unnecessary
	  binding. fixes
	  http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=468952

	* misc/ruby-mode.el: suppress warnings at byte compile.  fixes
	  http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=502926

Sun Mar 27 11:18:35 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: removed unused variables.

Sat Mar 26 15:16:09 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/getaddrinfo.c: parenthesize macro arguments.

Sat Mar 26 05:27:34 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/date/lib/date/format.rb (DateTime#strftime): removed because
	  date_core defines it.

Fri Mar 25 21:59:45 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: should not force cast with macros.

Fri Mar 25 21:56:10 2011  Tanaka Akira  <akr@fsij.org>

	* ext/sdbm/init.c: parenthesize macro arguments.

Fri Mar 25 19:39:40 2011  Ben Walton <bwalton@artsci.utoronto.ca>

	* test/test_syslog.rb:
	  Skip syslog tests that rely on LOG_PERROR unless it's defined

	  Instead of checking looking at the platform to determine if the tests
	  relying on LOG_PERROR should be run, look for the definition of the
	  constant as this will be robust against all platforms as long as the
	  underlying syslog.c code sets it up correctly.

	  This specifically addresses failures on Solaris 9.

	  Use LOG_PID instead of LOG_PERROR in Syslog.open test

	  LOG_PERROR isn't a POSIX option for syslog, so it fails on platforms
	  that don't define it.  Solaris 9 and 10 are examples of this.

	  Use LOG_PID instead.

Fri Mar 25 15:42:17 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/sdbm/_sdbm.c (sdbm_open): use size_t.

	* ext/syck/bytecode.c: ditto.

	* ext/sdbm/_sdbm.c (delpair): use ptrdiff_t.

	* ext/sdbm/init.c: use RSTRING_LENINT.

	* ext/dl/handle.c: suppress warning: shorten-64-to-32.

	* ext/strscan/strscan.c: ditto.

	* ext/syck/emitter.c: ditto.

	* ext/syck/implicit.c: ditto.

	* ext/syck/syck.c: ditto.

	* ext/syck/token.c: ditto.

Fri Mar 25 12:14:58 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/nkf.c: import nkf 7f18e30.

Fri Mar 25 11:49:29 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_process.rb (TestProcess#test_no_curdir): skip silently
	  on Windows, because this tests a platform specific feature and it'll
	  never be supported on ruby on Windows.

	* test/ruby/test_dir_m17n.rb
	  (TestDir_M17N#test_filename_extutf8_invalid,
	  TestDir_M17N#test_filename_as_bytes_extutf8): ditto.

	* test/open-uri/test_open-uri.rb
	  (TestOpenURI#test_find_proxy_case_sensitive_env): ditto.

	* test/dl/test_handle.rb (DL::TestHandle#test_NEXT,
	  DL::TestHandle#test_DEFAULT): ditto.

Thu Mar 24 23:06:29 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_get_ev_const): should not autoload in
	  defined? mode.

	* variable.c (rb_const_defined_0): fix autoloading base.
	  [ruby-core:35509]

Thu Mar 24 22:48:43 2011  Tanaka Akira  <akr@fsij.org>

	* ext/sdbm/_sdbm.c: parenthesize macro arguments.

Thu Mar 24 14:45:57 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl.c: suppress warning: shorten-64-to-32.

	* ext/openssl/ossl.h: ditto.

	* ext/openssl/ossl_asn1.c: ditto.

	* ext/openssl/ossl_bio.c: ditto.

	* ext/openssl/ossl_bn.c: ditto.

	* ext/openssl/ossl_cipher.c: ditto.

	* ext/openssl/ossl_hmac.c: ditto.

	* ext/openssl/ossl_ns_spki.c: ditto.

	* ext/openssl/ossl_ocsp.c: ditto.

	* ext/openssl/ossl_pkcs5.c: ditto.

	* ext/openssl/ossl_pkey.c: ditto.

	* ext/openssl/ossl_pkey_dh.c: ditto.

	* ext/openssl/ossl_pkey_dsa.c: ditto.

	* ext/openssl/ossl_pkey_ec.c: ditto.

	* ext/openssl/ossl_pkey_rsa.c: ditto.

	* ext/openssl/ossl_rand.c: ditto.

	* ext/openssl/ossl_ssl.c: ditto.

	* ext/openssl/ossl_x509ext.c: ditto.

	* ext/openssl/ossl_x509name.c: ditto.

Thu Mar 24 11:48:19 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_rand.c (ossl_rand_egd_bytes): use NUM2INT because
	  the result is used with functions whose argument is int.

	* ext/openssl/ossl_ssl.c (ossl_sslctx_setup): ditto.

	* ext/openssl/ossl_x509store.c (ossl_x509store_set_purpose): ditto.

	* ext/openssl/ossl_x509store.c (ossl_x509store_set_trust): ditto.

	* ext/openssl/ossl_x509store.c (ossl_x509stctx_set_purpose): ditto.

	* ext/openssl/ossl_x509store.c (ossl_x509stctx_set_trust): ditto.

Thu Mar 24 11:36:55 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_x509name.c: id_aref's type is ID.

Thu Mar 24 10:04:35 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/io/console/console.c (console_set_winsize):
	  suppress warning: shorten-64-to-32.

Thu Mar 24 09:56:19 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_ocsp.c (ossl_ocspreq_verify): flags is VALUE,
	  so it should use NUM2INT.

	* ext/openssl/ossl_ocsp.c (ossl_ocspbres_verify): ditto.

Wed Mar 23 21:09:29 2011  Tanaka Akira  <akr@fsij.org>

	* ext/readline/readline.c: parenthesize macro arguments.

Wed Mar 23 08:07:33 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* numeric.c (flo_round): fix inaccurate results.

Wed Mar 23 00:12:16 2011  Tajima Akio <artonx@yahoo.co.jp>

	* win32/win32.c: wait process real termination after reading
	  exit code. fixes #4518

Tue Mar 22 21:20:10 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/rubygems/test_case.rb: save current dir to @current_dir
	  before Dir.chdir.

Tue Mar 22 20:10:04 2011  Tanaka Akira  <akr@fsij.org>

	* ext/psych/parser.c: parenthesize macro arguments.

Tue Mar 22 20:10:01 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ruby_missing.h: parenthesize macro arguments.

Tue Mar 22 13:33:22 2011  NAKAMURA, Hiroshi  <nahi@ruby-lang.org>

	* ext/openssl/lib/openssl/buffering.rb: removed circular require of
	  openssl.rb.

	* ext/openssl/lib/openssl/*: removed following comment for transition
	  measures of avoiding circular require. No one claimed about this as
	  far as I know.
	  ##
	  # Should we care what if somebody require this file directly?
	  # require "openssl"

Tue Mar 22 10:57:36 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/runner.rb: set Gem::TestCase's @@project_dir.

	* lib/rubygems/test_case.rb: set Gem::TestCase's @@project_dir only
	  when it is not defined.

Tue Mar 22 09:38:19 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* numeric.c (flo_round): use pow instead of while-loop. fixes #4510
	  patched by Alex Young [ruby-core:35526]

Tue Mar 22 06:47:46 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/date/date_strftime.c (date_strftime_wo_timespec):
	  suppress warning: shorten-64-to-32.

Tue Mar 22 06:42:42 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/date/date_core.c: suppress warning: shorten-64-to-32.

Tue Mar 22 06:41:37 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/test/unit/parallel.rb: remove unused variable.

Tue Mar 22 06:19:42 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* enc/utf_16le.c: suppress warning: shorten-64-to-32.

	* ext/dbm/dbm.c: ditto.

	* ext/gdbm/gdbm.c: ditto.

	* parse.y (Init_ripper): suppress warning: unused value.

Mon Mar 21 11:21:32 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb: Refactoring. Unified if and elsif.

Sun Mar 20 23:09:34 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_strftime.c: checks duplicated modifiers.

Sun Mar 20 22:32:30 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_strftime.c: removed unused code and arguments.

Sun Mar 20 21:34:49 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: replacement of implementation of
	  strftime. It has some limitations that is same as Time's
	  one.  [experimental]
	* ext/date/date_strftime.c: new.
	* ext/date/lib/date/format.rb: removed ruby version of strftime.

Sun Mar 20 12:43:12 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_x509store.c: parenthesize macro arguments.

Sun Mar 20 01:39:48 2011  Tajima Akio <artonx@yahoo.co.jp>

	* hash.c (ruby_setenv): check env process block size with OS ver.
	* win32/win32.c: export rb_w32_osver for above patch.
	* include/ruby/win32.h: declare rb_w32_osver for Win32 Libs.

Sat Mar 19 18:35:05 2011  Tajima Akio <artonx@yahoo.co.jp>

	* hash.c (ruby_setenv): calculate total env block size for win32.
	* test/ruby/test_env.rb: add test for above patch.

Sat Mar 19 17:14:46 2011  Tajima Akio <artonx@yahoo.co.jp>

	* hash.c (ruby_setenv): checking with max process environment
	  block size for Win32. 32767 for 2000/XP, 2003. if failed to
	  read the block, then checking with 5120 for earlier Windows.

Sat Mar 19 12:30:25 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_x509revoked.c: parenthesize macro arguments.

Fri Mar 18 20:44:36 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_x509req.c: parenthesize macro arguments.

Fri Mar 18 08:48:06 2011  Oleg Shaldybin  <oleg.shaldybin@gmail.com>

	* lib/fileutils.rb (FileUtils::Entry_#copy_file): updated FileUtils.cp
	  to still copy file permissions when :preserve is false (as cp does
	  this even when -p isn't set).

Fri Mar 18 00:59:38 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/win32ole/extconf.rb (create_docfile): removed.  should not
	  modify source directory unnecessarily, platform dependent
	  documentation should be dealt with by rdoc.  [ruby-core:35495]

Fri Mar 18 00:54:20 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (rb_funcall_passing_block): add prototype.
	  a patch by James M. Lawrence at [ruby-core:35501]

Wed Mar 17 06:23:31 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_x509name.c: parenthesize macro arguments.

Wed Mar 16 20:36:56 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/ipsocket.c (init_inetsock_internal): raise an error on
	  listen(2) failure.
	  reported by Xavier Shay.  [ruby-core:35505]

Wed Mar 16 15:06:21 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/openssl/lib/openssl/buffering.rb (module OpenSSL): #flush should
	  not change sync mode on exception.
	* test/openssl/test_buffering.rb: added

Wed Mar 16 13:45:28 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/openssl/lib/openssl/buffering.rb: de-nest Buffering module

	* ext/openssl/lib/openssl/buffering.rb: add RDoc

Wed Mar 16 08:40:39 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_x509ext.c: parenthesize macro arguments.

Tue Mar 15 18:34:27 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_x509crl.c: parenthesize macro arguments.

Tue Mar 15 09:49:03 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/misc/test_ruby_mode.rb (test_singleton_class): Skip for Pending.

Mon Mar 14 21:20:44 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/ruby/test_require.rb (test_require_too_long_filename):
	  increase path length, because MAXPATHLEN is defined as 4096 on linux.

	* test/ruby/test_require.rb (test_require_path_home_1): ditto.

	* test/ruby/test_require.rb (test_require_path_home_2): ditto.

Mon Mar 14 19:54:37 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_x509cert.c: parenthesize macro arguments.

Sun Mar 13 18:11:28 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_x509attr.c: parenthesize macro arguments.

Sun Mar 13 16:07:58 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/pstore.rb: Fix don't raise "nested transaction" when thread_safe
	  is true. Patch by Masaki Matsushita (Glass_saga). [ruby-dev:43337]

	* test/test_pstore.rb: Test for above.
	  Patch by Masaki Matsushita (Glass_saga) [ruby-dev:43337]

Sat Mar 12 04:12:41 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_ssl_session.c: parenthesize macro arguments.

Sat Mar 12 02:27:07 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c ({d,dt}_lite_marshal_load): checks the given
	  argument.

Sat Mar 12 01:26:24 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: changed some directives.

Sat Mar 12 01:16:02 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c, ext/date/lib/*: moved rdoc descriptions.

Sat Mar 12 00:06:24 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/lib: moved from lib.

Fri Mar 11 23:32:38 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date/delta*: removed undocumented delta.

Fri Mar 11 18:42:43 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (find_executable0): should exclude directories.

Fri Mar 11 01:40:35 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (proc_getmaxgroups, proc_setmaxgroups): Process#maxgroups
	  and Process#maxgroups= now raise NotImplementedError if the
	  platform don't support supplementary groups concept.

Fri Mar 11 01:25:03 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (get_sc_ngroups_max): return -1 if platform don't
	  support NGROUPS_MAX.

Thu Mar 10 22:28:15 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_ssl.h: parenthesize macro arguments.

Thu Mar 10 21:59:37 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* parse.y (parser_encode_length): add exception as UTF8-MAC for
	  magic comment's emacs newline specifier
	  patched by James M. Lawrence [ruby-core:35476] fixes #4489

Thu Mar 10 16:00:22 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* parse.y (parser_encode_length): fix typo: the length of
	  "-dos" and "-mac" is not 5 but 4.
	  patched by James M. Lawrence [ruby-core:35476] fixes #4489

Thu Mar 10 10:52:01 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_require.rb: setting too long string to ENV causes
	  Errno::EINVAL on Windows.  long path name errors may causes over
	  about 1024 bytes, then limit it about 4000 bytes.

Thu Mar 10 10:09:35 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/test/unit.rb (Test::Unit::Runner::Worker#read): fix for the case
	  when IO#read or IO#gets returns nil.

Thu Mar 10 07:12:03 2011  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/rubygems*: Import rubygems 1.6.2 (release candidate @ 2026fbb5)
	* test/rubygems: Ditto
	* test/runner.rb: Added test to load path to fix test requires.

Thu Mar 10 03:00:43 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_ssl.c: parenthesize macro arguments.

Wed Mar  9 23:51:26 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/ruby/test_io_m17n.rb (test_io_new_enc): "sjis" is now an alias
	  of Windows-31J.

Wed Mar  9 23:06:13 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-parse-partial): fix indent after aref.

Wed Mar  9 12:50:24 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: Rescue exceptions when
	  people implement the method method. Thanks Lin Jen-Shin.
	  [ruby-core:35255]

	* test/psych/visitors/test_yaml_tree.rb: test for implementation of
	  method method.

Wed Mar  9 11:53:31 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* enc/shift_jis.c: Change SJIS as an alias of Windows-31J.
	  [ruby-dev:43027] fixes #4280

	* enc/shift_jis.c: Add PCK as an alias of Windows-31J.

Wed Mar  9 00:45:29 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/extmk.rb: nmake substitutes all occurrences in macro.

	* ext/extmk.rb: workaround for nmake.

Tue Mar  8 23:49:45 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (proc_setgroups): cleanup.

Tue Mar  8 23:40:30 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/misc/test_ruby_mode.rb: test for ruby-mode.el.

Tue Mar  8 23:27:38 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (get_sc_ngroups_max): try to use NGROUPS_MAX at first if
	  _SC_NGROUP_MAX is not defined.

Tue Mar  8 23:10:16 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-parse-partial): fix for array in block.

Tue Mar  8 21:44:49 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_rand.c: parenthesize macro arguments.

Tue Mar  8 16:45:31 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* hash.c (ruby_setenv): MSDN says that Windows XP or earlier limits
	  the total size of environment block to 5,120 chars.  and on such
	  OS, putenv() causes SEGV.  So, ruby should limit the size of an
	  environment variable to 5,120 bytes for workaround.

Tue Mar  8 15:57:20 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/rubygems/test_gem_spec_fetcher.rb
	  (TestGemSpecFetcher#test_cache_dir_escapes_windows_paths): cache_dir
	  may have driveletter and `:' for base of cache_dir itself, so need
	  to skip it for checking.

Tue Mar  8 12:30:06 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-deep-indent-paren-p, ruby-calculate-indent):
	  do not apply deep-indent inside parens at the beginning of
	  expressions.

Tue Mar  8 09:32:48 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (configure-ext, build-ext), ext/extmk.rb (extmake):
	  support parallel-make under ext.

Tue Mar  8 09:25:23 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (proc_setgroups): use getgrnam() if getgrnam_r() is
	  not available.

	* process.c: RARRAY_LEN() returns long int.

Tue Mar  8 09:07:03 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (RUBY_REPLACE_TYPE): enclose in quotes for multiple
	  type names.

Tue Mar  8 01:43:11 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* process.c (get_sc_ngroups_max): define to wrap sysconf(3).
	  this also supports Windows which doesn't have sysconf(3).

	* process.c (maxgroups): use get_sc_ngroups_max.

	* process.c (proc_setmaxgroups): ditto.

Tue Mar  8 01:16:49 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* gc.c (rb_objspace): an initializer must be a constant.

Tue Mar  8 01:11:44 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* process.c (maxgroups): cast because sysconf(3)'s return value is long.

	* process.c (proc_setmaxgroups): ditto.

	* process.c (proc_setgroups): cast because RARRAY_LEN() is long.

Tue Mar  8 00:02:47 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_pkey_rsa.c: parenthesize macro arguments.

Mon Mar  7 22:59:39 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/pstore.rb: Delete variable @transaction and fix #4474. Patch by
	  Masaki Matsushita (Glass_saga).

	* test/test_pstore.rb(test_thread_safe): Add test for #4474.

Mon Mar  7 21:31:38 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (proc_setgroups): replace getgrnam() with getgrnam_r()
	  because getgrnam() isn't thread safe.

Mon Mar  7 20:49:12 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (proc_getmaxgroups, proc_setmaxgroups): reflect
	  platform maxgroups limitation by default instead hardcoded 65536.

Mon Mar  7 17:13:00 2011  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (rb_gc_set_params): allow GC parameter configuration by
	  environment variables.  based on a patch from funny-falcon at
	  https://gist.github.com/856296, but honors safe level.

Mon Mar  7 09:05:18 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c: NUM2RLIM is defined but no getrlimit and setrlimit on
	  mingw.

Mon Mar  7 08:38:14 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_core.c (DateTimeData): should not use bare 'long long'
	  and 'long double', which are not defined by C89.

	* ext/date/date_core.c (dt_lite_plus): get rid of overflow at casting
	  down double to integer.

Mon Mar  7 00:21:11 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (proc_getgroups): get rid of maxgroups dependency.
	  ngroups can be calculated dynamically.

Sun Mar  6 23:45:40 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: rlim_t use standard RUBY_REPLACE_TYPE mechanism.

Sun Mar  6 23:26:07 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (proc_setmaxgroups): added negative value check.
	  This was suggested by Daniel Berger. Thanks Daniel!
	  [ruby-core:35426][Bug#4467]

Sun Mar  6 23:18:23 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (maxgroups, proc_setmaxgroups): increase max groups
	  limitation up to 65536.

Sun Mar  6 22:20:59 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_pkey_ec.c: parenthesize macro arguments.

Sun Mar  6 21:49:04 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* sample/list.rb (MyElem#initialize): initialize @head
	  explicitly. Otherwise -W2 option makes following warning.
	  "warning: instance variable @head not initialized".
	  This issue was founded by Andrew Grimm. Thanks Andrew!
	  [ruby-core:35435][Bug#4471]

Sun Mar  6 05:21:41 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* class.c: fix camelCase to snake_case in documentation code examples.
	  patched by Andrew Grimm. fixes Bug #4469

	* marshal.c: ditto.

	* proc.c: ditto.

	* sample/biorhythm.rb: ditto.

	* vm_eval.c: ditto.

	* vm_method.c: ditto.


Sun Mar  6 03:22:27 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (io_cntl): use rb_thread_io_blocking_region() instead
	  rb_thread_blocking_region().

Sat Mar  5 22:54:36 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* include/ruby/intern.h: fix a typo of prototype declaration.
	  rb_mutex_try_lock -> rb_mutex_trylock [ruby-dev:43213]

Sat Mar  5 19:44:03 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_io.rb (TestIO#test_fcntl_lock): small clean up.

Sat Mar  5 01:33:46 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (io_cntl, nogvl_io_cntl): IO.fcntl() and IO.ioctl()
	  release GVL during calling kernel interface.
	  Suggested by Eric Wong. [ruby-core:35417][Bug #4463]

	* test/ruby/test_io.rb (TestIO#test_fcntl_lock): add new test for
	  IO.fcntl().

Fri Mar  4 23:09:12 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/testunit/test_parallel.rb
	  (test_should_run_all_without_any_leaks): consider that the order of
	  testcase could change. [ruby-dev:43300] [Bug #4466]

Fri Mar  4 22:01:14 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (io_cntl): change 'cmd' type to int. ioctl and fcntl need to
	  be passed int.
	* io.c (rb_io_ctl): ditto.

Fri Mar  4 21:10:40 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: save warnflags. the patch is created by Eric Wong.
	  [Bug #4465]

Wed Mar  2 21:15:00 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_pkey_dsa.c: parenthesize macro arguments.

Thu Mar  3 22:10:26 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* process.c (check_exec_redirect_fd, check_exec_redirect): raise
	  ArgumentError if fd >= 3 on Windows because the feature is not
	  supported.

	* test/ruby/test_process.rb (test_execopts_redirect): remove meaningless
	  argument.

Thu Mar  3 21:21:42 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_process.rb (test_execopts_redirect): redirecting fd
	  >= 3 is not supported on Windows, so should not specify such options
	  when calling spawn or others.

Thu Mar  3 18:59:04 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_str_slice_bang): raise error when the string is frozen.

Thu Mar  3 14:25:19 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* strftime.c (STRFTIME): return 0 and ERANGE when precision is too
	  large. [ruby-dev:43284] fixes #4456

Thu Mar  3 00:46:51 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* addr2line.c (uleb128): cast the value to unsigned long.

	* addr2line.c (fill_lines): print error when lseek fails.

Thu Mar  3 00:36:29 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/rexml/encoding.rb (REXML::Encoding#encoding=): store @encoding
	  a String which means the name of the encoding.
	  this partially revert r29646.

	* lib/rexml/document.rb: follow above.

	* lib/rexml/output.rb: ditto.

	* lib/rexml/parsers/baseparser.rb: ditto.

	* lib/rexml/source.rb: ditto.

	* lib/rexml/xmldecl.rb: ditto.

Wed Mar  2 23:19:56 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_byte_substr): return nil for negative length.

Wed Mar  2 21:15:00 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_pkey_dh.c: parenthesize macro arguments.

Wed Mar  2 14:24:04 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit/parallel.rb: Fix name from `inclement_io` to
	  `increment_io`.

Wed Mar  2 14:06:01 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_str_slice_bang): move treatments which is only needed
	  when the result is not nil.

Wed Mar  2 14:02:29 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/testunit/test_parallel.rb(TestParallel#spawn_runner):
	  Fix outputing empty line in running test.

	* test/testunit/tests_for_parallel/test_third.rb: Remove `sleep`

Tue Mar  1 22:29:10 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_pkey.h: parenthesize macro arguments.

Tue Mar  1 22:02:35 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit/parallel.rb: Fix number.

Tue Mar  1 21:48:22 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit/parallel.rb: For Windows.

	* test/testunit/test_parallel.rb(TestParallelWorker#test_quit_in_test):
	  Fix for above specification change.
	* test/testunit/test_parallel.rb(TestParallel#spawn_runner):
	  Fix outputing empty line in running test.

Tue Mar  1 20:51:57 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_system.rb (TestSystem#test_system_at):
	  remove tests for [bug#4396]. because we decided to reject this
	  ticket.

Tue Mar  1 19:46:19 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/{test_date.rb,test_date_attr.rb}: [ruby-dev:43280]

Tue Mar  1 18:40:38 2011  Ryan Davis  <ryan@YPCMC09457>

	* lib/rubygems*: Import rubygems 1.6.0 (released version @ 58d8a0b9)
	* test/rubygems: Ditto

Tue Mar  1 16:22:22 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c: revert r30987 because it causes some failures in
	  test-all, especially webrick.

Tue Mar  1 15:59:53 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_str_byteslice): the resulted encoding should keep
	  original encoding. this also fixes the encoding when the result
	  shares internal string. [ruby-core:35376]

Tue Mar  1 13:25:00 2011  Kenta Murata <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (VpMemAlloc): CVE-2011-0188.
	  Fixes a bug reported by Drew Yao <ayao at apple.com>

Tue Mar  1 10:34:39 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_str_byteslice): Add String#byteslice. [ruby-core:35376]

Tue Mar  1 00:12:49 2011  Tajima Akio <artonx@yahoo.co.jp>

	* include/ruby/win32.h: define WIN32 if neither _WIN64 nor WIN32
	  defined. it forces to use push/pop for pack(4) pragma.

Mon Feb 28 23:52:13 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/testunit/test_rake_integration.rb (test_with_rake_runner):
	  use assert_in_out_err for suppress messages.

Mon Feb 28 22:48:56 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* win32/win32.c (rb_w32_spawn): use shell if a commandline contain
	  double-quote character.
	* win32/win32.c (is_internal_cmd): similar, use shell if a commandline
	  contain caret character.

	* test/ruby/test_system.rb (TestSystem#test_system_at): fix
	  wrong test case. if system() invoke a command by using shell,
	  system() never return nil. Also, "" quotation must not appear
	  twice in a command line.

Mon Feb 28 17:36:57 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_pkcs7.c: parenthesize macro arguments.

Mon Feb 28 16:48:42 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_pkcs12.c: parenthesize macro arguments.

Mon Feb 28 16:28:15 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (tr_trans): when the hash for multibyte repl is empty,
	  tr is inverse mode, and a character doesn't much the table, the
	  character should be replaced by last replacement. Bug #4449

Mon Feb 28 16:38:56 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_ocsp.c: parenthesize macro arguments.

Mon Feb 28 13:02:15 2011  Danial Pearce <github@tigris.id.au>

	* lib/tempfile.rb: Fix example file paths in docs for tempfile.
	  https://github.com/ruby/ruby/pull/5

Mon Feb 28 12:56:18 2011  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* ext/openssl/ossl_cipher.c (ossl_cipher_init): typo fix.
	  https://github.com/ruby/ruby/pull/8

Mon Feb 28 12:28:13 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/date/date_core.c (datetime_s_now): localtime() and localtime_r()
	  required time_t pointer as 1st parameter, and tv_sec member of struct
	  timeval is long.

Mon Feb 28 11:57:40 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/testunit/test_parallel.rb: Temporally disable test on Windows.

Mon Feb 28 07:28:35 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb(Test::Unit::Runner#after_worker_quit):
	  method name more be natural English.

	* lib/test/unit.rb(Test::Unit::Runner::Worker.launch):
	  IO.sync doesn't need. Should use "b" for mode.

Sun Feb 27 21:59:37 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_system.rb (TestSystem#test_system_redirect_win):
	  add test for system().

Sun Feb 27 18:00:09 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb: Refactoring; Worker never use Hash for internal
	  storage.

	* lib/test/unit.rb: Never use Kernel#spawn. Use IO.popen instead.

Sun Feb 27 13:16:48 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_ns_spki.c: parenthesize macro arguments.

Sat Feb 26 17:07:53 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date.rb: [Feature #4257]

	* ext/date/extconf.rb: new

	* ext/date/date_core.c: new

Sat Feb 26 16:10:23 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb: --jobs-status won't puts over 2 lines.

	* test/testunit/test_parallel.rb: Fix test for above.

	* lib/test/*: refactoring.

Sat Feb 26 07:10:05 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/scalar_scanner.rb: fix parsing timezone's whose
	  whose format is (+/-)hhmm.  Thanks Goncalo Silva!

	* test/psych/test_scalar_scanner.rb: test for bug.

Thu Feb 24 23:02:55 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_hmac.c: parenthesize macro arguments.

Thu Feb 24 22:53:10 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (love): for the birthday.

Thu Feb 24 22:51:54 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (ruby_vm_destruct): run vm exit hooks after all objects are
	  destructed.

Thu Feb 24 14:40:33 2011  Shota Fukumori  <sorah@tubusu.net>

	* ChangeLog (vim): Modeline for vim

Thu Feb 24 13:39:25 2011  Shota Fukumori  <sorah@tubusu.net>

	* common.mk: Use $RUNRUBY for worker process.

	* lib/test/unit.rb: Fix bug.

	* lib/test/unit.rb: @options[:ruby](@opts[:ruby]) is now Array.

	* test/testunit/parallel.rb: Fix for above.

Thu Feb 24 10:05:55 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/testunit/tests_for_parallel/misc.rb: Fix bug in r30947.

	* lib/test/unit.rb, lib/test/unit/assertions.rb: For this test.

Wed Feb 23 23:07:38 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/testunit/test_parallel.rb, test/testunit/parallel/*:
	  Test for r30939.

	* lib/test/unit.rb: For test.

	* lib/test/parallel.rb: For test.

	* lib/test/unit/testcase.rb: For test.

Wed Feb 23 22:05:13 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_engine.c: parenthesize macro arguments.

Tue Feb 22 23:15:17 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb: Fix --ruby option doesn't effect.

	* lib/test/unit.rb: Fix typo.

Tue Feb 22 21:39:28 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_digest.c: parenthesize macro arguments.

Tue Feb 22 14:34:26 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb: Fix merging miss.

Tue Feb 22 12:27:26 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb: Add new options; --jobs,-j,--ruby,--jobs-status,
	  --no-retry.
	  [Feature #4415] [ruby-dev:43226],[ruby-dev:43222],[ruby-core:35294]

	* lib/test/unit/parallel.rb: Used at test/unit --jobs(-j) option.

	* test/csv/test_serialization.rb: test/unit parallel running ready.

	* test/rake/test_file_task.rb: test/unit parallel running ready.

Tue Feb 22 06:09:10 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/syslog/syslog.c: Apply documentation patch from mathew murphy.
	  [Bug #4149]

Tue Feb 22 03:09:10 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: increase Psych to 1.1.0 for help with
	  debugging.

Tue Feb 22 03:04:46 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/streaming.rb: refactor streaming methods to a
	  module.
	* ext/psych/lib/psych/stream.rb: extracted streaming specific methods
	  to a module.
	* ext/psych/lib/psych/json/stream.rb: JSON stream inherits from
	  JSONTree and includes streaming methods.
	* ext/psych/lib/psych/visitors/json_tree.rb: JSON does not support
	  object references, so remove object reference testing when building
	  JSON trees.

Tue Feb 22 02:41:51 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb (accept): use Hash#key?
	  when looking up object references to err on the side of cache
	  misses.

Mon Feb 21 10:58:39 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/json/yaml_events.rb: refactoring JSON event
	  handling methods to a module for reuse.
	* ext/psych/lib/psych/json/tree_builder.rb: AST builder uses JSON
	  event methods.
	* ext/psych/lib/psych/json/stream.rb: stream emitter uses JSON event
	  methods.

Mon Feb 21 10:54:29 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/json/stream.rb: do not emit custom tags in maps
	  or sequences when emitting JSON.
	* ext/psych/lib/psych/json/tree_builder.rb: do not emit custom tags in
	  sequences when emitting JSON.
	* test/psych/json/test_stream.rb: tests for custom stream emits.
	* test/psych/test_json_tree.rb: tests for JSON emits.

Mon Feb 21 10:05:10 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/json/ruby_events.rb: DRY up ruby event handling
	  for JSON.
	* ext/psych/lib/psych/visitors/json_tree.rb: use ruby events module
	* ext/psych/lib/psych/json/stream.rb: ditto

Mon Feb 21 10:01:01 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/json/stream.rb: fix JSON stream emits to use
	  double quotes during stream.
	* test/psych/json/test_stream.rb: tests to reflect changes.

Mon Feb 21 00:38:56 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_system.rb (TestSystem#test_system_at):
	  add testcase for bug4396.

Sun Feb 20 19:59:32 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_cipher.c: parenthesize macro arguments.

Sun Feb 20 16:26:45 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (exec_recursive): prevent temporary objects from GC.

	* prevent temporary objects from GC, and should not use
	  RSTRING_PTR() for function calls since it evaluates the argument
	  a couple of times.

Sun Feb 20 16:22:53 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_file_flock): use rb_thread_io_blocking_region for the
	  time being.

Sun Feb 20 05:33:17 2011  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/minitest/*.rb: Imported minitest 2.0.2 r6207.
	* test/minitest/*: ditto

Sun Feb 20 02:14:09 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c (sig_trap): avoid pthread_sigmask(xx, &mask, &mask) usage
	  because FreeBSD don't permit it. If it's used, it behave as
	  pthread_sigmask(xx, NULL, &mask).

	* signal.c (init_sigchld): ditto.

Sun Feb 20 00:46:51 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl_bn.c: parenthesize macro arguments.

Sat Feb 19 22:37:42 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* vm_insnhelper.c (vm_check_if_namespace): guard temporary object
	  from GC.

Sat Feb 19 06:36:27 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* lib/test/unit.rb: partial revert of r30849. [ruby-core:32864]

	* test/testunit/test_rake_integration.rb: adding an integration test
	  with the rake loader to prevent regressions.

Fri Feb 18 19:31:31 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/fileutils.rb (FileUtils::remove_entry_secure): there is a
	  race condition in the case where the given path is a directory,
	  and some other user can move that directory, and create a
	  symlink while this method is executing.
	  Reported by: Nicholas Jefferson <nicholas at pythonic.com.au>

Fri Feb 18 00:28:39 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* compile.c (get_exception_sym2type): guard temporary object from GC.

Thu Feb 17 23:54:29 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* iseq.c (prepare_iseq_build): initialize iseq_compile_data::err_info
	  with nil. this fix exception in rb_iseq_load().

Thu Feb 17 22:32:35 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/ruby/test_marshal.rb (test_marshal_dump_extra_iv):
	  fix a typo of local variable. [Bug #3720] [ruby-dev:42083]

Thu Feb 17 21:32:53 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/ossl.h: parenthesize macro arguments.

Wed Feb 16 20:37:48 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* eval_jump.c (rb_exec_end_proc): changed at_exit and END proc
	  evaluation order. [Bug #4400] [ruby-core:35237]
	* eval_jump.c (rb_mark_end_proc): ditto.

	* test/ruby/test_beginendblock.rb (TestBeginEndBlock#test_nested_at_exit):
	  added a test for nested at_exit.
	* test/ruby/test_beginendblock.rb (TestBeginEndBlock#test_beginendblock):
	  changed the test to adopt new spec.

Wed Feb 16 20:17:06 2011  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/openssl_missing.h: parenthesize macro arguments.

Tue Feb 15 21:37:45 2011  Tanaka Akira  <akr@fsij.org>

	* ext/gdbm/gdbm.c: parenthesize macro arguments.

Tue Feb 15 20:34:53 2011  Tanaka Akira  <akr@fsij.org>

	* array.c (ary_join_1): fix array size.

Tue Feb 15 19:43:23 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: fix and resubmit r30621. [ruby-dev:43203]

Tue Feb 15 15:41:30 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* array.c (array_join): copy the encoding of the first element as
	  an initial encoding.

	* array.c (array_join_0): ditto.

	* array.c (array_join_1): ditto.

	* array.c (inspect_ary): ditto.

	* array.c (array_join_1): add an argument to check the appending is
	  first one or not.

Tue Feb 15 15:40:53 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* hash.c (inspect_i): copy the encoding of the first key as
	  an initial encoding.

Mon Feb 14 15:00:16 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* array.c (inspect_ary): don't taint the inspected result of a
	  recursive array.

Tue Feb 15 15:43:29 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* encoding.c (rb_enc_compatible): change the rule for empty strings:
	  remove the special treatment of the US-ASCII encoded empty string.
	  Now Encoding.compatible? usually respect the encoding of the
	  receiver.

Tue Feb 15 15:39:37 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_enc_cr_str_buf_cat): remove special treatment of
	  ASCII-8BIT receivers.

	* string.c (str_gsub): set initial encoding of the buffer as the
	  same of the receiver. [ruby-core:35141]

Tue Feb 15 09:49:33 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_system.rb (TestSystem#test_system_at): use findstr
	  command instead of find command, because the latter is confusing
	  another famous Unix command.

Mon Feb 14 23:01:19 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* thread.c (rb_thread_io_blocking_region): reset th->waiting_fd
	  after blocking region, because remaining waiting_fd might
	  cause unnecessary IOError.

Mon Feb 14 21:06:50 2011  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* configure.in: revert r30621.  That revision introduced mkmf test
	  failures and it turned out to be OK to revert. [ruby-dev:43203]

Mon Feb 14 21:04:01 2011  Tanaka Akira  <akr@fsij.org>

	* ext/fiddle/conversions.h: parenthesize macro arguments.

Mon Feb 14 18:41:47 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* win32/setup.mak (USE_RUBYGEMS): fixed r30835. It didn't work on
	  mswin32 port. If you changed win32/configure.bat, you should change
	  setup.mak too.

Mon Feb 14 17:28:34 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_system.rb (TestSystem#test_system_at):
	  added test. [ruby-core:35218] (#4393)

Mon Feb 14 13:15:35 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (is_internal_cmd): if the first char of prog is '@',
	  execute it via shell.  [ruby-core:35218] (#4393)

Mon Feb 14 10:33:45 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/test/unit.rb: revert r30863, because it causes too many noise.

Mon Feb 14 07:34:55 2011  Tanaka Akira  <akr@fsij.org>

	* ext/curses/curses.c: parenthesize macro arguments.

Sun Feb 13 19:41:47 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit.rb (Test::Unit::RequireFiles#non_options): skip
	  test suites failed to load instead of mere messages.

Sun Feb 13 09:56:44 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/openssl/test_config.rb (OpenSSL#test_freeze): fix error
	  message assertion.

	* test/io/nonblock/test_flush.rb (TestIONonblock#flush_test):
	  return true to finish the test.

	* test/syck/test_string.rb (Syck::TestString#test_non_binary_string):
	  use assert_not instead of refute, unless required minitest
	  explicitly.

	* test/test_prime.rb (TestPrime::sieve.Integer): ditto.

	* test/xmlrpc/webrick_testing.rb (WEBrick_Testing#start_server):
	  catch IOError when server socket was closed.

Sun Feb 13 07:39:51 2011  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* enum.c (enum_inject): typo fixed. a patch from Gaku Ueda in
	  [ruby-core:35216].

Sun Feb 13 00:48:47 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/date.rb (Date#===): [ruby-core:35127]

Sun Feb 13 00:29:18 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit.rb (Test::Unit::Options#process_args): always
	  return options.

	* lib/test/unit.rb (Test::Unit::RequireFiles#non_options): return
	  if any test case get loaded.

	* lib/test/unit.rb (Test::Unit::AutoRunner#initialize): do not add
	  default directory if it is nil.

	* lib/test/unit.rb (Test::Unit::AutoRunner#process_args): return
	  true if any test cases to run.

Sat Feb 12 23:17:43 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit.rb (assert_include): add alias.

Sat Feb 12 14:44:20 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_thread_io_blocking_region): new function to run
	  blocking region with GIL released, for fd.

	* thread.c (rb_thread_fd_close): implement.  [ruby-core:35203]

	* vm.c (th_init): rename from th_init2.

Sat Feb 12 14:41:36 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit.rb (Test::Unit::AutoRunner#initialize): use
	  default_dir if no test case given.

	* lib/test/unit.rb (Test::Unit::Runner): rename from Test::Unit::Mini.

	* lib/test/unit.rb (Test::Unit::GlobOption#non_options): run tests
	  under base directory if no argument given.

Sat Feb 12 08:03:12 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_settracefunc.rb (TestSetTraceFunc): ensure to use
	  method_added hook defined in Module.

Sat Feb 12 01:04:02 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (proc_options): enable rubygems if --gem option is given.

	* ruby.c (process_options): load rubygems if it is disabled but
	  --gem option is given.

Fri Feb 11 23:27:50 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ruby.c (proc_options): add --gem=enabled as an alias of
	  --enable=gems and --gem=disabled as an alias of --disable=gems.
	  Gem named "enabled" or "disabled" has already been reserved
	  legitimately for this purpose.

Fri Feb 11 23:17:04 2011  Tanaka Akira  <akr@fsij.org>

	* ext/dl/cfunc.c: parenthesize macro arguments.

Fri Feb 11 21:41:53 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* bin/testrb, test/runner.rb, lib/test/unit.rb: improve backward
	  compatibility.

Fri Feb 11 19:45:26 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (ruby_cleanup): use rb_ary_free to free internal object.

	* gc.h (RUBY_FREE_UNLESS_NULL): get rid of double free.
	  [ruby-core:35192]

Fri Feb 11 16:57:03 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_transcode.rb (test_from_cp50221): fix wrong
	  assertion and move back.

Fri Feb 11 14:33:18 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb (assert_no_match): alias for
	  backward compatibility.

Fri Feb 11 12:06:48 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (add_gems, require_libraries, proc_options): add
	  --require and --gem options.

Fri Feb 11 12:03:24 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rubygems): add --disable-rubygems option.

Fri Feb 11 11:39:03 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* template/fake.rb.in (CROSS_COMPILING): get rid of NameError.

Thu Feb 10 23:12:34 2011  Tanaka Akira  <akr@fsij.org>

	* ext/dl/dl.h: parenthesize macro arguments.

Wed Feb  9 23:11:27 2011  Tanaka Akira  <akr@fsij.org>

	* ext/pty/pty.c: parenthesize macro arguments.

Tue Feb  8 11:47:11 2011  Loren Sands-Ramshaw  <lorensr@gmail.com>

	* array.c: documentation clarification in rotate, rotate!,
	  index, and rindex. [ruby-core:35144]

Wed Feb  9 09:45:43 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/rdoc/test_rdoc_encoding.rb: remove unnecessary (and wrong)
	  platform-dependent hacks.

Wed Feb  9 00:47:18 2011  Tanaka Akira  <akr@fsij.org>

	* ext/etc/etc.c: parenthesize macro arguments.

Tue Feb  8 19:38:00 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-expr-beg): fix for invalid nest errors.

Tue Feb  8 19:22:59 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in (AC_MSG_CHECKING): fixed typo. the patch is
	  created by Benoit Daloze. Thanks a lot. [Bug #4384][ruby-core:35148]

Tue Feb  8 16:04:03 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_io_s_sysopen): use NUM2MODET() instead NUM2UINT().

Tue Feb  8 15:59:23 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (rb_run_exec_options_err): use MODET2NUM() instead
	  LONG2NUM().

Tue Feb  8 13:59:56 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: revert r30725. Now we have proper runtime fallback.
	  Therefore, no need compile time disabling. (see r30762).

Tue Feb  8 01:00:21 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* process.c (proc_setgroups): add GC guard to prevent intermediate
	  variable from GC.

Tue Feb  8 00:56:33 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* misc/ruby-mode.el (ruby-expr-beg, ruby-in-here-doc-p): tell
	  singleton class definitions from here documents.

	* misc/ruby-mode.el (ruby-expr-beg, ruby-parse-partial): keyword
	  followed by colon is label.

Mon Feb  7 22:56:16 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* lib/benchmark.rb (Benchmark#bmbm): use ensure clause instead of
	  Object#tap to restore STDOUT.sync.

Mon Feb  7 22:34:20 2011  Tanaka Akira  <akr@fsij.org>

	* lib/net/http.rb (Net::HTTP#connect): support SNI (Server Name
	  Indication) for HTTPS.  [ruby-dev:43164]
	  http://stackoverflow.com/questions/4685736/openssl-server-name-indication-support-in-ruby

Mon Feb  7 16:05:32 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc: Upgrade to RDoc 3.5.3  Fixes [Bug #4376]

Mon Feb  7 11:46:59 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* common.mk (rdoc): add --encoding=UTF-8; ruby's rdoc must be UTF-8.

Mon Feb  7 10:21:50 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/rdoc/test_rdoc_options.rb (TestRDocOptions#test_check_files):
	  there is no easy way to create owner unreadable file on Windows.
	  So, skip the test.

Sun Feb  6 13:48:29 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/json/lib/json/common.rb (JSON::MissingUnicodeSupport.iconv):
	  should not drop rest of the result.  use Iconv.conv instead.

Sun Feb  6 12:46:02 2011  Eric Hodel  <drbrain@segment7.net>

	* string.c (gsub): Ensure result encoding is the same as input
	  encoding.  [Bug #4340].

Sun Feb  6 12:18:25 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (words, qwords): dispatch array events.  based on a
	  patch from Michael Edgar.  [Bug #4365].

Sun Feb  6 12:12:59 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/fileutils/fileasserts.rb (FileAssertions): separate module.

Sun Feb  6 11:29:23 2011  Tanaka Akira  <akr@fsij.org>

	* ext/dbm/dbm.c: parenthesize macro arguments.

Sat Feb  5 22:01:59 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* lib/test/unit/assertions.rb (Test::Unit::Assertions#assert):
	  revert r30796. r30797 and r30798 are an alternative fix.
	  [ruby-dev:43174]

Sat Feb  5 21:47:09 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (mlhs_basic): include mlhs_post for ripper.  a patch
	  from Michael Edgar at [ruby-core:35078].

Sat Feb  5 21:22:21 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb (assert_block): move from
	  test/fileutils/fileasserts.rb.

	* test/fileutils/fileasserts.rb (assert_block): pass arguments
	  as-is.  [ruby-dev:43174]

Sat Feb  5 16:47:54 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* lib/test/unit/assertions.rb (Test::Unit::Assertions#assert):
	  msg can be passed nil. [Bug #4371] [ruby-dev:43174]

Sat Feb  5 15:18:25 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc: Upgrade to RDoc 3.5.2

Sat Feb  5 12:05:27 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/syck/rubyext.c (syck_node_init_copy): SyckNode is not
	  copiable.  [ruby-core:35094]

Sat Feb  5 11:48:47 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl_cipher.c (ossl_cipher_alloc): leave data ptr
	  NULL.

	* ext/openssl/ossl_cipher.c (ossl_cipher_new, ossl_cipher_initialize):
	  allocate internal structure.  [ruby-core:35094]

	* ext/openssl/ossl_cipher.c (ossl_cipher_copy): ditto.

Sat Feb  5 11:29:10 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/json/parser/parser.h (GET_PARSER): raise TypeError.

	* ext/json/parser/parser.rl (cParser_initialize): ditto.

	* ext/json/parser/parser.h (GET_PARSER): check if initialized.
	  [ruby-core:35079]

	* ext/json/parser/parser.rl (cParser_initialize): ditto.

Sat Feb  5 10:09:31 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (rb_get_expanded_load_path): always expand load paths.

Sat Feb  5 09:38:08 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (encoded_dup): extract.

Sat Feb  5 03:37:47 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/fileutils.rb (FileUtils::LowMethods): make low level methods
	  in NoWrite and DryRun to do nothing.  [ruby-dev:43129]

	* test/fileutils/fileasserts.rb: add message arguments.

	* test/fileutils/fileasserts.rb (Test::Unit::Assertions#assert_block):
	  show the given message.

Sat Feb  5 02:09:39 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (lex_getline, parser_set_encode): set encoding of lines
	  in SCRIPT_LINES__ as source encoding.  [ruby-dev:43168]

Sat Feb  5 02:08:37 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (ruby_thread_data_type): add prefix.

Sat Feb  5 00:59:54 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm_core.h (GetThreadPtr): use TypedData_Get_Struct() instead
	  CoreDataFromValue() because we need type check. Otherwise,
	  type mismatch can cause segmentation fault crash.
	  [ruby-core:35086] [Ruby 1.9-Bug#4367]

	* vm.c (thread_data_type): remove static.

Fri Feb  4 19:14:27 2011  Tanaka Akira  <akr@fsij.org>

	* enc/trans/utf8_mac.trans: parenthesize macro arguments.

Fri Feb  4 12:11:51 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* string.c (str_utf8_nth): fixed a condition of optimized lead
	  byte counting. [Bug #4366][ruby-dev:43170]

Fri Feb  4 01:50:13 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* string.c (count_utf8_lead_bytes_with_word): wrote function
	  comments.

Fri Feb  4 00:14:55 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/zlib/zlib.c (gzfile_reader_get_unused): no need to dup
	  before rb_str_resurrect.

Thu Feb  3 20:04:44 2011  Tanaka Akira  <akr@fsij.org>

	* ext/curses/curses.c (CHECK): unused macro removed.

Thu Feb  3 18:33:26 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/zlib/zlib.c (gzfile_reader_get_unused): use rb_str_resurrect
	  because gz->z.input is hidden string. [ruby-core:35057]

Thu Feb  3 16:34:10 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* enc/shift_jis.c (code_to_mbc): cast as int from the subtraction of
	  pointers.

	* enc/utf_16le.c (utf16le_mbc_enc_len): use ptrdiff_t.

	* enc/utf_32be.c (utf32be_left_adjust_char_head): ditto.

	* enc/utf_32le.c (utf32le_left_adjust_char_head): ditto.

Thu Feb  3 16:31:43 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* include/ruby/missing.h: don't use HAVE_STDDEF_H because it never
	  defined by configure though configure.bat defines it.

	* include/ruby/ruby.h: move include stddef.h to defines.h

	* include/ruby/defines.h: ditto.

Wed Feb  2 20:25:04 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* include/ruby/encoding.h (rb_enc_step_back): cast 4th argument 'n'
	  as int because Ruby usually treats length value as long but
	  onigenc_step_back's 4th argument is int.

Thu Feb  3 07:20:46 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: use Regexp::NOENCODING
	  rather than magic number.

	* ext/syck/lib/syck/rubytypes.rb: ditto

Thu Feb  3 07:16:11 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* re.c (Init_Regexp): added a constant for ARG_ENCODING_NONE
	  [ruby-core:35054]

	* test/ruby/test_regexp.rb: corresponding test.

Thu Feb  3 07:02:16 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: ARG_ENCODING_NONE regular
	  expressions can round trip. [ruby-core:34969]

	* test/psych/test_yaml.rb: test for ARG_ENCODING_NONE regex

	* ext/sych/lib/syck/rubytypes.rb: ARG_ENCODING_NONE regular
	  expressions can round trip.

	* test/syck/test_yaml.rb: test for ARG_ENCODING_NONE regex

Wed Feb  2 17:09:22 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_io_fdatasync): Use fsync(2) if the underlying
	  operating system does not support fdatasync(2).

Wed Feb  2 14:51:08 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/markup/to_tt_only.rb: commit miss
	* test/rdoc/test_rdoc_markup_to_tt_only.rb: ditto
	* test/rdoc/test_rdoc_single_class.rb: ditto

Wed Feb  2 09:27:53 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc: Upgrade to RDoc 3.5.1

Wed Feb  2 00:30:43 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/st.h (st_table): Added comment why we need __extension__.

Tue Feb  1 20:45:44 2011  Tanaka Akira  <akr@fsij.org>

	* enc/encdb.c: parenthesize macro arguments.

Tue Feb  1 15:12:26 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_require.rb (TestRequire#test_require_with_unc):
	  use ``127.0.0.1'' instead of ``localhost'' as host name, because
	  XP or earlier cannot resolv it as NBT hostname.

Tue Feb  1 13:20:39 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/benchmark/test_benchmark.rb (#capture_bench_output):
	  Added explicit sleep. Windows have imprecise time support.
	  Thus Tms.new.Add!{} may be or may be not equal 0. The
	  test failure started since r30747.

Tue Feb  1 11:03:47 2011  Ryan Davis  <ryan@lust.local>

	* lib/rubygems*: Import rubygems 1.5.0 (released version @ 1fb59d0)
	* test/rubygems: Ditto

Tue Feb  1 08:01:39 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (console_set_winsize): new method to set
	  console size.  [EXPERIMENTAL]

	* ext/io/console/console.c (console_winsize): use GetWriteFD.

Tue Feb  1 02:28:14 2011  Masaya Tarui  <tarui@ruby-lnag.org>

	* include/ruby/win32.h, win32/win32.c: add rb_w32_inet_ntop.
	  inet_ntop's minimum supported client is Vista.

Tue Feb  1 00:10:30 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/benchmark.rb: fix benchmark to work with current ruby.
	  patched by Benoit Daloze [ruby-core:33846] [ruby-dev:43143]
	  merged from https://github.com/eregon/ruby/commits/benchmark

	*  lib/benchmark (Report#width): update documentation
	*  lib/benchmark: document the return value of #benchmark and the
	   :list attribute in Report
	*  lib/benchmark (Tms#format): rename variables, use String#%
	   instead of Kernel.format
	*  lib/benchmark: remove undocumented Benchmark::times (an alias
	   of Process::times used twice)
	*  lib/benchmark (#benchmark): use label_width for the caption
	*  lib/benchmark (Tms#initialize): rename variables
	*  lib/benchmark: allow title to not be a String and call #to_s
	*  lib/benchmark (Benchmark#bm): return an Array of the times with
	   the labels
	*  lib/benchmark: correct output for Benchmark#bmbm
	   (remove the extra space)
	*  lib/benchmark: add a few tests for Benchmark::Tms output
	*  lib/benchmark: improve style (enumerators, ljust, unused vars)
	*  lib/benchmark: add spec about output and return value
	*  lib/benchmark: improve basic style and consistency
	   no parenthesis for print and use interpolation instead of printf
	*  lib/benchmark: remove unnecessary conversions and variables
	*  lib/benchmark: correct indentation
	*  lib/benchmark: rename the FMTSTR constant and variable to FORMAT
	*  lib/benchmark: remove useless exception

	*  test/benchmark: remove unused variable warnings

Mon Jan 31 23:27:23 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* node.c (add_id): remove duplicated rb_id2str() call.

Sun Jan 30 17:19:46 2011  Tanaka Akira  <akr@fsij.org>

	* missing/langinfo.c: parenthesize macro arguments.

Mon Jan 31 21:57:39 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: revert r30698.

Mon Jan 31 21:32:44 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* thread.c (thread_start_func_2): check deadlock condition before
	  release thread stack. fix memory violation when deadlock detected.
	  reported by Max Aller. [Bug #4009] [ruby-core:32982]

Mon Jan 31 14:45:47 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/irb/locale.rb (IRB::Locale::#search_file):
	  Gem might be undefined if --disable-gems. [ruby-core:34990]

Mon Jan 31 12:26:14 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* addr2line.c: suppressed shorten-64-to-32 warnings.
	* regcomp.c: ditto.
	* regexec.c: ditto.
	* regint.h: ditto.
	* regparse.c: ditto.
	* regparse.h: ditto.
	* time.c: ditto.
	* variable.c: ditto.

Mon Jan 31 04:45:12 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* array.c (rb_ary_uniq_bang): call ARY_SET_LEN(ary, 0) before
	  ary_resize_capa because ary_resize_capa expects resized length is
	  smaller than current array length. call rb_ary_unshare before
	  ary_resize_capa because ary_resize_capa lost the reference to
	  original shared array. [ruby-core:34997]

Sun Jan 30 17:19:46 2011  Tanaka Akira  <akr@fsij.org>

	* missing/crypt.c: parenthesize macro arguments.

Sun Jan 30 16:40:27 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/rubygems/test_gem_security.rb (TestGemSecurity): valid only
	  if OpenSSL is available.

	* test/dl/test_dl2.rb (TestDL#test_sin): math functions do not
	  work on x86_64 due to the design of DL2.

	* test/dl/test_func.rb (DL::TestFunc#test_{sinf,sin): ditto.

Sun Jan 30 16:09:22 2011  Tanaka Akira  <akr@fsij.org>

	* strftime.c (rb_strftime_with_timespec): %G produces 4 digits.

Sun Jan 30 15:13:19 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/emacs_mule.c (emacsmule_islead): 7bit range is also leading
	  byte.

Sun Jan 30 13:03:16 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_fetch_m): use useful message for longer key, not a
	  nonsense id value.

	* string.c (rb_str_ellipsize): new function to ellipsize a string.

	* include/ruby/encoding.h (rb_enc_step_back): new function to step
	  back n characters.

Sun Jan 30 12:53:38 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/emacs_mule.c (emacsmule_islead): fix inverse condition.

Sun Jan 30 09:37:25 2011  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* io.c (struct argf): char behaves like an unsigned char
	  by default on AIX.

Sun Jan 30 08:02:55 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* configure.in: Mac OS X wrongly reports it has fdatasync(3).

Sun Jan 30 03:29:47 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_bn.c (GetBNPtr): add missing nil case.
	  patched by Martin Bosslet. [ruby-core:34987]

Sun Jan 30 01:02:28 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/ruby.h: Added NUM2MODET() and MODET2NUM() default
	  definition.
	  Because r30686 introduced win32 build failure.

Sat Jan 29 22:16:26 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* array.c (rb_ary_join): [].join.encoding must be US-ASCII.
	  [ruby-list:47790]

Sat Jan 29 20:22:39 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/driver.rb (BenchmarkDriver#measure): Show command line
	  when abnormal exiting occur.

Sat Jan 29 10:53:16 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* vm_insnhelper.c (vm_get_ev_const): no-scope reference to toplevel
	  private constant has been prohibited incorrectly.

	* test/ruby/test_module.rb (test_toplevel_private_constant): add a
	  test for above.

Sat Jan 29 08:43:23 2011  Ryan Davis  <ryand-ruby@zenspider.com>

	* lib/rubygems*: Import rubygems 1.5.0 (release candidate @ 09893d9)
	* test/rubygems: Ditto

Sat Jan 29 02:02:37 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* variable.c (rb_mod_const_of, sv_i): Module#constant should exclude
	  private constants.  see [ruby-core:32912].

	* test/ruby/test_module.rb (test_constants_with_private_constant): add
	  a test for above.

Sat Jan 29 01:36:41 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* variable.c (rb_const_set): const_set should preserve constant
	  visibility.  see [ruby-core:32912].

	* test/ruby/test_module.rb: add a test for above.

Sat Jan 29 01:24:57 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* compile.c (NODE_CLASS, NODE_MODULE), insns.def (defineclass): raise
	  an exception when "class Foo::Bar" is evaluated and Foo::Bar is
	  private.  To implement this, define_type of "defineclass" is added
	  so that the instruction can distinguish whether the class definition
	  is scoped (class Foo::Bar) or not (class Bar).

	* test/ruby/test_class.rb (test_redefine_private_class),
	  test/ruby/test_module.rb
	  (test_define_module_under_private_constant): add tests for above.

Sat Jan 29 01:19:17 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* constant.h, variable.c: to ensure compatibility, rb_const_get_* must
	  not raise an exception even when the constant is private.  Instead,
	  rb_public_const_get_* and rb_public_const_defined_* are introduced,
	  which raise an exception when the referring constant is private.
	  see [ruby-core:32912].

	* vm_insnhelper.c (vm_get_ev_const): use rb_public_const_get_* instead
	  of rb_const_get_* to follow the constant visibility when user code
	  refers a constant.

	* test/ruby/test_marshal.rb (test_marshal_private_class): add a test.
	  This test had failed because of incompatibility of rb_const_get.

Sat Jan 29 00:30:44 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* variable.c (set_const_visibility): fix typo.  a patch from Tomoyuki
	  Chikanaga in [ruby-core:32919].

Fri Jan 28 23:20:28 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/gdbm/test_gdbm.rb (TestGDBM#test_s_open_no_create,
	  TestGDBM2#test_writer_open_notexist): We only need to skip libgdbm
	  1.8.0, not all 1.8.x. 1.8.1 or later don't have GDBM_WRITER sickness.

Fri Jan 28 21:56:57 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/dbm/extconf.rb: Added new header places for Fedora13.

Fri Jan 28 21:49:30 2011  Tanaka Akira  <akr@fsij.org>

	* ext/zlib/zlib.c: parenthesize macro arguments.

Fri Jan 28 17:47:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/gdbm/test_gdbm.rb (TestGDBM2#test_writer_open_notexist):
	  gdbm 1.8.x changed GDBM::WRITER behavior. Thus our testcase need
	  to be changed too.

Fri Jan 28 17:33:28 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/gdbm/test_gdbm.rb (TestGDBM#test_s_open_no_create): skip
	  the test if gdbm version is 1.8.x.

Fri Jan 28 16:30:51 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_require.rb (TestRequire#test_require_too_long_filename):
	  Added -w option because too long path error don't output a message
	  by default since r30660. [Bug #4336] [ruby-dev:43134]

Fri Jan 28 16:19:38 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_require.rb (TestRequire#test_require_path_home_{1,2}):
	  Added -w option because too long path error don't output a message
	  by default since r30660. [Bug #4336] [ruby-dev:43134]

Fri Jan 28 16:04:54 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_require.rb (TestRequire#test_require_path_home_{1,2,3}):
	  split from test_require_path_home.

Fri Jan 28 13:04:38 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in (--with-valgrind): Fixed r29683. Now this option
	  is really default on.

Fri Jan 28 12:05:48 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: Add #include<sys/stat.h> when struct stat is
	  tested. Otherwise, incomplete type dereference error will occur.

Fri Jan 28 11:53:19 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: redundant variable names made strange conftest
	  error. Fixed it.

Fri Jan 28 11:47:00 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

